GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

recode ppos01 to ppos14 (1=1) (2=2) (missing=1).

FREQUENCIES
  VARIABLES=ppos01 ppos02 ppos03 ppos04 ppos05 ppos06 ppos07 ppos08 ppos09
  ppos10 ppos11 ppos12 ppos13 ppos14
  /ORDER  ANALYSIS .

** ppos08 has a different meaning between SACMEQ-I and SACMEQ-II so not included ***.
compute zptotp13=ppos01 +ppos02+ ppos03+ ppos04+ ppos05+ ppos06+ ppos07+  ppos09+
  ppos10+ ppos11+ ppos12 +ppos13+ ppos14-13.
formats zptotp13 (F2.0).
execute.

WEIGHT
  BY pweight2 .

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

DESCRIPTIVES
  VARIABLES=zptotp13
  /STATISTICS=MEAN .

DO IF (country = "BOT") .
RECODE
  zptotp13
  (Lowest thru 5.51=1)  (5.51 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "KEN") .
RECODE
  zptotp13
  (Lowest thru 4.33=1)  (4.33 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "LES") .
RECODE
  zptotp13
  (Lowest thru 4.19=1)  (4.19 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "MAL") .
RECODE
  zptotp13
  (Lowest thru 4.03=1)  (4.03 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "MAU") .
RECODE
  zptotp13
  (Lowest thru 9.70=1)  (9.70 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "MOZ") .
RECODE
  zptotp13
  (Lowest thru 3.98=1)  (3.98 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "NAM") .
RECODE
  zptotp13
  (Lowest thru 5.36=1)  (5.36 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "SEY") .
RECODE
  zptotp13
  (Lowest thru 8.87=1)  (8.87 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "SOU") .
RECODE
  zptotp13
  (Lowest thru 6.57=1)  (6.57 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "SWA") .
RECODE
  zptotp13
  (Lowest thru 5.66=1)  (5.66 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "TAN") .
RECODE
  zptotp13
  (Lowest thru 3.36=1)  (3.36 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "UGA") .
RECODE
  zptotp13
  (Lowest thru 3.44=1)  (3.44 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "ZAM") .
RECODE
  zptotp13
  (Lowest thru 3.97=1)  (3.97 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .
DO IF (country = "ZAN") .
RECODE
  zptotp13
  (Lowest thru 4.57=1)  (4.57 thru Highest=2)  INTO  zposlev .
END IF .
EXECUTE .

SPLIT FILE
  OFF.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ07.sav' /keep country stratum idpupil ppos01 to ppos14 zptotp13 zposlev.

***** Table 3.1(b) Possessions *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zptotp13 zposlev BY stratum
  /CELLS MEAN COUNT STDDEV  .

