GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls1= NMISS(pmother) 
  /miscls2= NMISS(pfather) 
  /numcls=N (idpupil)
  /opt11cls = PIN(pmother 1 1)
  /opt12cls = PIN(pmother 2 2)
  /opt13cls = PIN(pmother 3 3)
  /opt14cls = PIN(pmother 4 4)
  /opt15cls = PIN(pmother 5 5)
  /opt16cls = PIN(pmother 6 6)
  /opt17cls = PIN(pmother 7 7)
  /opt18cls = PIN(pmother 8 8)
  /opt19cls = PIN(pmother 9 9)
  /opt21cls = PIN(pfather 1 1)
  /opt22cls = PIN(pfather 2 2)
  /opt23cls = PIN(pfather 3 3)
  /opt24cls = PIN(pfather 4 4)
  /opt25cls = PIN(pfather 5 5)
  /opt26cls = PIN(pfather 6 6)
  /opt27cls = PIN(pfather 7 7)
  /opt28cls = PIN(pfather 8 8)
  /opt29cls = PIN(pfather 9 9)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch1= NMISS(pmother) 
  /missch2= NMISS(pfather) 
  /numsch=N (idpupil)
  /opt11sch = PIN(pmother 1 1)
  /opt12sch = PIN(pmother 2 2)
  /opt13sch = PIN(pmother 3 3)
  /opt14sch = PIN(pmother 4 4)
  /opt15sch = PIN(pmother 5 5)
  /opt16sch = PIN(pmother 6 6)
  /opt17sch = PIN(pmother 7 7)
  /opt18sch = PIN(pmother 8 8)
  /opt19sch = PIN(pmother 9 9)
  /opt21sch = PIN(pfather 1 1)
  /opt22sch = PIN(pfather 2 2)
  /opt23sch = PIN(pfather 3 3)
  /opt24sch = PIN(pfather 4 4)
  /opt25sch = PIN(pfather 5 5)
  /opt26sch = PIN(pfather 6 6)
  /opt27sch = PIN(pfather 7 7)
  /opt28sch = PIN(pfather 8 8)
  /opt29sch = PIN(pfather 9 9)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis1= NMISS(pmother) 
  /misdis2= NMISS(pfather) 
  /numdis=N (idpupil)
  /opt11dis = PIN(pmother 1 1)
  /opt12dis = PIN(pmother 2 2)
  /opt13dis = PIN(pmother 3 3)
  /opt14dis = PIN(pmother 4 4)
  /opt15dis = PIN(pmother 5 5)
  /opt16dis = PIN(pmother 6 6)
  /opt17dis = PIN(pmother 7 7)
  /opt18dis = PIN(pmother 8 8)
  /opt19dis = PIN(pmother 9 9)
  /opt21dis = PIN(pfather 1 1)
  /opt22dis = PIN(pfather 2 2)
  /opt23dis = PIN(pfather 3 3)
  /opt24dis = PIN(pfather 4 4)
  /opt25dis = PIN(pfather 5 5)
  /opt26dis = PIN(pfather 6 6)
  /opt27dis = PIN(pfather 7 7)
  /opt28dis = PIN(pfather 8 8)
  /opt29dis = PIN(pfather 9 9)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg1= NMISS(pmother) 
  /misreg2= NMISS(pfather) 
  /numreg=N (idpupil)
  /opt11reg = PIN(pmother 1 1)
  /opt12reg = PIN(pmother 2 2)
  /opt13reg = PIN(pmother 3 3)
  /opt14reg = PIN(pmother 4 4)
  /opt15reg = PIN(pmother 5 5)
  /opt16reg = PIN(pmother 6 6)
  /opt17reg = PIN(pmother 7 7)
  /opt18reg = PIN(pmother 8 8)
  /opt19reg = PIN(pmother 9 9)
  /opt21reg = PIN(pfather 1 1)
  /opt22reg = PIN(pfather 2 2)
  /opt23reg = PIN(pfather 3 3)
  /opt24reg = PIN(pfather 4 4)
  /opt25reg = PIN(pfather 5 5)
  /opt26reg = PIN(pfather 6 6)
  /opt27reg = PIN(pfather 7 7)
  /opt28reg = PIN(pfather 8 8)
  /opt29reg = PIN(pfather 9 9)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon1= NMISS(pmother)
  /miscon2= NMISS(pfather)
  /numcon=N (idpupil)
  /opt11con = PIN(pmother 1 1)
  /opt12con = PIN(pmother 2 2)
  /opt13con = PIN(pmother 3 3)
  /opt14con = PIN(pmother 4 4)
  /opt15con = PIN(pmother 5 5)
  /opt16con = PIN(pmother 6 6)
  /opt17con = PIN(pmother 7 7)
  /opt18con = PIN(pmother 8 8)
  /opt19con = PIN(pmother 9 9)
  /opt21con = PIN(pfather 1 1)
  /opt22con = PIN(pfather 2 2)
  /opt23con = PIN(pfather 3 3)
  /opt24con = PIN(pfather 4 4)
  /opt25con = PIN(pfather 5 5)
  /opt26con = PIN(pfather 6 6)
  /opt27con = PIN(pfather 7 7)
  /opt28con = PIN(pfather 8 8)
  /opt29con = PIN(pfather 9 9)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=pmother pfather
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misclsp1=  miscls1/ numcls.
compute misschp1= missch1/ numsch.
compute misdisp1= misdis1/numdis.
compute misregp1= misreg1/numreg.
compute misconp1= miscon1/numcon.

compute misclsp2=  miscls2/ numcls.
compute misschp2= missch2/ numsch.
compute misdisp2= misdis2/numdis.
compute misregp2= misreg2/numreg.
compute misconp2= miscon2/numcon.

EXECUTE .

***** Finding the Mode at each level *****.

if max(opt11cls, opt12cls, opt13cls, opt14cls, opt15cls, opt16cls, opt17cls, opt18cls, opt19cls)=opt19cls modecls1=9.
if max(opt11cls, opt12cls, opt13cls, opt14cls, opt15cls, opt16cls, opt17cls, opt18cls, opt19cls)=opt18cls modecls1=8.
if max(opt11cls, opt12cls, opt13cls, opt14cls, opt15cls, opt16cls, opt17cls, opt18cls, opt19cls)=opt17cls modecls1=7.
if max(opt11cls, opt12cls, opt13cls, opt14cls, opt15cls, opt16cls, opt17cls, opt18cls, opt19cls)=opt16cls modecls1=6.
if max(opt11cls, opt12cls, opt13cls, opt14cls, opt15cls, opt16cls, opt17cls, opt18cls, opt19cls)=opt15cls modecls1=5.
if max(opt11cls, opt12cls, opt13cls, opt14cls, opt15cls, opt16cls, opt17cls, opt18cls, opt19cls)=opt14cls modecls1=4.
if max(opt11cls, opt12cls, opt13cls, opt14cls, opt15cls, opt16cls, opt17cls, opt18cls, opt19cls)=opt13cls modecls1=3.
if max(opt11cls, opt12cls, opt13cls, opt14cls, opt15cls, opt16cls, opt17cls, opt18cls, opt19cls)=opt12cls modecls1=2.
if max(opt11cls, opt12cls, opt13cls, opt14cls, opt15cls, opt16cls, opt17cls, opt18cls, opt19cls)=opt11cls modecls1=1.

if max(opt21cls, opt22cls, opt23cls, opt24cls, opt25cls, opt26cls, opt27cls, opt28cls, opt29cls)=opt29cls modecls2=9.
if max(opt21cls, opt22cls, opt23cls, opt24cls, opt25cls, opt26cls, opt27cls, opt28cls, opt29cls)=opt28cls modecls2=8.
if max(opt21cls, opt22cls, opt23cls, opt24cls, opt25cls, opt26cls, opt27cls, opt28cls, opt29cls)=opt27cls modecls2=7.
if max(opt21cls, opt22cls, opt23cls, opt24cls, opt25cls, opt26cls, opt27cls, opt28cls, opt29cls)=opt26cls modecls2=6.
if max(opt21cls, opt22cls, opt23cls, opt24cls, opt25cls, opt26cls, opt27cls, opt28cls, opt29cls)=opt25cls modecls2=5.
if max(opt21cls, opt22cls, opt23cls, opt24cls, opt25cls, opt26cls, opt27cls, opt28cls, opt29cls)=opt24cls modecls2=4.
if max(opt21cls, opt22cls, opt23cls, opt24cls, opt25cls, opt26cls, opt27cls, opt28cls, opt29cls)=opt23cls modecls2=3.
if max(opt21cls, opt22cls, opt23cls, opt24cls, opt25cls, opt26cls, opt27cls, opt28cls, opt29cls)=opt22cls modecls2=2.
if max(opt21cls, opt22cls, opt23cls, opt24cls, opt25cls, opt26cls, opt27cls, opt28cls, opt29cls)=opt21cls modecls2=1.

if max(opt11sch, opt12sch, opt13sch, opt14sch, opt15sch, opt16sch, opt17sch, opt18sch, opt19sch)=opt19sch modesch1=9.
if max(opt11sch, opt12sch, opt13sch, opt14sch, opt15sch, opt16sch, opt17sch, opt18sch, opt19sch)=opt18sch modesch1=8.
if max(opt11sch, opt12sch, opt13sch, opt14sch, opt15sch, opt16sch, opt17sch, opt18sch, opt19sch)=opt17sch modesch1=7.
if max(opt11sch, opt12sch, opt13sch, opt14sch, opt15sch, opt16sch, opt17sch, opt18sch, opt19sch)=opt16sch modesch1=6.
if max(opt11sch, opt12sch, opt13sch, opt14sch, opt15sch, opt16sch, opt17sch, opt18sch, opt19sch)=opt15sch modesch1=5.
if max(opt11sch, opt12sch, opt13sch, opt14sch, opt15sch, opt16sch, opt17sch, opt18sch, opt19sch)=opt14sch modesch1=4.
if max(opt11sch, opt12sch, opt13sch, opt14sch, opt15sch, opt16sch, opt17sch, opt18sch, opt19sch)=opt13sch modesch1=3.
if max(opt11sch, opt12sch, opt13sch, opt14sch, opt15sch, opt16sch, opt17sch, opt18sch, opt19sch)=opt12sch modesch1=2.
if max(opt11sch, opt12sch, opt13sch, opt14sch, opt15sch, opt16sch, opt17sch, opt18sch, opt19sch)=opt11sch modesch1=1.

if max(opt21sch, opt22sch, opt23sch, opt24sch, opt25sch, opt26sch, opt27sch, opt28sch, opt29sch)=opt29sch modesch2=9.
if max(opt21sch, opt22sch, opt23sch, opt24sch, opt25sch, opt26sch, opt27sch, opt28sch, opt29sch)=opt28sch modesch2=8.
if max(opt21sch, opt22sch, opt23sch, opt24sch, opt25sch, opt26sch, opt27sch, opt28sch, opt29sch)=opt27sch modesch2=7.
if max(opt21sch, opt22sch, opt23sch, opt24sch, opt25sch, opt26sch, opt27sch, opt28sch, opt29sch)=opt26sch modesch2=6.
if max(opt21sch, opt22sch, opt23sch, opt24sch, opt25sch, opt26sch, opt27sch, opt28sch, opt29sch)=opt25sch modesch2=5.
if max(opt21sch, opt22sch, opt23sch, opt24sch, opt25sch, opt26sch, opt27sch, opt28sch, opt29sch)=opt24sch modesch2=4.
if max(opt21sch, opt22sch, opt23sch, opt24sch, opt25sch, opt26sch, opt27sch, opt28sch, opt29sch)=opt23sch modesch2=3.
if max(opt21sch, opt22sch, opt23sch, opt24sch, opt25sch, opt26sch, opt27sch, opt28sch, opt29sch)=opt22sch modesch2=2.
if max(opt21sch, opt22sch, opt23sch, opt24sch, opt25sch, opt26sch, opt27sch, opt28sch, opt29sch)=opt21sch modesch2=1.

if max(opt11dis, opt12dis, opt13dis, opt14dis, opt15dis, opt16dis, opt17dis, opt18dis, opt19dis)=opt19dis modedis1=9.
if max(opt11dis, opt12dis, opt13dis, opt14dis, opt15dis, opt16dis, opt17dis, opt18dis, opt19dis)=opt18dis modedis1=8.
if max(opt11dis, opt12dis, opt13dis, opt14dis, opt15dis, opt16dis, opt17dis, opt18dis, opt19dis)=opt17dis modedis1=7.
if max(opt11dis, opt12dis, opt13dis, opt14dis, opt15dis, opt16dis, opt17dis, opt18dis, opt19dis)=opt16dis modedis1=6.
if max(opt11dis, opt12dis, opt13dis, opt14dis, opt15dis, opt16dis, opt17dis, opt18dis, opt19dis)=opt15dis modedis1=5.
if max(opt11dis, opt12dis, opt13dis, opt14dis, opt15dis, opt16dis, opt17dis, opt18dis, opt19dis)=opt14dis modedis1=4.
if max(opt11dis, opt12dis, opt13dis, opt14dis, opt15dis, opt16dis, opt17dis, opt18dis, opt19dis)=opt13dis modedis1=3.
if max(opt11dis, opt12dis, opt13dis, opt14dis, opt15dis, opt16dis, opt17dis, opt18dis, opt19dis)=opt12dis modedis1=2.
if max(opt11dis, opt12dis, opt13dis, opt14dis, opt15dis, opt16dis, opt17dis, opt18dis, opt19dis)=opt11dis modedis1=1.

if max(opt21dis, opt22dis, opt23dis, opt24dis, opt25dis, opt26dis, opt27dis, opt28dis, opt29dis)=opt29dis modedis2=9.
if max(opt21dis, opt22dis, opt23dis, opt24dis, opt25dis, opt26dis, opt27dis, opt28dis, opt29dis)=opt28dis modedis2=8.
if max(opt21dis, opt22dis, opt23dis, opt24dis, opt25dis, opt26dis, opt27dis, opt28dis, opt29dis)=opt27dis modedis2=7.
if max(opt21dis, opt22dis, opt23dis, opt24dis, opt25dis, opt26dis, opt27dis, opt28dis, opt29dis)=opt26dis modedis2=6.
if max(opt21dis, opt22dis, opt23dis, opt24dis, opt25dis, opt26dis, opt27dis, opt28dis, opt29dis)=opt25dis modedis2=5.
if max(opt21dis, opt22dis, opt23dis, opt24dis, opt25dis, opt26dis, opt27dis, opt28dis, opt29dis)=opt24dis modedis2=4.
if max(opt21dis, opt22dis, opt23dis, opt24dis, opt25dis, opt26dis, opt27dis, opt28dis, opt29dis)=opt23dis modedis2=3.
if max(opt21dis, opt22dis, opt23dis, opt24dis, opt25dis, opt26dis, opt27dis, opt28dis, opt29dis)=opt22dis modedis2=2.
if max(opt21dis, opt22dis, opt23dis, opt24dis, opt25dis, opt26dis, opt27dis, opt28dis, opt29dis)=opt21dis modedis2=1.

if max(opt11reg, opt12reg, opt13reg, opt14reg, opt15reg, opt16reg, opt17reg, opt18reg, opt19reg)=opt19reg modereg1=9.
if max(opt11reg, opt12reg, opt13reg, opt14reg, opt15reg, opt16reg, opt17reg, opt18reg, opt19reg)=opt18reg modereg1=8.
if max(opt11reg, opt12reg, opt13reg, opt14reg, opt15reg, opt16reg, opt17reg, opt18reg, opt19reg)=opt17reg modereg1=7.
if max(opt11reg, opt12reg, opt13reg, opt14reg, opt15reg, opt16reg, opt17reg, opt18reg, opt19reg)=opt16reg modereg1=6.
if max(opt11reg, opt12reg, opt13reg, opt14reg, opt15reg, opt16reg, opt17reg, opt18reg, opt19reg)=opt15reg modereg1=5.
if max(opt11reg, opt12reg, opt13reg, opt14reg, opt15reg, opt16reg, opt17reg, opt18reg, opt19reg)=opt14reg modereg1=4.
if max(opt11reg, opt12reg, opt13reg, opt14reg, opt15reg, opt16reg, opt17reg, opt18reg, opt19reg)=opt13reg modereg1=3.
if max(opt11reg, opt12reg, opt13reg, opt14reg, opt15reg, opt16reg, opt17reg, opt18reg, opt19reg)=opt12reg modereg1=2.
if max(opt11reg, opt12reg, opt13reg, opt14reg, opt15reg, opt16reg, opt17reg, opt18reg, opt19reg)=opt11reg modereg1=1.

if max(opt21reg, opt22reg, opt23reg, opt24reg, opt25reg, opt26reg, opt27reg, opt28reg, opt29reg)=opt29reg modereg2=9.
if max(opt21reg, opt22reg, opt23reg, opt24reg, opt25reg, opt26reg, opt27reg, opt28reg, opt29reg)=opt28reg modereg2=8.
if max(opt21reg, opt22reg, opt23reg, opt24reg, opt25reg, opt26reg, opt27reg, opt28reg, opt29reg)=opt27reg modereg2=7.
if max(opt21reg, opt22reg, opt23reg, opt24reg, opt25reg, opt26reg, opt27reg, opt28reg, opt29reg)=opt26reg modereg2=6.
if max(opt21reg, opt22reg, opt23reg, opt24reg, opt25reg, opt26reg, opt27reg, opt28reg, opt29reg)=opt25reg modereg2=5.
if max(opt21reg, opt22reg, opt23reg, opt24reg, opt25reg, opt26reg, opt27reg, opt28reg, opt29reg)=opt24reg modereg2=4.
if max(opt21reg, opt22reg, opt23reg, opt24reg, opt25reg, opt26reg, opt27reg, opt28reg, opt29reg)=opt23reg modereg2=3.
if max(opt21reg, opt22reg, opt23reg, opt24reg, opt25reg, opt26reg, opt27reg, opt28reg, opt29reg)=opt22reg modereg2=2.
if max(opt21reg, opt22reg, opt23reg, opt24reg, opt25reg, opt26reg, opt27reg, opt28reg, opt29reg)=opt21reg modereg2=1.

if max(opt11con, opt12con, opt13con, opt14con, opt15con, opt16con, opt17con, opt18con, opt19con)=opt19con modecon1=9.
if max(opt11con, opt12con, opt13con, opt14con, opt15con, opt16con, opt17con, opt18con, opt19con)=opt18con modecon1=8.
if max(opt11con, opt12con, opt13con, opt14con, opt15con, opt16con, opt17con, opt18con, opt19con)=opt17con modecon1=7.
if max(opt11con, opt12con, opt13con, opt14con, opt15con, opt16con, opt17con, opt18con, opt19con)=opt16con modecon1=6.
if max(opt11con, opt12con, opt13con, opt14con, opt15con, opt16con, opt17con, opt18con, opt19con)=opt15con modecon1=5.
if max(opt11con, opt12con, opt13con, opt14con, opt15con, opt16con, opt17con, opt18con, opt19con)=opt14con modecon1=4.
if max(opt11con, opt12con, opt13con, opt14con, opt15con, opt16con, opt17con, opt18con, opt19con)=opt13con modecon1=3.
if max(opt11con, opt12con, opt13con, opt14con, opt15con, opt16con, opt17con, opt18con, opt19con)=opt12con modecon1=2.
if max(opt11con, opt12con, opt13con, opt14con, opt15con, opt16con, opt17con, opt18con, opt19con)=opt11con modecon1=1.

if max(opt21con, opt22con, opt23con, opt24con, opt25con, opt26con, opt27con, opt28con, opt29con)=opt29con modecon2=9.
if max(opt21con, opt22con, opt23con, opt24con, opt25con, opt26con, opt27con, opt28con, opt29con)=opt28con modecon2=8.
if max(opt21con, opt22con, opt23con, opt24con, opt25con, opt26con, opt27con, opt28con, opt29con)=opt27con modecon2=7.
if max(opt21con, opt22con, opt23con, opt24con, opt25con, opt26con, opt27con, opt28con, opt29con)=opt26con modecon2=6.
if max(opt21con, opt22con, opt23con, opt24con, opt25con, opt26con, opt27con, opt28con, opt29con)=opt25con modecon2=5.
if max(opt21con, opt22con, opt23con, opt24con, opt25con, opt26con, opt27con, opt28con, opt29con)=opt24con modecon2=4.
if max(opt21con, opt22con, opt23con, opt24con, opt25con, opt26con, opt27con, opt28con, opt29con)=opt23con modecon2=3.
if max(opt21con, opt22con, opt23con, opt24con, opt25con, opt26con, opt27con, opt28con, opt29con)=opt22con modecon2=2.
if max(opt21con, opt22con, opt23con, opt24con, opt25con, opt26con, opt27con, opt28con, opt29con)=opt21con modecon2=1.

***** Imputation of pmother at class level *****.

if (missing(pmother) and misclsp1~= 0 and misclsp1 LT .15) pmother =modecls1.

FREQUENCIES
  VARIABLES=pmother 
  /ORDER  ANALYSIS .

***** Imputation of pmother at school level *****.

if (missing(pmother) and misclsp1 GE .15 and misschp1~= 0 and misschp1 LT .15) pmother=modesch1.

FREQUENCIES
  VARIABLES=pmother
  /ORDER  ANALYSIS .

***** Imputation of pmother at district level *****.

if (missing(pmother) and misclsp1 GE .15 and misschp1 GE .15 and misdisp1~= 0 and misdisp1 LT .15) pmother=modedis1.

FREQUENCIES
  VARIABLES=pmother
  /ORDER  ANALYSIS .

***** Imputation of pmother at region level *****.

if (missing(pmother) and misclsp1 GE .15 and misschp1 GE .15 and misdisp1 GE .15 and misregp1~= 0 and misregp1 LT .15) pmother=modereg1.

FREQUENCIES
  VARIABLES=pmother
  /ORDER  ANALYSIS .

***** Imputation of pmother at country level *****.

if (missing(pmother) and misclsp1 GE .15 and misschp1 GE .15 and misdisp1 GE .15 and misregp1 GE .15 and misconp1~= 0 and misconp1 LT .15) pmother=modecon1.

FREQUENCIES
  VARIABLES=pmother
  /ORDER  ANALYSIS .

***** No imputation of pmother if more than 15% missing at country level *****.

if (missing(pmother) and misclsp1 GE .15 and misschp1 GE .15 and misdisp1 GE .15 and misregp1 GE .15 and misconp1 GE .15) pmother=pmother.

FREQUENCIES
  VARIABLES=pmother
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Imputation of pfather at class level *****.

if (missing(pfather) and misclsp2~= 0 and misclsp2 LT .15) pfather =modecls2.

FREQUENCIES
  VARIABLES=pfather 
  /ORDER  ANALYSIS .

***** Imputation of pfather at school level *****.

if (missing(pfather) and misclsp2 GE .15 and misschp2~= 0 and misschp2 LT .15) pfather=modesch2.

FREQUENCIES
  VARIABLES=pfather
  /ORDER  ANALYSIS .

***** Imputation of pfather at district level *****.

if (missing(pfather) and misclsp2 GE .15 and misschp2 GE .15 and misdisp2~= 0 and misdisp2 LT .15) pfather=modedis2.

FREQUENCIES
  VARIABLES=pfather
  /ORDER  ANALYSIS .

***** Imputation of pfather at region level *****.

if (missing(pfather) and misclsp2 GE .15 and misschp2 GE .15 and misdisp2 GE .15 and misregp2~= 0 and misregp2 LT .15) pfather=modereg2.

FREQUENCIES
  VARIABLES=pfather
  /ORDER  ANALYSIS .

***** Imputation of pfather at country level *****.

if (missing(pfather) and misclsp2 GE .15 and misschp2 GE .15 and misdisp2 GE .15 and misregp2 GE .15 and misconp2~= 0 and misconp2 LT .15) pfather=modecon2.

FREQUENCIES
  VARIABLES=pfather
  /ORDER  ANALYSIS .

***** No imputation of pfather if more than 15% missing at country level *****.

if (missing(pfather) and misclsp2 GE .15 and misschp2 GE .15 and misdisp2 GE .15 and misregp2 GE .15 and misconp2 GE .15) pfather=pfather.

FREQUENCIES
  VARIABLES=pfather
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** computing derived variables *****.

compute zpmother=pmother.
compute zpfather=pfather.

if (pmother=8 or pmother=9) and pfather=1 zpmother =1.
if (pmother=8 or pmother=9) and pfather=2 zpmother =2.
if (pmother=8 or pmother=9) and pfather=3 zpmother =3.
if (pmother=8 or pmother=9) and pfather=4 zpmother =4.
if (pmother=8 or pmother=9) and pfather=5 zpmother =5.
if (pmother=8 or pmother=9) and pfather=6 zpmother =6.
if (pmother=8 or pmother=9) and pfather=7 zpmother =7.

if (pfather=8 or pfather=9) and pmother =1 zpfather =1 .
if (pfather=8 or pfather=9) and pmother =2 zpfather =2 .
if (pfather=8 or pfather=9) and pmother =3 zpfather =3 .
if (pfather=8 or pfather=9) and pmother =4 zpfather =4 .
if (pfather=8 or pfather=9) and pmother =5 zpfather =5 .
if (pfather=8 or pfather=9) and pmother =6 zpfather =6 .
if (pfather=8 or pfather=9) and pmother =7 zpfather =7 .

recode ppos01 to ppos14 (1=1) (2=2) (missing=1).
compute zptotp13=ppos01 +ppos02+ ppos03+ ppos04+ ppos05+ ppos06+ ppos07+  ppos09+
  ppos10+ ppos11+ ppos12 +ppos13+ ppos14-13.
formats zptotp13 (F2.0).

if (pmother=8 or pmother=9) and zptotp13 =0 zpmother =1.
if (pmother=8 or pmother=9) and zptotp13 =1 zpmother =2.
if (pmother=8 or pmother=9) and zptotp13 =2 zpmother =2.
if (pmother=8 or pmother=9) and zptotp13 =3 zpmother =2.
if (pmother=8 or pmother=9) and zptotp13 =4 zpmother =2.
if (pmother=8 or pmother=9) and zptotp13 =5 zpmother =2.
if (pmother=8 or pmother=9) and zptotp13 =6 zpmother =3.
if (pmother=8 or pmother=9) and zptotp13 =7 zpmother =4.
if (pmother=8 or pmother=9) and zptotp13 =8 zpmother =4.
if (pmother=8 or pmother=9) and zptotp13 =9 zpmother =4.
if (pmother=8 or pmother=9) and zptotp13 =10 zpmother =4.
if (pmother=8 or pmother=9) and zptotp13 =11 zpmother =5.
if (pmother=8 or pmother=9) and zptotp13 =12 zpmother =5.
if (pmother=8 or pmother=9) and zptotp13 =13 zpmother =5.

if (pfather=8 or pfather=9) and zptotp13 =0 zpfather =1.
if (pfather=8 or pfather=9) and zptotp13 =1 zpfather =2.
if (pfather=8 or pfather=9) and zptotp13 =2 zpfather =2.
if (pfather=8 or pfather=9) and zptotp13 =3 zpfather =2.
if (pfather=8 or pfather=9) and zptotp13 =4 zpfather =2.
if (pfather=8 or pfather=9) and zptotp13 =5 zpfather =2.
if (pfather=8 or pfather=9) and zptotp13 =6 zpfather =4.
if (pfather=8 or pfather=9) and zptotp13 =7 zpfather =4.
if (pfather=8 or pfather=9) and zptotp13 =8 zpfather =4.
if (pfather=8 or pfather=9) and zptotp13 =9 zpfather =4.
if (pfather=8 or pfather=9) and zptotp13 =10 zpfather =4.
if (pfather=8 or pfather=9) and zptotp13 =11 zpfather =6.
if (pfather=8 or pfather=9) and zptotp13 =12 zpfather =6.
if (pfather=8 or pfather=9) and zptotp13 =13 zpfather =6.

RECODE  zpmother zpfather   (1 thru 6=Copy)  (7=6)  .

if (zpmother LE 6 and zpfather LE 6) zpfamoed=zpmother +zpfather .
if (zpmother LE 6 and zpfather LE 6) zpfmedmn=(zpmother +zpfather)/2 .

FREQUENCIES
  VARIABLES=zpmother zpfather zpfamoed
  /ORDER  ANALYSIS .

***** Saving imputated and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ11_12.sav' /keep country stratum idpupil pmother pfather zpmother zpfather zpfamoed zpfmedmn.

***** Table 3.1(b) Parents Education *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zpfamoed  zpfmedmn BY stratum
  /CELLS MEAN COUNT STDDEV  .
