GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

if missing(pabsent) pabsent=pfabsent.
Execute.

if missing(pabsent) pabsent=0.
compute pfabsent=pabsent.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Automatic Recoding *****.

recode pabwhy1 to pabwhy7 (1=1) (2=2) (missing=1).

DO IF pabsent=0 and pfabsent=0 .
  compute pabwhy1=2.
  compute pabwhy2=1.
  compute pabwhy3=1.
  compute pabwhy4=1.
  compute pabwhy5=1.
  compute pabwhy6=1.
  compute pabwhy7=1.
END IF.

DO IF pabsent~=0 and pfabsent~=0 .
  compute pabwhy1=1.
END IF.

DO IF pabsent~=0 and pfabsent~=0 and pabwhy2 =1 and pabwhy3 =1 and pabwhy4 =1 and pabwhy5 =1 and pabwhy6 =1 and pabwhy7 =1 .
  compute pabwhy7=2.
END IF.

FREQUENCIES
  VARIABLES=pabwhy1 to pabwhy7
  /ORDER  ANALYSIS .

***** Computing derived variables *****.

DO IF pabwhy1=1.
RECODE pabwhy2 pabwhy3 pabwhy6 pabwhy4
  (1=0) (2=1) INTO zpabwhy2 zpabwhy3  zpabwhy6  zpabwhy4.
END IF.

***** Saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ16_17.sav' /keep country stratum  idpupil pabsent pfabsent
 pabwhy1 to pabwhy7 zpabwhy2 zpabwhy3  zpabwhy6  zpabwhy4.

***** Table 3.2(b) days absent *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=pabsent  BY stratum
  /CELLS MEAN COUNT STDDEV  .

MEANS
  /TABLES=zpabwhy2 zpabwhy3  zpabwhy6  zpabwhy4 BY stratum
  /CELLS MEAN COUNT STDDEV  .

