***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(sqacadem)   
  /numdis=N (idpupil)
  /opt_1dis = PIN(sqacadem 1 1)
  /opt_2dis = PIN(sqacadem 2 2)
  /opt_3dis = PIN(sqacadem 3 3)
  /opt_4dis = PIN(sqacadem 4 4)
  /opt_5dis = PIN(sqacadem 5 5)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(sqacadem)   
  /numreg=N (idpupil)
  /opt_1reg = PIN(sqacadem 1 1)
  /opt_2reg = PIN(sqacadem 2 2)
  /opt_3reg = PIN(sqacadem 3 3)
  /opt_4reg = PIN(sqacadem 4 4)
  /opt_5reg = PIN(sqacadem 5 5)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(sqacadem)  
  /numcon=N (idpupil)
  /opt_1con = PIN(sqacadem 1 1)
  /opt_2con = PIN(sqacadem 2 2)
  /opt_3con = PIN(sqacadem 3 3)
  /opt_4con = PIN(sqacadem 4 4)
  /opt_5con = PIN(sqacadem 5 5)
.


***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FREQUENCIES
  VARIABLES=sqacadem
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.

EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_5dis modedis=5.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_5reg modereg=5.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_5con modecon=5.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_1con modecon=1.

***** Imputation at district level *****.

if (schmis~=169 and missing(sqacadem) and misdispc~= 0 and misdispc LT .15) sqacadem=modedis.

FREQUENCIES
  VARIABLES=sqacadem
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (schmis~=169 and missing(sqacadem) and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) sqacadem=modereg.

FREQUENCIES
  VARIABLES=sqacadem
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (schmis~=169 and missing(sqacadem) and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) sqacadem=modecon.

FREQUENCIES
  VARIABLES=sqacadem
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (schmis~=169 and missing(sqacadem) and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) sqacadem=sqacadem.

FREQUENCIES
  VARIABLES=sqacadem
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** saving imputed variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ03.sav' /keep country stratum idpupil sqacadem.

****Table 11.12 (b) School Head Academic Qualification*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .


CROSSTABS
  /TABLES=stratum  BY sqacadem
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .
