GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(stype)   
  /numdis=N (idpupil)
  /opt_1dis = PIN(stype 1 1)
  /opt_2dis = PIN(stype 2 2)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(stype)   
  /numreg=N (idpupil)
  /opt_1reg = PIN(stype 1 1)
  /opt_2reg = PIN(stype 2 2)
 .

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(stype)  
  /numcon=N (idpupil)
  /opt_1con = PIN(stype 1 1)
  /opt_2con = PIN(stype 2 2)
 .

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FREQUENCIES
  VARIABLES=stype
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1dis, opt_2dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con)=opt_2con modecon=2.
if max(opt_1con, opt_2con)=opt_1con modecon=1.

***** Imputation at district level *****.

if (schmis~=169 and missing(stype) and misdisp~= 0 and misdisp LT .15) stype=modedis.

FREQUENCIES
  VARIABLES=stype
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (schmis~=169 and missing(stype) and misdisp GE .15 and misregp~= 0 and misregp LT .15) stype=modereg.

FREQUENCIES
  VARIABLES=stype
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (schmis~=169 and missing(stype) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) stype=modecon.

FREQUENCIES
  VARIABLES=stype
  /ORDER  ANALYSIS .

***** No imputation of xqacad if more than 15% missing at country level *****.

if (schmis~=169 and missing(stype) and misdisp GE .15 and misregp GE .15 and misconp GE .15) stype=stype.

FREQUENCIES
  VARIABLES=stype
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.


***** saving imputed variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ11.sav' /keep country stratum idpupil stype .

