GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

FREQUENCIES
  VARIABLES=sestabl
  /ORDER=  ANALYSIS .

***** Special Correction *****.
if sestabl=1197 sestabl=1997.
***** Special Correction *****.

DESCRIPTIVES
  VARIABLES=sestabl
  /STATISTICS=MEAN STDDEV MIN MAX .

***** If missing, Imputation by country mean *****.

if country="BOT" and schmis~=169 and missing(sestabl) sestabl=1970.
if country="KEN" and schmis~=169 and missing(sestabl) sestabl=1966.
if country="LES" and schmis~=169 and missing(sestabl) sestabl=1937.
if country="MAL" and schmis~=169 and missing(sestabl) sestabl=1960.
if country="MAU" and schmis~=169 and missing(sestabl) sestabl=1950.
if country="MOZ" and schmis~=169 and missing(sestabl) sestabl=1978.
if country="NAM" and schmis~=169 and missing(sestabl) sestabl=1966.
if country="SEY" and schmis~=169 and missing(sestabl) sestabl=1972.
if country="SOU" and schmis~=169 and missing(sestabl) sestabl=1963.
if country="SWA" and schmis~=169 and missing(sestabl) sestabl=1956.
if country="TAN" and schmis~=169 and missing(sestabl) sestabl=1966.
if country="UGA" and schmis~=169 and missing(sestabl) sestabl=1961.
if country="ZAM" and schmis~=169 and missing(sestabl) sestabl=1962.
if country="ZAN" and schmis~=169 and missing(sestabl) sestabl=1965.

***** Creating and Saving imputed variable *****.

if country="BOT" testyear=2000.
if country="KEN" testyear=2000.
if country="LES" testyear=2000.
if country="MAL" testyear=2002.
if country="MAU" testyear=2001.
if country="MOZ" testyear=2000.
if country="NAM" testyear=2000.
if country="SEY" testyear=2000.
if country="SOU" testyear=2000.
if country="SWA" testyear=2000.
if country="TAN" testyear=2000.
if country="UGA" testyear=2000.
if country="ZAM" testyear=2000.
if country="ZAN" testyear=2000.
compute zsestabl=testyear-sestabl.

FREQUENCIES
  VARIABLES=zsestabl
  /ORDER=  ANALYSIS .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ12.sav' /keep country stratum idpupil sestabl zsestabl.

