GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

******change missing to 0 for spupboy spupgirl ssess1p ssess2p ssess3p ssess4p ssess5p ssess6p sfenrol   *****.

RECODE  spupboy spupgirl ssess1p ssess2p ssess3p ssess4p ssess5p ssess6p sfenrol   (MISSING=0)  .

***** calculating totals in both ways *****.

compute sum1=spupboy +spupgirl .
compute sum2=ssess1p+ ssess2p+ ssess3p+ ssess4p+ ssess5p+ ssess6p .
formats sum1 sum2 (f6.0).

***** IMPUTATION Step 1: If there is no data at all use the mos x 6 *****.

DO IF sum1=0 and sum2=0 and sfenrol=0.
  compute spupboy =mos*3.
  compute spupgirl =mos*3.
  compute ssess1p=mos*6.
  compute sfenrol=mos*6.
  compute sum1=spupboy +spupgirl .
  compute sum2=ssess1p+ ssess2p+ ssess3p+ ssess4p+ ssess5p+ ssess6p .
END IF.

***** IMPUTATION Step 2: If only one variable is valid *****.

DO IF sum1=0 and sum2=0 and sfenrol~=0.
  compute spupboy =RND(sfenrol/2).
  compute spupgirl =sfenrol-spupboy.
  compute ssess1p=sfenrol.
  compute sum1=spupboy +spupgirl .
  compute sum2=ssess1p+ ssess2p+ ssess3p+ ssess4p+ ssess5p+ ssess6p .
END IF.

DO IF sum2=0 and sfenrol=0 and sum1~=0.
  compute ssess1p= sum1.
  compute sfenrol= sum1.
  compute sum2=ssess1p+ ssess2p+ ssess3p+ ssess4p+ ssess5p+ ssess6p .
END IF.

DO IF sfenrol=0 and sum1=0 and sum2~=0.
  compute spupboy =RND(sum2/2).
  compute spupgirl =sum2-spupboy.
  compute sfenrol= sum2.
  compute sum1=spupboy +spupgirl .
END IF.

***** IMPUTATION Step 3: If two variables are valid and equal *****.

DO IF sum1=0 and sum2=sfenrol.
  compute spupboy =RND(sfenrol/2).
  compute spupgirl =sfenrol-spupboy.
  compute sum1=spupboy +spupgirl .
END IF.

DO IF sum2=0 and sfenrol=sum1.
  compute ssess1p =sum1.
  compute sum2=ssess1p+ ssess2p+ ssess3p+ ssess4p+ ssess5p+ ssess6p .
END IF.

DO IF sfenrol=0 and sum1=sum2.
  compute sfenrol =sum2.
END IF.

***** Automatic Cleaning Step 1: Democracy *****.

 DO IF sum1=sum2 and sum2~=sfenrol .
  compute    sfenrol=sum1.
END IF.

 DO IF sum2=sfenrol and sfenrol~=sum1 .
  compute    sum1=sum2.
END IF.

 DO IF sfenrol=sum1 and sum1~=sum2 .
  compute   sum2=sfenrol.
END IF.

***** Automatic Cleaning Step 2: Using the two values with less differences *****.

compute diff1=abs(sum1-sum2).
compute diff2=abs(sum2-sfenrol).
compute diff3=abs(sfenrol-sum1).

DO IF min(diff1,diff2,diff3)=diff1 and sum1~=0 and sum2~=0.
  compute mid12=RND(mean(sum1,sum2)).
  compute sum1=mid12.
  compute sum2=mid12.
  compute sfenrol=mid12.
END IF.

DO IF min(diff1,diff2,diff3)=diff2 and sum2~=0 and sfenrol~=0.
  compute mid23=RND(mean(sum2,sfenrol)).
  compute sum1=mid23.
  compute sum2=mid23.
  compute sfenrol=mid23.
END IF.

DO IF min(diff1,diff2,diff3)=diff3 and sfenrol~=0 and sum1~=0.
  compute mid31=RND(mean(sfenrol,sum1)).
  compute sum1=mid31.
  compute sum2=mid31.
  compute sfenrol=mid31.
END IF.

***** Automatic Cleaning for the sub information:  If shift1 is already the same as sum2, then other shifts are 0 *****.

DO IF ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p ~=sum2 and ssess1p=sum2.
  compute ssess2p=0.
  compute ssess3p=0.
  compute ssess4p=0.
  compute ssess5p=0.
  compute ssess6p=0.
END IF.

***** Automatic Cleaning for the sub information: If sum1~=0 apply ratios*****.

DO IF spupboy+ spupgirl ~=sum1 and spupboy+ spupgirl ~=0.
  compute sub11=trunc(sum1*spupboy/(spupboy+ spupgirl )).
  compute sub12=sum1-sub11.
  compute spupboy=sub11.
  compute spupgirl =sub12.
END IF.

DO IF ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p ~=sum2 and ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p ~=0.
  compute sub26=trunc(sum2*ssess6p/(ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p )).
  compute sub25=trunc(sum2*ssess5p/(ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p )).
  compute sub24=trunc(sum2*ssess4p/(ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p )).
  compute sub23=trunc(sum2*ssess3p/(ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p )).
  compute sub22=trunc(sum2*ssess2p/(ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p )).
  compute sub21=sum2-sub26-sub25-sub24-sub23-sub22.
  compute ssess1p=sub21.
  compute ssess2p=sub22.
  compute ssess3p=sub23.
  compute ssess4p=sub24.
  compute ssess5p=sub25.
  compute ssess6p=sub26.
END IF.

***** Automatic Cleaning for the sub information: If sum=0 estimation *****.

DO IF spupboy+ spupgirl ~=sum1 and spupboy+ spupgirl =0.
  compute spupboy =RND(sum1/2).
  compute spupgirl =sum1-spupboy.
END IF.

DO IF ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p ~=sum2 and ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p =0.
  compute ssess1p =sum2.
END IF.

***** Cross checking ssess1c  ssess2c ssess3c ssess4c ssess5c ssess6c sclass  sclass6 sfclag6 *****.

RECODE  ssess1c  ssess2c ssess3c ssess4c ssess5c ssess6c sclass  sclass6 sfclag6 (MISSING=0)  .

if sclass6=0 and sfclag6~=0 sclass6=sfclag6.
if sfclag6=0 and sclass6~=0 sfclag6=sclass6.

DO IF sclass6~=sfclag6.
  compute diff1=abs(enr6/40-sclass6).
  compute diff2=abs(enr6/40-sfclag6).
  if min(diff1,diff2)=diff1 sfclag6=sclass6.
  if min(diff1,diff2)=diff2 sclass6=sfclag6.
END IF.

if ssess2p=0 ssess2c=0.
if ssess3p=0 ssess3c=0.
if ssess4p=0 ssess4c=0.
if ssess5p=0 ssess5c=0.
if ssess6p=0 ssess6c=0.

if ssess1p~=0 and ssess1c=0 ssess1c=trunc(ssess1p/40)+1.
if ssess2p~=0 and ssess2c=0 ssess2c=trunc(ssess2p/40)+1.
if ssess3p~=0 and ssess3c=0 ssess3c=trunc(ssess3p/40)+1.
if ssess4p~=0 and ssess4c=0 ssess4c=trunc(ssess4p/40)+1.
if ssess5p~=0 and ssess5c=0 ssess5c=trunc(ssess5p/40)+1.
if ssess6p~=0 and ssess6c=0 ssess6c=trunc(ssess6p/40)+1.

compute sumc=ssess1c+ssess2c+ssess3c+ssess4c+ssess5c+ssess6c.

if sclass=0 and sumc~=0 sclass=sumc.
if sumc=0 and sclass~=0 sumc=sclass.

DO IF sclass~=sumc.
  compute diff1=abs(sclass6*6-sclass).
  compute diff2=abs(sclass6*6-sumc).
  if min(diff1,diff2)=diff1 sumc=sclass.
  if min(diff1,diff2)=diff2 sclass=sumc.
END IF.

DO IF ssess1c+ssess2c+ssess3c+ssess4c+ssess5c+ssess6c~=sumc.
  compute ssess6c=RND(sumc*(ssess6p/(ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p ) ) ).
  compute ssess5c=RND(sumc*(ssess5p/(ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p ) ) ).
  compute ssess4c=RND(sumc*(ssess4p/(ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p ) ) ).
  compute ssess3c=RND(sumc*(ssess3p/(ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p ) ) ).
  compute ssess2c=RND(sumc*(ssess2p/(ssess1p +ssess2p+ ssess3p  +ssess4p +ssess5p +ssess6p ) ) ).
  compute ssess1c=sumc-(ssess2c+ssess3c+ssess4c+ssess5c+ssess6c).
END IF.

***** Calculating derived variables *****.

if max(ssess1p, ssess2p, ssess3p, ssess4p, ssess5p, ssess6p)=ssess1p bigshift=ssess1p.
if max(ssess1p, ssess2p, ssess3p, ssess4p, ssess5p, ssess6p)=ssess2p bigshift=ssess2p.
if max(ssess1p, ssess2p, ssess3p, ssess4p, ssess5p, ssess6p)=ssess3p bigshift=ssess3p.
if max(ssess1p, ssess2p, ssess3p, ssess4p, ssess5p, ssess6p)=ssess4p bigshift=ssess4p.
if max(ssess1p, ssess2p, ssess3p, ssess4p, ssess5p, ssess6p)=ssess5p bigshift=ssess5p.
if max(ssess1p, ssess2p, ssess3p, ssess4p, ssess5p, ssess6p)=ssess6p bigshift=ssess6p.

************** creating shift variables *****

compute xshift1=0.
if ssess1p~=0 zshift1=1.
compute xshift2=0.
if ssess2p~=0 zshift2=1.
compute xshift3=0.
if ssess3p~=0 zshift3=1.
compute xshift4=0.
if ssess4p~=0 zshift4=1.
compute xshift5=0.
if ssess5p~=0 zshift5=1.
compute xshift6=0.
if ssess6p~=0 zshift6=1.
compute zssessnu=zshift1+zshift2+zshift3+zshift4+zshift5+zshift6.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=pfshift  BY sfsess
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

FREQUENCIES
  VARIABLES=zssessnu 
  /ORDER=  ANALYSIS .

DO IF zssessnu=1 .
  compute pfshift="M".
  compute sfsess="M".
END IF.

CROSSTABS
  /TABLES=pfshift  BY sfsess
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

if pfshift~="A" and pfshift~= "M"  pfshift="".
if sfsess~="A" and sfsess~= "M"  sfsess="".

CROSSTABS
  /TABLES=pfshift  BY sfsess
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

if  sfsess="A" pfshift="A".
if  sfsess="M" pfshift="M".

CROSSTABS
  /TABLES=pfshift  BY sfsess
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

if  pfshift="A" and sfsess="" sfsess="A".
if  pfshift="M" and sfsess="" sfsess="M".

CROSSTABS
  /TABLES=pfshift  BY sfsess
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

DO IF sfsess="" and pfshift="".
  compute pfshift="M".
  compute sfsess="M".
END IF.

CROSSTABS
  /TABLES=pfshift  BY sfsess
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

*****Imputing G6 Boy & Girl enrolment*****.

IF (MISSING(spupboy6)) spupboy6 = RND(enr6 * (spupboy/ (spupboy + spupgirl))) .
IF (MISSING(spupgir6)) spupgir6 = enr6-spupboy6.
EXECUTE .

*****Calculating derived variables for enrolment*****.

COMPUTE zspupgir = spupgirl / ( spupboy+ spupgirl) .
COMPUTE zspupgi6 = spupgir6 / (spupboy6 + spupgir6) .
EXECUTE .

*****.

sort cases by country (a) stratum (a) idpupil (a).

SAVE OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ18_19_20_21_22_sfenrol_bigshift.sav' keep country stratum idpupil 
spupboy spupgirl spupboy6 spupgir6 ssess1p ssess2p ssess3p ssess4p ssess5p ssess6p sfenrol 
ssess1c  ssess2c ssess3c ssess4c ssess5c ssess6c sclass  sclass6 sfclag6 
  pfshift sfsess bigshift zssessnu zspupgir zspupgi6.

***** means of bigshift *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=bigshift  BY stratum
  /CELLS MEAN COUNT STDDEV  .

***** Frequencies of # of shifts *****.

FREQUENCIES
  VARIABLES=zssessnu pfshift
  /ORDER=  ANALYSIS .

