GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(SACTMOST)   
  /numdis=N (idpupil)
  /opt_01di = PIN(SACTMOST 1 1)
  /opt_02di = PIN(SACTMOST 2 2)
  /opt_03di = PIN(SACTMOST 3 3)
  /opt_04di = PIN(SACTMOST 4 4)
  /opt_05di = PIN(SACTMOST 5 5)
  /opt_06di = PIN(SACTMOST 6 6)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(SACTMOST)   
  /numreg=N (idpupil)
  /opt_01re = PIN(SACTMOST 1 1)
  /opt_02re = PIN(SACTMOST 2 2)
  /opt_03re = PIN(SACTMOST 3 3)
  /opt_04re = PIN(SACTMOST 4 4)
  /opt_05re = PIN(SACTMOST 5 5)
  /opt_06re = PIN(SACTMOST 6 6)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(SACTMOST)  
  /numcon=N (idpupil)
  /opt_01co = PIN(SACTMOST 1 1)
  /opt_02co = PIN(SACTMOST 2 2)
  /opt_03co = PIN(SACTMOST 3 3)
  /opt_04co = PIN(SACTMOST 4 4)
  /opt_05co = PIN(SACTMOST 5 5)
  /opt_06co = PIN(SACTMOST 6 6)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FREQUENCIES
  VARIABLES=SACTMOST
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_01di, opt_02di, opt_03di, opt_04di, opt_05di, opt_06di)=opt_06di modedis=6.
if max(opt_01di, opt_02di, opt_03di, opt_04di, opt_05di, opt_06di)=opt_05di modedis=5.
if max(opt_01di, opt_02di, opt_03di, opt_04di, opt_05di, opt_06di)=opt_04di modedis=4.
if max(opt_01di, opt_02di, opt_03di, opt_04di, opt_05di, opt_06di)=opt_03di modedis=3.
if max(opt_01di, opt_02di, opt_03di, opt_04di, opt_05di, opt_06di)=opt_02di modedis=2.
if max(opt_01di, opt_02di, opt_03di, opt_04di, opt_05di, opt_06di)=opt_01di modedis=1.

if max(opt_01re, opt_02re, opt_03re, opt_04re, opt_05re, opt_06re)=opt_06re modereg=6.
if max(opt_01re, opt_02re, opt_03re, opt_04re, opt_05re, opt_06re)=opt_05re modereg=5.
if max(opt_01re, opt_02re, opt_03re, opt_04re, opt_05re, opt_06re)=opt_04re modereg=4.
if max(opt_01re, opt_02re, opt_03re, opt_04re, opt_05re, opt_06re)=opt_03re modereg=3.
if max(opt_01re, opt_02re, opt_03re, opt_04re, opt_05re, opt_06re)=opt_02re modereg=2.
if max(opt_01re, opt_02re, opt_03re, opt_04re, opt_05re, opt_06re)=opt_01re modereg=1.

if max(opt_01co, opt_02co, opt_03co, opt_04co, opt_05co, opt_06co)=opt_06co modecon=6.
if max(opt_01co, opt_02co, opt_03co, opt_04co, opt_05co, opt_06co)=opt_05co modecon=5.
if max(opt_01co, opt_02co, opt_03co, opt_04co, opt_05co, opt_06co)=opt_04co modecon=4.
if max(opt_01co, opt_02co, opt_03co, opt_04co, opt_05co, opt_06co)=opt_03co modecon=3.
if max(opt_01co, opt_02co, opt_03co, opt_04co, opt_05co, opt_06co)=opt_02co modecon=2.
if max(opt_01co, opt_02co, opt_03co, opt_04co, opt_05co, opt_06co)=opt_01co modecon=1.

***** Imputation at district level *****.

if (schmis~=169 and missing(SACTMOST) and misdispc~= 0 and misdispc LT .15) SACTMOST=modedis.

FREQUENCIES
  VARIABLES=SACTMOST
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (schmis~=169 and missing(SACTMOST) and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) SACTMOST=modereg.

FREQUENCIES
  VARIABLES=SACTMOST
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (schmis~=169 and missing(SACTMOST) and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) SACTMOST=modecon.

FREQUENCIES
  VARIABLES=SACTMOST
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (schmis~=169 and missing(SACTMOST) and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) SACTMOST=SACTMOST.
FREQUENCIES
  VARIABLES=SACTMOST
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ29.sav' /keep country stratum idpupil SACTMOST.

*********.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=SACTMOST BY stratum
  /CELLS MEAN COUNT STDDEV  .

