GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /meandis1= MEAN(stoiboya)
  /meandis2= MEAN(stoiboyb)
  /meandis3= MEAN(stoiboyc)
  /meandis4= MEAN(stoigira)
  /meandis5= MEAN(stoigirb)
  /meandis6= MEAN(stoigirc)
  /meandis7= MEAN(stoistaa)
  /meandis8= MEAN(stoistab )
  /meandis9= MEAN(stoistac)
  /misdis1= NMISS(stoiboya)
  /misdis2= NMISS(stoiboyb)
  /misdis3= NMISS(stoiboyc)
  /misdis4= NMISS(stoigira)
  /misdis5= NMISS(stoigirb)
  /misdis6= NMISS(stoigirc)
  /misdis7= NMISS(stoistaa)
  /misdis8= NMISS(stoistab)
  /misdis9= NMISS(stoistac)
  /numdis=N (idpupil).

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /meanreg1= MEAN(stoiboya)
  /meanreg2= MEAN(stoiboyb)
  /meanreg3= MEAN(stoiboyc)
  /meanreg4= MEAN(stoigira)
  /meanreg5= MEAN(stoigirb)
  /meanreg6= MEAN(stoigirc)
  /meanreg7= MEAN(stoistaa)
  /meanreg8= MEAN(stoistab )
  /meanreg9= MEAN(stoistac)
  /misreg1= NMISS(stoiboya)
  /misreg2= NMISS(stoiboyb)
  /misreg3= NMISS(stoiboyc)
  /misreg4= NMISS(stoigira)
  /misreg5= NMISS(stoigirb)
  /misreg6= NMISS(stoigirc)
  /misreg7= NMISS(stoistaa)
  /misreg8= NMISS(stoistab)
  /misreg9= NMISS(stoistac)
  /numreg=N (idpupil).

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /meancon1= MEAN(stoiboya)
  /meancon2= MEAN(stoiboyb)
  /meancon3= MEAN(stoiboyc)
  /meancon4= MEAN(stoigira)
  /meancon5= MEAN(stoigirb)
  /meancon6= MEAN(stoigirc)
  /meancon7= MEAN(stoistaa)
  /meancon8= MEAN(stoistab )
  /meancon9= MEAN(stoistac)
  /miscon1= NMISS(stoiboya)
  /miscon2= NMISS(stoiboyb)
  /miscon3= NMISS(stoiboyc)
  /miscon4= NMISS(stoigira)
  /miscon5= NMISS(stoigirb)
  /miscon6= NMISS(stoigirc)
  /miscon7= NMISS(stoistaa)
  /miscon8= NMISS(stoistab)
  /miscon9= NMISS(stoistac)
  /numcon=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FREQUENCIES
  VARIABLES=stoiboya stoiboyb stoiboyc  stoigira stoigirb stoigirc   stoistaa stoistab stoistac 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdisp1= misdis1/numdis.
compute misdisp2= misdis2/numdis.
compute misdisp3= misdis3/numdis.
compute misdisp4= misdis4/numdis.
compute misdisp5= misdis5/numdis.
compute misdisp6= misdis6/numdis.
compute misdisp7= misdis7/numdis.
compute misdisp8= misdis8/numdis.
compute misdisp9= misdis9/numdis.
compute misregp1= misreg1/numreg.
compute misregp2= misreg2/numreg.
compute misregp3= misreg3/numreg.
compute misregp4= misreg4/numreg.
compute misregp5= misreg5/numreg.
compute misregp6= misreg6/numreg.
compute misregp7= misreg7/numreg.
compute misregp8= misreg8/numreg.
compute misregp9= misreg9/numreg.
compute misconp1= miscon1/numcon.
compute misconp2= miscon2/numcon.
compute misconp3= miscon3/numcon.
compute misconp4= miscon4/numcon.
compute misconp5= miscon5/numcon.
compute misconp6= miscon6/numcon.
compute misconp7= miscon7/numcon.
compute misconp8= miscon8/numcon.
compute misconp9= miscon9/numcon.
EXECUTE .

***** Imputation of stoiboya stoiboyb stoiboyc  stoigira stoigirb stoigirc   stoistaa stoistab stoistac *****.

if (schmis~=169 and missing(stoiboya) and misdisp1~= 0 and misdisp1 LT .15) stoiboya=trunc(meandis1)+1.
if (schmis~=169 and missing(stoiboyb) and misdisp2~= 0 and misdisp2 LT .15) stoiboyb=trunc(meandis2)+1.
if (schmis~=169 and missing(stoiboyc) and misdisp3~= 0 and misdisp3 LT .15) stoiboyc=trunc(meandis3)+1.
if (schmis~=169 and missing(stoigira) and misdisp4~= 0 and misdisp4 LT .15) stoigira=trunc(meandis4)+1.
if (schmis~=169 and missing(stoigirb) and misdisp5~= 0 and misdisp5 LT .15) stoigirb=trunc(meandis5)+1.
if (schmis~=169 and missing(stoigirc) and misdisp6~= 0 and misdisp6 LT .15) stoigirc=trunc(meandis6)+1.
if (schmis~=169 and missing(stoistaa) and misdisp7~= 0 and misdisp7 LT .15) stoistaa=trunc(meandis7)+1.
if (schmis~=169 and missing(stoistab) and misdisp8~= 0 and misdisp8 LT .15) stoistab=trunc(meandis8)+1.
if (schmis~=169 and missing(stoistac) and misdisp9~= 0 and misdisp9 LT .15) stoistac=trunc(meandis9)+1.
FREQUENCIES
  VARIABLES=stoiboya stoiboyb stoiboyc  stoigira stoigirb stoigirc   stoistaa stoistab stoistac  
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(stoiboya) and misdisp1 GE .15 and misregp1~= 0 and misregp1 LT .15) stoiboya=trunc(meanreg1)+1.
if (schmis~=169 and missing(stoiboyb) and misdisp2 GE .15 and misregp2~= 0 and misregp2 LT .15) stoiboyb=trunc(meanreg2)+1.
if (schmis~=169 and missing(stoiboyc) and misdisp3 GE .15 and misregp3~= 0 and misregp3 LT .15) stoiboyc=trunc(meanreg3)+1.
if (schmis~=169 and missing(stoigira) and misdisp4 GE .15 and misregp4~= 0 and misregp4 LT .15) stoigira=trunc(meanreg4)+1.
if (schmis~=169 and missing(stoigirb) and misdisp5 GE .15 and misregp5~= 0 and misregp5 LT .15) stoigirb=trunc(meanreg5)+1.
if (schmis~=169 and missing(stoigirc) and misdisp6 GE .15 and misregp6~= 0 and misregp6 LT .15) stoigirc=trunc(meanreg6)+1.
if (schmis~=169 and missing(stoistaa) and misdisp7 GE .15 and misregp7~= 0 and misregp7 LT .15) stoistaa=trunc(meanreg7)+1.
if (schmis~=169 and missing(stoistab) and misdisp8 GE .15 and misregp8~= 0 and misregp8 LT .15) stoistab=trunc(meanreg8)+1.
if (schmis~=169 and missing(stoistac) and misdisp9 GE .15 and misregp9~= 0 and misregp9 LT .15) stoistac=trunc(meanreg9)+1.
FREQUENCIES
  VARIABLES=stoiboya stoiboyb stoiboyc  stoigira stoigirb stoigirc   stoistaa stoistab stoistac  
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(stoiboya) and misdisp1 GE .15 and misregp1 GE .15 and misconp1~= 0 and misconp1 LT .15) stoiboya=trunc(meancon1)+1.
if (schmis~=169 and missing(stoiboyb) and misdisp2 GE .15 and misregp2 GE .15 and misconp2~= 0 and misconp2 LT .15) stoiboyb=trunc(meancon2)+1.
if (schmis~=169 and missing(stoiboyc) and misdisp3 GE .15 and misregp3 GE .15 and misconp3~= 0 and misconp3 LT .15) stoiboyc=trunc(meancon3)+1.
if (schmis~=169 and missing(stoigira) and misdisp4 GE .15 and misregp4 GE .15 and misconp4~= 0 and misconp4 LT .15) stoigira=trunc(meancon4)+1.
if (schmis~=169 and missing(stoigirb) and misdisp5 GE .15 and misregp5 GE .15 and misconp5~= 0 and misconp5 LT .15) stoigirb=trunc(meancon5)+1.
if (schmis~=169 and missing(stoigirc) and misdisp6 GE .15 and misregp6 GE .15 and misconp6~= 0 and misconp6 LT .15) stoigirc=trunc(meancon6)+1.
if (schmis~=169 and missing(stoistaa) and misdisp7 GE .15 and misregp7 GE .15 and misconp7~= 0 and misconp7 LT .15) stoistaa=trunc(meancon7)+1.
if (schmis~=169 and missing(stoistab) and misdisp8 GE .15 and misregp8 GE .15 and misconp8~= 0 and misconp8 LT .15) stoistab=trunc(meancon8)+1.
if (schmis~=169 and missing(stoistac) and misdisp9 GE .15 and misregp9 GE .15 and misconp9~= 0 and misconp9 LT .15) stoistac=trunc(meancon9)+1.
FREQUENCIES
  VARIABLES=stoiboya stoiboyb stoiboyc  stoigira stoigirb stoigirc   stoistaa stoistab stoistac   
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(stoiboya) and misdisp1 GE .15 and misregp1 GE .15 and misconp1 GE .15) stoiboya=0.
if (schmis~=169 and missing(stoiboyb) and misdisp2 GE .15 and misregp2 GE .15 and misconp2 GE .15) stoiboyb=0.
if (schmis~=169 and missing(stoiboyc) and misdisp3 GE .15 and misregp3 GE .15 and misconp3 GE .15) stoiboyc=0.
if (schmis~=169 and missing(stoigira) and misdisp4 GE .15 and misregp4 GE .15 and misconp4 GE .15) stoigira=0.
if (schmis~=169 and missing(stoigirb) and misdisp5 GE .15 and misregp5 GE .15 and misconp5 GE .15) stoigirb=0.
if (schmis~=169 and missing(stoigirc) and misdisp6 GE .15 and misregp6 GE .15 and misconp6 GE .15) stoigirc=0.
if (schmis~=169 and missing(stoistaa) and misdisp7 GE .15 and misregp7 GE .15 and misconp7 GE .15) stoistaa=0.
if (schmis~=169 and missing(stoistab) and misdisp8 GE .15 and misregp8 GE .15 and misconp8 GE .15) stoistab=0.
if (schmis~=169 and missing(stoistac) and misdisp9 GE .15 and misregp9 GE .15 and misconp9 GE .15) stoistac=0.
FREQUENCIES
  VARIABLES=stoiboya stoiboyb stoiboyc  stoigira stoigirb stoigirc   stoistaa stoistab stoistac    
  /ORDER  ANALYSIS .

if (stoiboya>=1 or stoiboyb>=1 or stoiboyc>=1) stoiboyd=1.
if (stoiboya=0 and stoiboyb=0 and stoiboyc=0) stoiboyd=2.
if (stoigira>=1 or stoigirb>=1 or stoigirc>=1) stoigird=1.
if (stoigira=0 and stoigirb=0 and stoigirc=0) stoigird=2.
if (stoistaa>=1 or stoistab>=1 or stoistac>=1) stoistad=1.
if (stoistaa=0 and stoistab=0 and stoistac=0) stoistad=2.

FREQUENCIES
  VARIABLES=stoiboyd stoigird stoistad
  /ORDER=  ANALYSIS .

***** Calculating derived variable *****.

COMPUTE zstoitot = stoiboya + stoiboyb + stoiboyc + stoigira + stoigirb +  stoigirc .

sort cases by country (a) stratum (a) idpupil (a).

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ18_19_20_21_22_sfenrol_bigshift.sav'
 /RENAME (sfenrol spupboy spupgirl ssess1p ssess2p ssess3p ssess4p ssess5p  ssess6p  = d0 d1 d2 d3 d4 d5 d6 d7 d8 )
 /BY country stratum idpupil.
EXECUTE.

compute sfenrol=d0.
compute spupboy=d1.
compute spupgirl=d2.
compute ssess1p=d3.
compute ssess2p=d4.
compute ssess3p=d5.
compute ssess4p=d6.
compute ssess5p  =d7.
compute ssess6p  =d8.

IF (zstoitot >= 1) zstratio = bigshift / zstoitot .
EXECUTE .

***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ37.sav' /keep country stratum idpupil stoiboya stoiboyb stoiboyc stoiboyd stoigira stoigirb stoigirc
  stoigird stoistaa stoistab stoistac stoistad zstoitot zstratio.

****Table 7.1 Toilet provision*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zstoitot BY  stratum
  /CELLS MEAN COUNT STDDEV  .


