***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating xqacad at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /misdisx= NMISS(xqacad)   
  /numdisx=N (idpupil)
  /optx1dis = PIN(xqacad 1 1)
  /optx2dis = PIN(xqacad 2 2)
  /optx3dis = PIN(xqacad 3 3)
  /optx4dis = PIN(xqacad 4 4)
  /optx5dis = PIN(xqacad 5 5)
.

***** Aggregating xqacad at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /misregx= NMISS(xqacad)   
  /numregx=N (idpupil)
  /optx1reg = PIN(xqacad 1 1)
  /optx2reg = PIN(xqacad 2 2)
  /optx3reg = PIN(xqacad 3 3)
  /optx4reg = PIN(xqacad 4 4)
  /optx5reg = PIN(xqacad 5 5)
.

***** Aggregating xqacad at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /misconx= NMISS(xqacad)  
  /numconx=N (idpupil)
  /optx1con = PIN(xqacad 1 1)
  /optx2con = PIN(xqacad 2 2)
  /optx3con = PIN(xqacad 3 3)
  /optx4con = PIN(xqacad 4 4)
  /optx5con = PIN(xqacad 5 5)
.

***** MATHEMATICS TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating yqacad at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /misdisy= NMISS(yqacad)   
  /numdisy=N (idpupil)
  /opty1dis = PIN(yqacad 1 1)
  /opty2dis = PIN(yqacad 2 2)
  /opty3dis = PIN(yqacad 3 3)
  /opty4dis = PIN(yqacad 4 4)
  /opty5dis = PIN(yqacad 5 5)
.

***** Aggregating yqacad at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /misregy= NMISS(yqacad)   
  /numregy=N (idpupil)
  /opty1reg = PIN(yqacad 1 1)
  /opty2reg = PIN(yqacad 2 2)
  /opty3reg = PIN(yqacad 3 3)
  /opty4reg = PIN(yqacad 4 4)
  /opty5reg = PIN(yqacad 5 5)
.

***** Aggregating yqacad at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /miscony= NMISS(yqacad)  
  /numcony=N (idpupil)
  /opty1con = PIN(yqacad 1 1)
  /opty2con = PIN(yqacad 2 2)
  /opty3con = PIN(yqacad 3 3)
  /opty4con = PIN(yqacad 4 4)
  /opty5con = PIN(yqacad 5 5)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=xqacad yqacad
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

EXECUTE .

***** Finding the Mode at each level *****.

if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx5dis modedisx=5.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx4dis modedisx=4.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx3dis modedisx=3.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx2dis modedisx=2.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx1dis modedisx=1.

if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx5reg moderegx=5.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx4reg moderegx=4.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx3reg moderegx=3.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx2reg moderegx=2.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx1reg moderegx=1.

if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx5con modeconx=5.
if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx4con modeconx=4.
if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx3con modeconx=3.
if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx2con modeconx=2.
if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx1con modeconx=1.

if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty5dis modedisy=5.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty4dis modedisy=4.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty3dis modedisy=3.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty2dis modedisy=2.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty1dis modedisy=1.

if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty5reg moderegy=5.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty4reg moderegy=4.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty3reg moderegy=3.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty2reg moderegy=2.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty1reg moderegy=1.

if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty5con modecony=5.
if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty4con modecony=4.
if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty3con modecony=3.
if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty2con modecony=2.
if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty1con modecony=1.

***** Imputation of xqacad at district level *****.

if (idtr~="" and missing(xqacad) and misdispx~= 0 and misdispx LT .15) xqacad=modedisx.

FREQUENCIES
  VARIABLES=xqacad
  /ORDER  ANALYSIS .

***** Imputation of xqacad at region level *****.

if (idtr~="" and missing(xqacad) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) xqacad=moderegx.

FREQUENCIES
  VARIABLES=xqacad
  /ORDER  ANALYSIS .

***** Imputation of xqacad at country level *****.

if (idtr~="" and missing(xqacad) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) xqacad=modeconx.

FREQUENCIES
  VARIABLES=xqacad
  /ORDER  ANALYSIS .

***** No imputation of xqacad if more than 15% missing at country level *****.

if (idtr~="" and missing(xqacad) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) xqacad=xqacad.
FREQUENCIES
  VARIABLES=xqacad
  /ORDER  ANALYSIS .

***** Imputation of yqacad at district level *****.

if (idtm~="" and missing(yqacad) and misdispy~= 0 and misdispy LT .15) yqacad=modedisy.

FREQUENCIES
  VARIABLES=yqacad
  /ORDER  ANALYSIS .

***** Imputation of yqacad at region level *****.

if (idtm~="" and missing(yqacad) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) yqacad=moderegy.

FREQUENCIES
  VARIABLES=yqacad
  /ORDER  ANALYSIS .

***** Imputation of yqacad at country level *****.

if (idtm~="" and missing(yqacad) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) yqacad=modecony.

FREQUENCIES
  VARIABLES=yqacad
  /ORDER  ANALYSIS .

***** No imputation of yqacad if more than 15% missing at country level *****.

if (idtm~="" and missing(yqacad) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) yqacad=yqacad.
FREQUENCIES
  VARIABLES=yqacad
  /ORDER  ANALYSIS .

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and xqacad~=yqacad ).
VARIABLE LABEL filter_$ 'idtr=idtm and xqacad~=yqacad  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xqacad idtm yqacad
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and xqacad~=yqacad yqacad=xqacad.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ04.sav' /keep country stratum idpupil xqacad yqacad .

****Table 4.3(b) (c) Teacher Academic Qualification*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .


CROSSTABS
  /TABLES=stratum  BY xqacad yqacad 
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .
