***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

if idtr~= "" and missing(xinservc) xinservc=0.
if idtr~= "" and missing(xinservd) xinservd=0.
if idtm~= "" and missing(yinservc) yinservc=0.
if idtm~= "" and missing(yinservd) yinservd=0.

if xinservc=0 and xinservd=0 and missing(xinserve) xinserve=1.
if yinservc=0 and yinservd=0 and missing(yinserve) yinserve=1.

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating xinserve at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /misdisx= NMISS(xinserve)   
  /numdisx=N (idpupil)
  /optx1dis = PIN(xinserve 1 1)
  /optx2dis = PIN(xinserve 2 2)
  /optx3dis = PIN(xinserve 3 3)
  /optx4dis = PIN(xinserve 4 4)
  /optx5dis = PIN(xinserve 5 5)
.

***** Aggregating xinserve at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /misregx= NMISS(xinserve)   
  /numregx=N (idpupil)
  /optx1reg = PIN(xinserve 1 1)
  /optx2reg = PIN(xinserve 2 2)
  /optx3reg = PIN(xinserve 3 3)
  /optx4reg = PIN(xinserve 4 4)
  /optx5reg = PIN(xinserve 5 5)
.

***** Aggregating xinserve at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /misconx= NMISS(xinserve)  
  /numconx=N (idpupil)
  /optx1con = PIN(xinserve 1 1)
  /optx2con = PIN(xinserve 2 2)
  /optx3con = PIN(xinserve 3 3)
  /optx4con = PIN(xinserve 4 4)
  /optx5con = PIN(xinserve 5 5)
.

***** MATHEMATICS TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

if idtr~= "" and missing(xinservc) xinservc=0.
if idtr~= "" and missing(xinservd) xinservd=0.
if idtm~= "" and missing(yinservc) yinservc=0.
if idtm~= "" and missing(yinservd) yinservd=0.

if xinservc=0 and xinservd=0 and missing(xinserve) xinserve=1.
if yinservc=0 and yinservd=0 and missing(yinserve) yinserve=1.

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating yinserve at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /misdisy= NMISS(yinserve)   
  /numdisy=N (idpupil)
  /opty1dis = PIN(yinserve 1 1)
  /opty2dis = PIN(yinserve 2 2)
  /opty3dis = PIN(yinserve 3 3)
  /opty4dis = PIN(yinserve 4 4)
  /opty5dis = PIN(yinserve 5 5)
.

***** Aggregating yinserve at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /misregy= NMISS(yinserve)   
  /numregy=N (idpupil)
  /opty1reg = PIN(yinserve 1 1)
  /opty2reg = PIN(yinserve 2 2)
  /opty3reg = PIN(yinserve 3 3)
  /opty4reg = PIN(yinserve 4 4)
  /opty5reg = PIN(yinserve 5 5)
.

***** Aggregating yinserve at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /miscony= NMISS(yinserve)  
  /numcony=N (idpupil)
  /opty1con = PIN(yinserve 1 1)
  /opty2con = PIN(yinserve 2 2)
  /opty3con = PIN(yinserve 3 3)
  /opty4con = PIN(yinserve 4 4)
  /opty5con = PIN(yinserve 5 5)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

if idtr~= "" and missing(xinservc) xinservc=0.
if idtr~= "" and missing(xinservd) xinservd=0.
if idtm~= "" and missing(yinservc) yinservc=0.
if idtm~= "" and missing(yinservd) yinservd=0.

if xinservc=0 and xinservd=0 and missing(xinserve) xinserve=1.
if yinservc=0 and yinservd=0 and missing(yinserve) yinserve=1.

FREQUENCIES
  VARIABLES=xinserve yinserve
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

EXECUTE .

***** Finding the Mode at each level *****.

if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx5dis modedisx=5.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx4dis modedisx=4.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx3dis modedisx=3.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx2dis modedisx=2.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx1dis modedisx=1.

if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx5reg moderegx=5.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx4reg moderegx=4.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx3reg moderegx=3.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx2reg moderegx=2.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx1reg moderegx=1.

if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx5con modeconx=5.
if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx4con modeconx=4.
if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx3con modeconx=3.
if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx2con modeconx=2.
if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx1con modeconx=1.

if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty5dis modedisy=5.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty4dis modedisy=4.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty3dis modedisy=3.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty2dis modedisy=2.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty1dis modedisy=1.

if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty5reg moderegy=5.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty4reg moderegy=4.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty3reg moderegy=3.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty2reg moderegy=2.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty1reg moderegy=1.

if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty5con modecony=5.
if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty4con modecony=4.
if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty3con modecony=3.
if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty2con modecony=2.
if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty1con modecony=1.

***** Imputation of xinserve at district level *****.

if (idtr~="" and missing(xinserve) and misdispx~= 0 and misdispx LT .15) xinserve=modedisx.

FREQUENCIES
  VARIABLES=xinserve
  /ORDER  ANALYSIS .

***** Imputation of xinserve at region level *****.

if (idtr~="" and missing(xinserve) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) xinserve=moderegx.

FREQUENCIES
  VARIABLES=xinserve
  /ORDER  ANALYSIS .

***** Imputation of xinserve at country level *****.

if (idtr~="" and missing(xinserve) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) xinserve=modeconx.

FREQUENCIES
  VARIABLES=xinserve
  /ORDER  ANALYSIS .

***** No imputation of xinserve if more than 15% missing at country level *****.

if (idtr~="" and missing(xinserve) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) xinserve=xinserve.
FREQUENCIES
  VARIABLES=xinserve
  /ORDER  ANALYSIS .

***** Imputation of yinserve at district level *****.

if (idtm~="" and missing(yinserve) and misdispy~= 0 and misdispy LT .15) yinserve=modedisy.

FREQUENCIES
  VARIABLES=yinserve
  /ORDER  ANALYSIS .

***** Imputation of yinserve at region level *****.

if (idtm~="" and missing(yinserve) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) yinserve=moderegy.

FREQUENCIES
  VARIABLES=yinserve
  /ORDER  ANALYSIS .

***** Imputation of yinserve at country level *****.

if (idtm~="" and missing(yinserve) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) yinserve=modecony.

FREQUENCIES
  VARIABLES=yinserve
  /ORDER  ANALYSIS .

***** No imputation of yinserve if more than 15% missing at country level *****.

if (idtm~="" and missing(yinserve) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) yinserve=yinserve.
FREQUENCIES
  VARIABLES=yinserve
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Consistency *****.

if  idtr~= "" and xinservc=0 and xinservd=0 and xinserve~=1 xinserve=1.
if  idtr~= "" and xinservc=0 and xinservd~=0 and xinserve=1 xinservd=0.
if  idtr~= "" and xinservc=0 and xinservd~=0 and xinserve~=1 xinservc=RND(xinservd/10).

if  idtr~= "" and xinservc~=0 and xinservd=0 and xinserve=1 xinservc=0.
if  idtr~= "" and xinservc~=0 and xinservd=0 and xinserve~=1 xinservd=xinservc*10.
DO IF  idtr~= "" and xinservc~=0 and xinservd~=0 and xinserve=1.
  Recode xinserve (1=sysmis).
END IF.

if  idtm~= "" and yinservc=0 and yinservd=0 and yinserve~=1 yinserve=1.
if  idtm~= "" and yinservc=0 and yinservd~=0 and yinserve=1 yinservd=0.
if  idtm~= "" and yinservc=0 and yinservd~=0 and yinserve~=1 yinservc=RND(yinservd/10).

if  idtm~= "" and yinservc~=0 and yinservd=0 and yinserve=1 yinservc=0.
if  idtm~= "" and yinservc~=0 and yinservd=0 and yinserve~=1 yinservd=yinservc*10.
DO IF  idtm~= "" and yinservc~=0 and yinservd~=0 and yinserve=1.
  Recode yinserve (1=sysmis).
END IF.

if idtr~= "" and idtm~= "" and idtr=idtm and xinservd~=yinservd yinservd=xinservd.
if idtr~= "" and idtm~= "" and idtr=idtm and xinservc~=yinservc yinservc=xinservc.
if idtr~= "" and idtm~= "" and idtr=idtm and xinserve~=yinserve yinserve=xinserve.

***** computing derived variables *****.
RECODE
 xinserve yinserve 
  (1=sysmis)  (2=0)  (3=0)  (4=1) (5=1) INTO   zxinserv zyinserv.
EXECUTE .

***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ07_08_09.sav' /keep country stratum idpupil xinservc yinservc xinservd yinservd xinserve yinserve zxinserv zyinserv .





