******************************************************.
*****TQ11.1*imputation missing to mean%****.
*******************************************************.


***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

compute xsitpu=xsit/xclsize.
execute.

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating xsitpu at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /meandisx= MEAN(xsitpu) /misdisx= NMISS(xsit)
  /numdisx=N (idpupil).

***** Aggregating xsitpu at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /meanregx= MEAN(xsitpu) /misregx= NMISS(xsit)
  /numregx=N (idpupil).

***** Aggregating xsitpu at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /meanconx= MEAN(xsitpu) /misconx= NMISS(xsit)
  /numconx=N (idpupil).


***** MATH TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

compute ysitpu=ysit/yclsize.
execute.

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating ysitpu at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /meandisy= MEAN(ysitpu) /misdisy= NMISS(ysit)
  /numdisy=N (idpupil).

***** Aggregating ysitpu at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /meanregy= MEAN(ysitpu) /misregy= NMISS(ysit)
  /numregy=N (idpupil).

***** Aggregating ysitpu at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /meancony= MEAN(ysitpu) /miscony= NMISS(ysit)
  /numcony=N (idpupil).


***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

compute xsitpu=xsit/xclsize.
compute ysitpu=ysit/yclsize.
execute.

FREQUENCIES
  VARIABLES=xsit ysit xsitpu ysitpu 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.


compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.
EXECUTE .

compute xmsitdis=meandisx*xclsize.
compute xmsitreg=meanregx*xclsize.
compute xmsitcon=meanconx*xclsize.
compute ymsitdis=meandisy*xclsize.
compute ymsitreg=meanregy*xclsize.
compute ymsitcon=meancony*xclsize.
execute.

***** Reading Teachers *****.

if (idtr~= "" and missing(xsit) and misdispx~= 0 and misdispx LT .15) xsit=RND(xmsitdis).
FREQUENCIES
  VARIABLES=xsit
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xsit) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) xsit=RND(xmsitreg).
FREQUENCIES
  VARIABLES=xsit
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xsit) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) xsit=RND(xmsitcon).
FREQUENCIES
  VARIABLES=xsit
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xsit) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) xsit=xsit.
FREQUENCIES
  VARIABLES=xsit
  /ORDER  ANALYSIS .

***** Math Teachers *****.

if (idtm~= "" and missing(ysit) and misdispy~= 0 and misdispy LT .15) ysit=RND(ymsitdis).
FREQUENCIES
  VARIABLES=ysit
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(ysit) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) ysit=RND(ymsitreg).
FREQUENCIES
  VARIABLES=ysit
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(ysit) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) ysit=RND(ymsitcon).
FREQUENCIES
  VARIABLES=ysit
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(ysit) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) ysit=ysit.

FREQUENCIES
  VARIABLES=ysit
  /ORDER  ANALYSIS .


***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and xsit~=ysit).
VARIABLE LABEL filter_$ 'idtr=idtm and xsit~=ysit  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xsit idtm ysit
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and xsit~=ysit ysit=xsit.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.


***** Saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ11.1.sav' /keep country stratum idpupil xsit ysit .

