***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating xoutwork at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /meandisx= MEAN(xoutwork) /misdisx= NMISS(xoutwork)
  /numdisx=N (idpupil).

***** Aggregating xoutwork at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /meanregx= MEAN(xoutwork) /misregx= NMISS(xoutwork)
  /numregx=N (idpupil).

***** Aggregating xoutwork at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /meanconx= MEAN(xoutwork) /misconx= NMISS(xoutwork)
  /numconx=N (idpupil).

***** MATH TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating youtwork at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /meandisy= MEAN(youtwork) /misdisy= NMISS(youtwork)
  /numdisy=N (idpupil).

***** Aggregating youtwork at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /meanregy= MEAN(youtwork) /misregy= NMISS(youtwork)
  /numregy=N (idpupil).

***** Aggregating youtwork at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /meancony= MEAN(youtwork) /miscony= NMISS(youtwork)
  /numcony=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=xoutwork youtwork 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

EXECUTE .

***** Reading Teachers *****.

if (idtr~= "" and missing(xoutwork) and misdispx~= 0 and misdispx LT .15) xoutwork=RND(meandisx).
FREQUENCIES
  VARIABLES=xoutwork
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xoutwork) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) xoutwork=RND(meanregx).
FREQUENCIES
  VARIABLES=xoutwork
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xoutwork) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) xoutwork=RND(meanconx).
FREQUENCIES
  VARIABLES=xoutwork
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xoutwork) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) xoutwork=xoutwork.
FREQUENCIES
  VARIABLES=xoutwork
  /ORDER  ANALYSIS .

***** Math Teachers *****.

if (idtm~= "" and missing(youtwork) and misdispy~= 0 and misdispy LT .15) youtwork=RND(meandisy).
FREQUENCIES
  VARIABLES=youtwork
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(youtwork) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) youtwork=RND(meanregy).
FREQUENCIES
  VARIABLES=youtwork
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(youtwork) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) youtwork=RND(meancony).
FREQUENCIES
  VARIABLES=youtwork
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(youtwork) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) youtwork=youtwork.
FREQUENCIES
  VARIABLES=youtwork
  /ORDER  ANALYSIS .

FREQUENCIES
  VARIABLES=xoutwork youtwork  /FORMAT=NOTABLE
  /ORDER  ANALYSIS .

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and xoutwork~=youtwork).
VARIABLE LABEL filter_$ 'idtr=idtm and xoutwork~=youtwork  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xoutwork idtm youtwork
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and xoutwork~=youtwork youtwork=xoutwork.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.


***** Saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ16.sav' /keep country stratum idpupil xoutwork youtwork .

***** Table8.5 Time spent on lesson preparation *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=xoutwork youtwork BY stratum
  /CELLS MEAN COUNT STDDEV  .


