GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

DO IF idtr="".
   compute xins98="98".
   compute xins99="98".
   compute xins00="98".
   compute xadv98="98".
   compute xadv99="98".
   compute xadv00="98".
END IF.

DO IF idtm="".
   compute yins98="98".
   compute yins99="98".
   compute yins00="98".
   compute yadv98="98".
   compute yadv99="98".
   compute yadv00="98".
END IF.

***** Automatic Cleaning for TQ19 and TQ20 *****.

*BOT	Inspector Yes	Advisor	Yes.
*KEN	Inspector Yes	Advisor	Yes.
*LES	Inspector Yes	Advisor	Yes.
*MAL	Inspector Yes	Advisor	Yes.
*MAU	Inspector Yes	Advisor	No.
*MOZ	Inspector Yes	Advisor	Yes.
*NAM	Inspector Yes	Advisor	Yes.
*SEY	Inspector No	Advisor	Yes.
*SOU	Inspector Yes	Advisor	Yes.
*SWA	Inspector Yes	Advisor	No.
*TAN	Inspector Yes	Advisor	Yes.
*UGA	Inspector Yes	Advisor	Yes.
*ZAM	Inspector Yes	Advisor	Yes.
*ZAN	Inspector Yes	Advisor	Yes.

DO IF (country="BOT" or country="KEN" or country="LES" or country="MAL" or country="MAU" or country="MOZ" or country="NAM" or country="SOU" or country="SWA"
 or country="TAN" or country="UGA" or country="ZAM" or country="ZAN") and idtr~="".
  recode xinsp01 to xinsp12 (missing=1).
  if xins98 ="" or xins98 <="0" or xins98>="88" xins98="00". 
  if xins99 ="" or xins99 <="0" or xins99>="88" xins99="00". 
  if xins00 ="" or xins00 <="0" or xins00>="88" xins00="00". 
END IF.
DO IF (country="BOT" or country="KEN" or country="LES" or country="MAL" or country="MAU" or country="MOZ" or country="NAM" or country="SOU" or country="SWA"
 or country="TAN" or country="UGA" or country="ZAM" or country="ZAN") and idtm~="".
  recode yinsp01 to yinsp12 (missing=1).
  if yins98="" or yins98 <="0" or yins98>="88" yins98="00".
  if yins99="" or yins99 <="0" or yins99>="88" yins99="00".
  if yins00="" or yins00 <="0" or yins00>="88" yins00="00".
END IF.

DO IF country="SEY" and idtr~="".
  recode xinsp01 to xinsp12 (else=sysmis).
  compute xins98="98".
  compute xins99="98".
  compute xins00="98".
END IF.
DO IF country="SEY" and idtm~="".
  recode yinsp01 to yinsp12 (else=sysmis).
  compute yins98="98".
  compute yins99="98".
  compute yins00="98".
END IF.

DO IF (country="BOT" or country="KEN" or country="LES" or country="MAL" or country="MOZ" or country="NAM" or country="SEY" or country="SOU" 
 or country="TAN" or country="UGA" or country="ZAM" or country="ZAN") and idtr~="".
  recode xadv01 to xadv12 (missing=1).
  if xadv98="" or xadv98 <="0" or xadv98>="88" xadv98="00".
  if xadv99="" or xadv99 <="0" or xadv99>="88" xadv99="00".
  if xadv00="" or xadv00 <="0" or xadv00>="88" xadv00="00".
END IF.
DO IF (country="BOT" or country="KEN" or country="LES" or country="MAL" or country="MOZ" or country="NAM" or country="SEY" or country="SOU" 
 or country="TAN" or country="UGA" or country="ZAM" or country="ZAN") and idtm~="".
  recode yadv01 to yadv12 (missing=1).
  if yadv98="" or yadv98 <="0" or yadv98>="88" yadv98="00".
  if yadv99="" or yadv99 <="0" or yadv99>="88" yadv99="00".
  if yadv00="" or yadv00 <="0" or yadv00>="88" yadv00="00".
END IF.

DO IF (country="MAU" or country="SWA") and idtr~="".
  recode xadv01 to xadv12 (else=sysmis).
  compute xadv98="98".
  compute xadv99="98".
  compute xadv00="98".
END IF.
DO IF (country="MAU" or country="SWA") and idtm~="".
  recode yadv01 to yadv12  (else=sysmis).
  compute yadv98="98".
  compute yadv99="98".
  compute yadv00="98".
END IF.

***** Creating numerical variables from TQ19 *****.

COMPUTE zxins98 = NUMBER(xins98,f2) .
COMPUTE zxins99 = NUMBER(xins99,f2) .
COMPUTE zxins00 = NUMBER(xins00,f2) .
COMPUTE zxadv98 = NUMBER(xadv98,f2) .
COMPUTE zxadv99 = NUMBER(xadv99,f2) .
COMPUTE zxadv00 = NUMBER(xadv00,f2) .
COMPUTE zyins98 = NUMBER(yins98,f2) .
COMPUTE zyins99 = NUMBER(yins99,f2) .
COMPUTE zyins00 = NUMBER(yins00,f2) .
COMPUTE zyadv98 = NUMBER(yadv98,f2) .
COMPUTE zyadv99 = NUMBER(yadv99,f2) .
COMPUTE zyadv00 = NUMBER(yadv00,f2) .
recode zxins98 zxins99 zxins00 zxadv98 zxadv99 zxadv00 zyins98 zyins99 zyins00  zyadv98 zyadv99 zyadv00 (98=sysmis). 
EXECUTE .

***** Creating and saving derived variables *****.

DO IF idtr~="" .
   compute zxins8=zxins98+zxadv98.
   compute zxins9=zxins99+zxadv99.
   compute zxins0=zxins00+zxadv00.
   recode zxins8 zxins9 zxins0 (1 thru 4=copy) (5 thru 97=4).
   compute zxinstot=zxins8+zxins9+zxins0.
  RECODE  xinsp01 to xinsp12  (1=0)  (2=1)  INTO  zxinsp01  to zxinsp12.
  RECODE  xadv01 to xadv12  (1=0)  (2=1)  INTO  zxadv01  to zxadv12.
END IF.

DO IF idtm~="" .
   compute zyins8=zyins98+zyadv98.
   compute zyins9=zyins99+zyadv99.
   compute zyins0=zyins00+zyadv00.
   recode zyins8 zyins9 zyins0 (1 thru 4=copy) (5 thru 97=4).
   compute zyinstot=zyins8+zyins9+zyins0.
  RECODE  yinsp01 to yinsp12  (1=0)  (2=1)  INTO  zyinsp01  to zyinsp12.
  RECODE  yadv01 to yadv12  (1=0)  (2=1)  INTO  zyadv01  to zyadv12.
END IF.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ19_20_21.sav' /keep country stratum idpupil
 xins98 xadv98 xins99 xadv99 xins00 xadv00 yins98 yadv98 yins99 yadv99 yins00 yadv00
 zxins98 zxins99 zxins00 zxadv98 zxadv99 zxadv00 zyins98 zyins99 zyins00 zyadv98 zyadv99 zyadv00
 zxins8 zxins9 zxins0 zxinstot zyins8 zyins9 zyins0 zyinstot
xinsp01 to xinsp12 yinsp01 to yinsp12 zxinsp01 to zxinsp12 zyinsp01 to zyinsp12 
xadv01 to xadv12 yadv01 to yadv12 zxadv01 to zxadv12 zyadv01 to zyadv12 .

***** Imputing SQ23 and SQ25.1 using consistency logic *****.

count schmis=ssex to sprobcom (missing).

IF schmis~=169 and   missing(syrinsp) and sinsp01>=1   syrinsp  =6  .
IF schmis~=169 and   missing(syrinsp) and sinsp01=0   syrinsp=1 .
IF schmis~=169 and   missing(sinsp01) and syrinsp<=5 sinsp01=0.
IF schmis~=169 and   missing(sinsp01) and syrinsp>=6 sinsp01=1.

DO IF schmis~=169 and   missing(syrinsp) and missing(sinsp01).
  compute syrinsp=1.
  compute sinsp01=0. 
END IF .

*****Automatic Cleaning using SQ23 & SQ25.1*****.

if ( syrinsp<=5 and sinsp01>=1) sinsp01=0.
if ( syrinsp>=6 and sinsp01=0) sinsp01=1.

***** Imputing the rest of SQ25 *****.

DO IF schmis~=169.
  RECODE  sinsp02 sinsp03 sinsp04 sinsp05 sinsp06 sinsp07 sinsp08  (missing=0)  .
END IF .

***** Imputing SQ24 using TQ19 and SQ25 *****.

DO IF schmis~=169 and missing(sins1998) and  sum(zxinstot,  zyinstot,  sinsp01 to sinsp08)~=0.
  compute sins1998=max(zxinstot,  zyinstot,  sinsp01 to sinsp08).
END IF.

DO IF schmis~=169 and missing(sins1998) and sum(zxinstot,  zyinstot,  sinsp01 to sinsp08)=0.
  compute sins1998=0.
END IF.

*****Automatic Cleaning SQ24 using TQ19 & SQ25 *****.

DO IF sins1998 > sum(zxinstot,  zyinstot,  sinsp01 to sinsp08).
  compute sins1998=sum(zxinstot,  zyinstot,  sinsp01 to sinsp08).
END IF.

DO IF  sins1998< max(zxinstot,  zyinstot,  sinsp01 to sinsp08).
  compute sins1998=max(zxinstot,  zyinstot,  sinsp01 to sinsp08).
END IF.

*****computing derived variable*****.

RECODE  sinsp01 to sinsp08
  (0=0)  (1 thru 97=1)  INTO  zsinsp01 to  zsinsp08.
EXECUTE .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ23_24_25.sav' /keep country stratum idpupil syrinsp sins1998 sinsp01 sinsp02
sinsp03 sinsp04 sinsp05 sinsp06 sinsp07 sinsp08 zsinsp01 zsinsp02 zsinsp03 zsinsp04 zsinsp05 zsinsp06 zsinsp07 zsinsp08  .

***** Table 9.9 Inspector--percentage of teachers agreeing *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zxinsp01 zxinsp02 zxinsp03 zxinsp04 zxinsp05 zxinsp06 zxinsp07 zxinsp08  zxinsp09 zxinsp10 zxinsp11 zxinsp12
zyinsp01 zyinsp02 zyinsp03 zyinsp04 zyinsp05 zyinsp06 zyinsp07 zyinsp08 zyinsp09 zyinsp10 zyinsp11 zyinsp12
BY stratum
  /CELLS MEAN COUNT STDDEV  .

***** Table 9.9 Advicer--percentage of teachers agreeing *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zxadv01 zxadv02 zxadv03 zxadv04 zxadv05 zxadv06 zxadv07 zxadv08  zxadv09 zxadv10 zxadv11 zxadv12
zyadv01 zyadv02 zyadv03 zyadv04 zyadv05 zyadv06 zyadv07 zyadv08 zyadv09 zyadv10 zyadv11 zyadv12
BY stratum
  /CELLS MEAN COUNT STDDEV  .

***** Table 8.7 Type of School Inspections*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zsinsp01 zsinsp02 zsinsp03 zsinsp04 zsinsp05 zsinsp06 zsinsp07 zsinsp08 BY  stratum
  /CELLS MEAN COUNT STDDEV  .

*****Table 11.14 Inspections over 3 years *******.

MEANS
  TABLES=sins1998 BY  stratum
  /CELLS MEAN COUNT STDDEV  .

***** Table 11.15 classroom inspection/advisory *****.

SPLIT FILE
  OFF.

AGGREGATE
  /OUTFILE='H:\MIOKO\SACMEQ2\Main data quality\wcv.sav'
  /BREAK=country stratum school
  /zxinst_1 = MEAN(zxinstot) /zyinst_1 = MEAN(zyinstot).

GET
  FILE='H:\MIOKO\SACMEQ2\Main data quality\wcv.sav'.
EXECUTE .

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zxinst_1  zyinst_1   BY stratum
  /CELLS MEAN COUNT STDDEV
  /STATISTICS ANOVA .


