***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating xsatis11 at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /misdisx= NMISS(xsatis11)   
  /numdisx=N (idpupil)
  /optx1dis = PIN(xsatis11 1 1)
  /optx2dis = PIN(xsatis11 2 2)
  /optx3dis = PIN(xsatis11 3 3)
.

***** Aggregating xsatis11 at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /misregx= NMISS(xsatis11)   
  /numregx=N (idpupil)
  /optx1reg = PIN(xsatis11 1 1)
  /optx2reg = PIN(xsatis11 2 2)
  /optx3reg = PIN(xsatis11 3 3)
.

***** Aggregating xsatis11 at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /misconx= NMISS(xsatis11)  
  /numconx=N (idpupil)
  /optx1con = PIN(xsatis11 1 1)
  /optx2con = PIN(xsatis11 2 2)
  /optx3con = PIN(xsatis11 3 3)
.

***** MATHEMATICS TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating ysatis11 at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /misdisy= NMISS(ysatis11)   
  /numdisy=N (idpupil)
  /opty1dis = PIN(ysatis11 1 1)
  /opty2dis = PIN(ysatis11 2 2)
  /opty3dis = PIN(ysatis11 3 3)
.

***** Aggregating ysatis11 at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /misregy= NMISS(ysatis11)   
  /numregy=N (idpupil)
  /opty1reg = PIN(ysatis11 1 1)
  /opty2reg = PIN(ysatis11 2 2)
  /opty3reg = PIN(ysatis11 3 3)
.

***** Aggregating ysatis11 at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /miscony= NMISS(ysatis11)  
  /numcony=N (idpupil)
  /opty1con = PIN(ysatis11 1 1)
  /opty2con = PIN(ysatis11 2 2)
  /opty3con = PIN(ysatis11 3 3)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=xsatis11 ysatis11
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

EXECUTE .

***** Finding the Mode at each level *****.

if max(optx1dis, optx2dis, optx3dis)=optx3dis modedisx=3.
if max(optx1dis, optx2dis, optx3dis)=optx2dis modedisx=2.
if max(optx1dis, optx2dis, optx3dis)=optx1dis modedisx=1.

if max(optx1reg, optx2reg, optx3reg)=optx3reg moderegx=3.
if max(optx1reg, optx2reg, optx3reg)=optx2reg moderegx=2.
if max(optx1reg, optx2reg, optx3reg)=optx1reg moderegx=1.

if max(optx1con, optx2con, optx3con)=optx3con modeconx=3.
if max(optx1con, optx2con, optx3con)=optx2con modeconx=2.
if max(optx1con, optx2con, optx3con)=optx1con modeconx=1.

if max(opty1dis, opty2dis, opty3dis)=opty3dis modedisy=3.
if max(opty1dis, opty2dis, opty3dis)=opty2dis modedisy=2.
if max(opty1dis, opty2dis, opty3dis)=opty1dis modedisy=1.

if max(opty1reg, opty2reg, opty3reg)=opty3reg moderegy=3.
if max(opty1reg, opty2reg, opty3reg)=opty2reg moderegy=2.
if max(opty1reg, opty2reg, opty3reg)=opty1reg moderegy=1.

if max(opty1con, opty2con, opty3con)=opty3con modecony=3.
if max(opty1con, opty2con, opty3con)=opty2con modecony=2.
if max(opty1con, opty2con, opty3con)=opty1con modecony=1.

***** Imputation of xsatis11 at district level *****.

if (idtr~="" and missing(xsatis11) and misdispx~= 0 and misdispx LT .15) xsatis11=modedisx.

FREQUENCIES
  VARIABLES=xsatis11
  /ORDER  ANALYSIS .

***** Imputation of xsatis11 at region level *****.

if (idtr~="" and missing(xsatis11) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) xsatis11=moderegx.

FREQUENCIES
  VARIABLES=xsatis11
  /ORDER  ANALYSIS .

***** Imputation of xsatis11 at country level *****.

if (idtr~="" and missing(xsatis11) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) xsatis11=modeconx.

FREQUENCIES
  VARIABLES=xsatis11
  /ORDER  ANALYSIS .

***** No imputation of xsatis11 if more than 15% missing at country level *****.

if (idtr~="" and missing(xsatis11) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) xsatis11=xsatis11.
FREQUENCIES
  VARIABLES=xsatis11
  /ORDER  ANALYSIS .

***** Imputation of ysatis11 at district level *****.

if (idtm~="" and missing(ysatis11) and misdispy~= 0 and misdispy LT .15) ysatis11=modedisy.

FREQUENCIES
  VARIABLES=ysatis11
  /ORDER  ANALYSIS .

***** Imputation of ysatis11 at region level *****.

if (idtm~="" and missing(ysatis11) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) ysatis11=moderegy.

FREQUENCIES
  VARIABLES=ysatis11
  /ORDER  ANALYSIS .

***** Imputation of ysatis11 at country level *****.

if (idtm~="" and missing(ysatis11) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) ysatis11=modecony.

FREQUENCIES
  VARIABLES=ysatis11
  /ORDER  ANALYSIS .

***** No imputation of ysatis11 if more than 15% missing at country level *****.

if (idtm~="" and missing(ysatis11) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) ysatis11=ysatis11.
FREQUENCIES
  VARIABLES=ysatis11
  /ORDER  ANALYSIS .

***** Automatic Cleaning based on TQ26 *****.

sort cases by country (a) stratum (a) idpupil (a).

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ26.sav'
 /RENAME (Xsatmost Ysatmost= d0 d1 )
 /BY country stratum idpupil.
EXECUTE.

compute Xsatmost=d0.
compute Ysatmost=d1.

if Xsatmost=11 xsatis11=3.
if Ysatmost=11 ysatis11=3.

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and xsatis11~=ysatis11 ).
VARIABLE LABEL filter_$ 'idtr=idtm and xsatis11~=ysatis11  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xsatis11 idtm ysatis11
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and xsatis11~=ysatis11 ysatis11=xsatis11.

***** Automatic Cleaning using TQ26 (most important) *****.

sort cases by country (a) stratum (a) idpupil (a).

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ26.sav'
 /RENAME (XSATMOST= d0  ) (YSATMOST=d1)
 /BY country stratum idpupil.
EXECUTE.

compute XSATMOST=d0.
compute YSATMOST=d1.

if XSATMOST=11 xsatis11=3.
if YSATMOST=11 ysatis11=3.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ25.11.sav' /keep country stratum idpupil xsatis11 ysatis11 .

