GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=xpos01 to xpos14 ypos01 to ypos14 
  /ORDER  ANALYSIS .

DO IF idtr~="".
  recode xpos01 to xpos14 (1=1) (2=2) (missing=1).
END IF.

DO IF idtm~="".
  recode ypos01 to ypos14 (1=1) (2=2) (missing=1).
END IF.

FREQUENCIES
  VARIABLES=xpos01 to xpos14 ypos01 to ypos14 
  /ORDER  ANALYSIS .

** xpos08 ypos08 have a different meaning between SACMEQ-I and SACMEQ-II so not included ***.
compute zxhpos13 =xpos01 +xpos02+ xpos03+ xpos04+ xpos05+ xpos06+ xpos07+  xpos09+
  xpos10+ xpos11+ xpos12 +xpos13+ xpos14-13.
compute zyhpos13=ypos01 +ypos02+ ypos03+ ypos04+ ypos05+ ypos06+ ypos07+  ypos09+
  ypos10+ ypos11+ ypos12 +ypos13+ ypos14-13.
formats zxhpos13 zyhpos13 (F2.0).

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ27.sav' /keep country stratum idpupil xpos01 to xpos14 ypos01 to ypos14 zxhpos13 zyhpos13.

***** Table 3.1(b) Possessions *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zxhpos13 zyhpos13 BY stratum
  /CELLS MEAN COUNT STDDEV  .
