GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating Xlight at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /misdisx= NMISS(xlight) 
  /numdisx=N (idpupil)
  /optx1dis = PIN(xlight 1 1)
  /optx2dis = PIN(xlight 2 2)
  /optx3dis = PIN(xlight 3 3)
  /optx4dis = PIN(xlight 4 4)
.

***** Aggregating Xlight at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /misregx= NMISS(xlight) 
  /numregx=N (idpupil)
  /optx1reg = PIN(xlight 1 1)
  /optx2reg = PIN(xlight 2 2)
  /optx3reg = PIN(xlight 3 3)
  /optx4reg = PIN(xlight 4 4)
.

***** Aggregating Xlight at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /misconx= NMISS(xlight)
  /numconx=N (idpupil)
  /optx1con = PIN(xlight 1 1)
  /optx2con = PIN(xlight 2 2)
  /optx3con = PIN(xlight 3 3)
  /optx4con = PIN(xlight 4 4)
.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating Ylight at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /misdisy= NMISS(ylight) 
  /numdisy=N (idpupil)
  /opty1dis = PIN(ylight 1 1)
  /opty2dis = PIN(ylight 2 2)
  /opty3dis = PIN(ylight 3 3)
  /opty4dis = PIN(ylight 4 4)
.

***** Aggregating Ylight at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /misregy= NMISS(ylight) 
  /numregy=N (idpupil)
  /opty1reg = PIN(ylight 1 1)
  /opty2reg = PIN(ylight 2 2)
  /opty3reg = PIN(ylight 3 3)
  /opty4reg = PIN(ylight 4 4)
.

***** Aggregating Ylight at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /miscony= NMISS(ylight)
  /numcony=N (idpupil)
  /opty1con = PIN(ylight 1 1)
  /opty2con = PIN(ylight 2 2)
  /opty3con = PIN(ylight 3 3)
  /opty4con = PIN(ylight 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

recode xliving yliving (missing=sysmis).

FREQUENCIES
  VARIABLES=xlight ylight
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

EXECUTE .

***** Finding the Mode at each level *****.

if max(optx1dis, optx2dis, optx3dis, optx4dis)=optx4dis modedisx=4.
if max(optx1dis, optx2dis, optx3dis, optx4dis)=optx3dis modedisx=3.
if max(optx1dis, optx2dis, optx3dis, optx4dis)=optx2dis modedisx=2.
if max(optx1dis, optx2dis, optx3dis, optx4dis)=optx1dis modedisx=1.

if max(optx1reg, optx2reg, optx3reg, optx4reg)=optx4reg moderegx=4.
if max(optx1reg, optx2reg, optx3reg, optx4reg)=optx3reg moderegx=3.
if max(optx1reg, optx2reg, optx3reg, optx4reg)=optx2reg moderegx=2.
if max(optx1reg, optx2reg, optx3reg, optx4reg)=optx1reg moderegx=1.

if max(optx1con, optx2con, optx3con, optx4con)=optx4con modeconx=4.
if max(optx1con, optx2con, optx3con, optx4con)=optx3con modeconx=3.
if max(optx1con, optx2con, optx3con, optx4con)=optx2con modeconx=2.
if max(optx1con, optx2con, optx3con, optx4con)=optx1con modeconx=1.

if max(opty1dis, opty2dis, opty3dis, opty4dis)=opty4dis modedisy=4.
if max(opty1dis, opty2dis, opty3dis, opty4dis)=opty3dis modedisy=3.
if max(opty1dis, opty2dis, opty3dis, opty4dis)=opty2dis modedisy=2.
if max(opty1dis, opty2dis, opty3dis, opty4dis)=opty1dis modedisy=1.

if max(opty1reg, opty2reg, opty3reg, opty4reg)=opty4reg moderegy=4.
if max(opty1reg, opty2reg, opty3reg, opty4reg)=opty3reg moderegy=3.
if max(opty1reg, opty2reg, opty3reg, opty4reg)=opty2reg moderegy=2.
if max(opty1reg, opty2reg, opty3reg, opty4reg)=opty1reg moderegy=1.

if max(opty1con, opty2con, opty3con, opty4con)=opty4con modecony=4.
if max(opty1con, opty2con, opty3con, opty4con)=opty3con modecony=3.
if max(opty1con, opty2con, opty3con, opty4con)=opty2con modecony=2.
if max(opty1con, opty2con, opty3con, opty4con)=opty1con modecony=1.

***** Imputation of Xlight at district level *****.

if (idtr~="" and missing(Xlight) and misdispx~= 0 and misdispx LT .15) Xlight=modedisx.

FREQUENCIES
  VARIABLES=Xlight
  /ORDER  ANALYSIS .

***** Imputation of Xlight at region level *****.

if (idtr~="" and missing(Xlight) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) Xlight=moderegx.

FREQUENCIES
  VARIABLES=Xlight
  /ORDER  ANALYSIS .

***** Imputation of Xlight at country level *****.

if (idtr~="" and missing(Xlight) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) Xlight=modeconx.

FREQUENCIES
  VARIABLES=Xlight
  /ORDER  ANALYSIS .

***** No imputation of Xlight if more than 15% missing at country level *****.

if (idtr~="" and missing(Xlight) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) Xlight=Xlight.

FREQUENCIES
  VARIABLES=Xlight
  /ORDER  ANALYSIS .

***** Imputation of Ylight at district level *****.

if (idtm~="" and missing(Ylight) and misdispy~= 0 and misdispy LT .15) Ylight=modedisy.

FREQUENCIES
  VARIABLES=Ylight
  /ORDER  ANALYSIS .

***** Imputation of Ylight at region level *****.

if (idtm~="" and missing(Ylight) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) Ylight=moderegy.

FREQUENCIES
  VARIABLES=Ylight
  /ORDER  ANALYSIS .

***** Imputation of Ylight at country level *****.

if (idtm~="" and missing(Ylight) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) Ylight=modecony.

FREQUENCIES
  VARIABLES=Ylight
  /ORDER  ANALYSIS .

***** No imputation of Ylight if more than 15% missing at country level *****.

if (idtm~="" and missing(Ylight) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) Ylight=Ylight.

FREQUENCIES
  VARIABLES=Ylight
  /ORDER  ANALYSIS .

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and Xlight~=Ylight ).
VARIABLE LABEL filter_$ 'idtr=idtm and Xlight~=Ylight    (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr Xlight idtm Ylight
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and Xlight~=Ylight Ylight=Xlight.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** calculating derived variable *****.

DO IF idtr~="".
  RECODE  Xlight   (missing=1)  (1,2=2)   (3=3)  (4=4)  INTO  zxlight  .
END IF.

DO IF idtm~="".
  RECODE   Ylight  (missing=1)  (1,2=2)   (3=3)  (4=4)  INTO    zylight .
END IF.

***** saving imputed and derived variables *****.

FREQUENCIES
  VARIABLES=zxlight  zylight
  /ORDER  ANALYSIS .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ29.sav' /keep country stratum idpupil Xlight Ylight zxlight zylight.

***** Table 11.3 *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY zxlight zylight 
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT ROW .
