GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=trepengl trepmath 
  /ORDER  ANALYSIS .

*****imputing missing to 1*****.

DO IF idtr~="" .
  recode trepengl (1=1) (2=2) (missing=1).
END IF.

DO IF idtm~="" .
  recode trepmath (1=1) (2=2) (missing=1).
END IF.

FREQUENCIES
  VARIABLES=trepengl trepmath 
  /ORDER  ANALYSIS .

*****computing derived variable*****.

DO IF idtr~="" .
  RECODE  trepengl     (1=0)  (2=1)  INTO  ztrepeng .
END IF.

DO IF idtm~="" .
  RECODE   trepmath    (1=0)  (2=1)  INTO   ztrepmat.
END IF.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ31_39.sav' /keep country stratum idpupil  trepengl trepmath ztrepeng ztrepmat.

***** Table 11.5 School Report *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=ztrepeng ztrepmat
BY stratum
  /CELLS MEAN COUNT STDDEV  .


