
GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating tmactmos at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(tmactmos)   
  /numdis=N (idpupil)
  /opt1dis = PIN(tmactmos 1 1)
  /opt2dis = PIN(tmactmos 2 2)
  /opt3dis = PIN(tmactmos 3 3)
  /opt4dis = PIN(tmactmos 4 4)
  /opt5dis = PIN(tmactmos 5 5)
  /opt6dis = PIN(tmactmos 6 6)
  /opt7dis = PIN(tmactmos 7 7)
  /opt8dis = PIN(tmactmos 8 8)
.

***** Aggregating tmactmos at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(tmactmos)   
  /numreg=N (idpupil)
  /opt1reg = PIN(tmactmos 1 1)
  /opt2reg = PIN(tmactmos 2 2)
  /opt3reg = PIN(tmactmos 3 3)
  /opt4reg = PIN(tmactmos 4 4)
  /opt5reg = PIN(tmactmos 5 5)
  /opt6reg = PIN(tmactmos 6 6)
  /opt7reg = PIN(tmactmos 7 7)
  /opt8reg = PIN(tmactmos 8 8)
.

***** Aggregating tmactmos at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(tmactmos)  
  /numcon=N (idpupil)
  /opt1con = PIN(tmactmos 1 1)
  /opt2con = PIN(tmactmos 2 2)
  /opt3con = PIN(tmactmos 3 3)
  /opt4con = PIN(tmactmos 4 4)
  /opt5con = PIN(tmactmos 5 5)
  /opt6con = PIN(tmactmos 6 6)
  /opt7con = PIN(tmactmos 7 7)
  /opt8con = PIN(tmactmos 8 8)
.

***** Merging back the aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=tmactmos 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.

EXECUTE .

***** Finding the Mode at each level *****.

if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis, opt8dis)=opt8dis modedis=8.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis, opt8dis)=opt7dis modedis=7.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis, opt8dis)=opt6dis modedis=6.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis, opt8dis)=opt5dis modedis=5.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis, opt8dis)=opt4dis modedis=4.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis, opt8dis)=opt3dis modedis=3.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis, opt8dis)=opt2dis modedis=2.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis, opt8dis)=opt1dis modedis=1.

if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg, opt8reg)=opt8reg modereg=8.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg, opt8reg)=opt7reg modereg=7.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg, opt8reg)=opt6reg modereg=6.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg, opt8reg)=opt5reg modereg=5.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg, opt8reg)=opt4reg modereg=4.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg, opt8reg)=opt3reg modereg=3.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg, opt8reg)=opt2reg modereg=2.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg, opt8reg)=opt1reg modereg=1.

if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con, opt8con)=opt8con modecon=8.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con, opt8con)=opt7con modecon=7.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con, opt8con)=opt6con modecon=6.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con, opt8con)=opt5con modecon=5.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con, opt8con)=opt4con modecon=4.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con, opt8con)=opt3con modecon=3.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con, opt8con)=opt2con modecon=2.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con, opt8con)=opt1con modecon=1.


***** Imputation of tmactmos at district level *****.

if (idtm~="" and missing(tmactmos) and misdisp~= 0 and misdisp LT .15) tmactmos=modedis.

FREQUENCIES
  VARIABLES=tmactmos
  /ORDER  ANALYSIS .

***** Imputation of tmactmos at region level *****.

if (idtm~="" and missing(tmactmos) and misdisp GE .15 and misregp~= 0 and misregp LT .15) tmactmos=modereg.

FREQUENCIES
  VARIABLES=tmactmos
  /ORDER  ANALYSIS .

***** Imputation of tmactmos at country level *****.

if (idtm~="" and missing(tmactmos) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) tmactmos=modecon.

FREQUENCIES
  VARIABLES=tmactmos
  /ORDER  ANALYSIS .

***** No imputation of tmactmos if more than 15% missing at country level *****.

if (idtm~="" and missing(tmactmos) and misdisp GE .15 and misregp GE .15 and misconp GE .15) tmactmos=tmactmos.
FREQUENCIES
  VARIABLES=tmactmos
  /ORDER  ANALYSIS .

***** saving imputed variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ41.sav' /keep country stratum idpupil tmactmos .

****Table 8.1(b) Activity rated as 'most important'*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

FREQUENCIES
  VARIABLES=tmactmos
  /ORDER=  ANALYSIS .
