***** PQ8 *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(plight) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(plight 1 1)
  /opt_2cls = PIN(plight 2 2)
  /opt_3cls = PIN(plight 3 3)
  /opt_4cls = PIN(plight 4 4)
  /opt_5cls = PIN(plight 5 5)
  /opt_6cls = PIN(plight 6 6)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(plight) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(plight 1 1)
  /opt_2sch = PIN(plight 2 2)
  /opt_3sch = PIN(plight 3 3)
  /opt_4sch = PIN(plight 4 4)
  /opt_5sch = PIN(plight 5 5)
  /opt_6sch = PIN(plight 6 6)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(plight) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(plight 1 1)
  /opt_2dis = PIN(plight 2 2)
  /opt_3dis = PIN(plight 3 3)
  /opt_4dis = PIN(plight 4 4)
  /opt_5dis = PIN(plight 5 5)
  /opt_6dis = PIN(plight 6 6)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(plight) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(plight 1 1)
  /opt_2reg = PIN(plight 2 2)
  /opt_3reg = PIN(plight 3 3)
  /opt_4reg = PIN(plight 4 4)
  /opt_5reg = PIN(plight 5 5)
  /opt_6reg = PIN(plight 6 6)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(plight)
  /numcon=N (idpupil)
  /opt_1con = PIN(plight 1 1)
  /opt_2con = PIN(plight 2 2)
  /opt_3con = PIN(plight 3 3)
  /opt_4con = PIN(plight 4 4)
  /opt_5con = PIN(plight 5 5)
  /opt_6con = PIN(plight 6 6)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=plight
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_6cls modecls=6.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_5cls modecls=5.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_6sch modesch=6.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_5sch modesch=5.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_6dis modedis=6.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_5dis modedis=5.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_6reg modereg=6.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_5reg modereg=5.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_6con modecon=6.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_5con modecon=5.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(plight) and misclspc~= 0 and misclspc LT .15) plight =modecls.

FREQUENCIES
  VARIABLES=plight 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(plight) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) plight=modesch.

FREQUENCIES
  VARIABLES=plight
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(plight) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) plight=modedis.

FREQUENCIES
  VARIABLES=plight
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(plight) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) plight=modereg.

FREQUENCIES
  VARIABLES=plight
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(plight) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) plight=modecon.

FREQUENCIES
  VARIABLES=plight
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(plight) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) plight=plight.

FREQUENCIES
  VARIABLES=plight
  /ORDER  ANALYSIS .

***** calculating derived variable *****.

RECODE
  plight
  (1,6=1)  (2,3=2)   (4=3)  (5=4)  INTO  zplight .
EXECUTE .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

FREQUENCIES
  VARIABLES=zplight 
  /ORDER  ANALYSIS .

***** Table 3.4(a) *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY zplight 
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT ROW .

***** PQ13 *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(pfloor) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(pfloor 1 1)
  /opt_2cls = PIN(pfloor 2 2)
  /opt_3cls = PIN(pfloor 3 3)
  /opt_4cls = PIN(pfloor 4 4)
  /opt_5cls = PIN(pfloor 5 5)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(pfloor) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(pfloor 1 1)
  /opt_2sch = PIN(pfloor 2 2)
  /opt_3sch = PIN(pfloor 3 3)
  /opt_4sch = PIN(pfloor 4 4)
  /opt_5sch = PIN(pfloor 5 5)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(pfloor) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(pfloor 1 1)
  /opt_2dis = PIN(pfloor 2 2)
  /opt_3dis = PIN(pfloor 3 3)
  /opt_4dis = PIN(pfloor 4 4)
  /opt_5dis = PIN(pfloor 5 5)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(pfloor) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(pfloor 1 1)
  /opt_2reg = PIN(pfloor 2 2)
  /opt_3reg = PIN(pfloor 3 3)
  /opt_4reg = PIN(pfloor 4 4)
  /opt_5reg = PIN(pfloor 5 5)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(pfloor)
  /numcon=N (idpupil)
  /opt_1con = PIN(pfloor 1 1)
  /opt_2con = PIN(pfloor 2 2)
  /opt_3con = PIN(pfloor 3 3)
  /opt_4con = PIN(pfloor 4 4)
  /opt_5con = PIN(pfloor 5 5)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=pfloor
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_5cls modecls=5.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_5sch modesch=5.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_5dis modedis=5.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_5reg modereg=5.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_5con modecon=5.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(pfloor) and misclspc~= 0 and misclspc LT .15) pfloor =modecls.

FREQUENCIES
  VARIABLES=pfloor 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(pfloor) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) pfloor=modesch.

FREQUENCIES
  VARIABLES=pfloor
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(pfloor) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) pfloor=modedis.

FREQUENCIES
  VARIABLES=pfloor
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(pfloor) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) pfloor=modereg.

FREQUENCIES
  VARIABLES=pfloor
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(pfloor) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) pfloor=modecon.

FREQUENCIES
  VARIABLES=pfloor
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(pfloor) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) pfloor=pfloor.

FREQUENCIES
  VARIABLES=pfloor
  /ORDER  ANALYSIS .

***** computing derived variable *****.

RECODE pfloor (1,2=1) (3=2) (4=3) (5=4) INTO zpfloor.
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

FREQUENCIES
  VARIABLES=zpfloor
  /ORDER  ANALYSIS .

****Table 3.4(b) *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY zpfloor
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT ROW .

***** PQ14 *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(pwall) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(pwall 1 1)
  /opt_2cls = PIN(pwall 2 2)
  /opt_3cls = PIN(pwall 3 3)
  /opt_4cls = PIN(pwall 4 4)
  /opt_5cls = PIN(pwall 5 5)
  /opt_6cls = PIN(pwall 6 6)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(pwall) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(pwall 1 1)
  /opt_2sch = PIN(pwall 2 2)
  /opt_3sch = PIN(pwall 3 3)
  /opt_4sch = PIN(pwall 4 4)
  /opt_5sch = PIN(pwall 5 5)
  /opt_6sch = PIN(pwall 6 6)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(pwall) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(pwall 1 1)
  /opt_2dis = PIN(pwall 2 2)
  /opt_3dis = PIN(pwall 3 3)
  /opt_4dis = PIN(pwall 4 4)
  /opt_5dis = PIN(pwall 5 5)
  /opt_6dis = PIN(pwall 6 6)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(pwall) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(pwall 1 1)
  /opt_2reg = PIN(pwall 2 2)
  /opt_3reg = PIN(pwall 3 3)
  /opt_4reg = PIN(pwall 4 4)
  /opt_5reg = PIN(pwall 5 5)
  /opt_6reg = PIN(pwall 6 6)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(pwall)
  /numcon=N (idpupil)
  /opt_1con = PIN(pwall 1 1)
  /opt_2con = PIN(pwall 2 2)
  /opt_3con = PIN(pwall 3 3)
  /opt_4con = PIN(pwall 4 4)
  /opt_5con = PIN(pwall 5 5)
  /opt_6con = PIN(pwall 6 6)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=pwall
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_6cls modecls=6.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_5cls modecls=5.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_6sch modesch=6.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_5sch modesch=5.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_6dis modedis=6.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_5dis modedis=5.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_6reg modereg=6.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_5reg modereg=5.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_6con modecon=6.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_5con modecon=5.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(pwall) and misclspc~= 0 and misclspc LT .15) pwall=modecls.

FREQUENCIES
  VARIABLES=pwall
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(pwall) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) pwall=modesch.

FREQUENCIES
  VARIABLES=pwall
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(pwall) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) pwall=modedis.

FREQUENCIES
  VARIABLES=pwall
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(pwall) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) pwall=modereg.

FREQUENCIES
  VARIABLES=pwall
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(pwall) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) pwall=modecon.

FREQUENCIES
  VARIABLES=pwall
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(pwall) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) pwall=pwall.

FREQUENCIES
  VARIABLES=pwall
  /ORDER  ANALYSIS .

***** computing derived variable *****.

RECODE pwall (1,2=1) (3=2) (4,5=3) (6=4) INTO zpwall.
EXECUTE.

FREQUENCIES
  VARIABLES=zpwall
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

****Table 3.4(c) *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY zpwall
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT ROW .

***** PQ15 *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(proof) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(proof 1 1)
  /opt_2cls = PIN(proof 2 2)
  /opt_3cls = PIN(proof 3 3)
  /opt_4cls = PIN(proof 4 4)
  /opt_5cls = PIN(proof 5 5)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(proof) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(proof 1 1)
  /opt_2sch = PIN(proof 2 2)
  /opt_3sch = PIN(proof 3 3)
  /opt_4sch = PIN(proof 4 4)
  /opt_5sch = PIN(proof 5 5)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(proof) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(proof 1 1)
  /opt_2dis = PIN(proof 2 2)
  /opt_3dis = PIN(proof 3 3)
  /opt_4dis = PIN(proof 4 4)
  /opt_5dis = PIN(proof 5 5)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(proof) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(proof 1 1)
  /opt_2reg = PIN(proof 2 2)
  /opt_3reg = PIN(proof 3 3)
  /opt_4reg = PIN(proof 4 4)
  /opt_5reg = PIN(proof 5 5)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(proof)
  /numcon=N (idpupil)
  /opt_1con = PIN(proof 1 1)
  /opt_2con = PIN(proof 2 2)
  /opt_3con = PIN(proof 3 3)
  /opt_4con = PIN(proof 4 4)
  /opt_5con = PIN(proof 5 5)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=proof
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_5cls modecls=5.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_5sch modesch=5.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_5dis modedis=5.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_5reg modereg=5.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_5con modecon=5.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(proof) and misclspc~= 0 and misclspc LT .15) proof=modecls.

FREQUENCIES
  VARIABLES=proof
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(proof) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) proof=modesch.

FREQUENCIES
  VARIABLES=proof
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(proof) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) proof=modedis.

FREQUENCIES
  VARIABLES=proof
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(proof) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) proof=modereg.

FREQUENCIES
  VARIABLES=proof
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(proof) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) proof=modecon.

FREQUENCIES
  VARIABLES=proof
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(proof) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) proof=proof.

FREQUENCIES
  VARIABLES=proof
  /ORDER  ANALYSIS .

***** computing derived variable *****.

RECODE proof (1,2=1) (3=2) (4=3) (5=4) INTO zproof.
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

FREQUENCIES
  VARIABLES=zproof
  /ORDER  ANALYSIS .

****Table 3.4(d) *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY zproof
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT ROW .

***** saving variables *****.

compute zphmqual=zplight+zpfloor+zpwall+zproof.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY zphmqual
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT ROW .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ08_13_14_15.sav' /keep country stratum  idpupil 
  plight zplight pfloor zpfloor pwall zpwall proof zproof  zphmqual.