GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

recode plivs1 to plivs8 (missing=0).

FREQUENCIES
  VARIABLES=plivs1 plivs2 plivs3 plivs4 plivs5 plivs6 plivs7 plivs8
 /FORMAT=NOTABLE
  /STATISTICS=MINIMUM MAXIMUM
  /ORDER  ANALYSIS .

RECODE
  plivs1 plivs2 plivs3 plivs4 plivs5 plivs6 plivs7 plivs8
  (0 thru 500=Copy)  (501 thru 9997=500)  INTO  zplivs1 zplivs2 zplivs3 zplivs4 zplivs5 zplivs6 zplivs7 zplivs8.
EXECUTE .

compute zplivs45=0.
if (plivs4 GT 0 or plivs5 GT 0) zplivs45=max(plivs4, plivs5).
formats zplivs45 (f4.0).

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ09.sav' /keep country stratum idpupil plivs1 to plivs8 zplivs1 to  zplivs8 zplivs45.

***** Table 3.5 *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zplivs1 zplivs2 zplivs3 zplivs45  zplivs6 zplivs7 BY  stratum
  /CELLS MEAN COUNT STDDEV  .
