GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls1= NMISS(pmeal1) 
  /miscls2= NMISS(pmeal2) 
  /miscls3= NMISS(pmeal3) 
  /numcls=N (idpupil)
  /opt11cls = PIN(pmeal1 1 1)
  /opt12cls = PIN(pmeal1 2 2)
  /opt13cls = PIN(pmeal1 3 3)
  /opt14cls = PIN(pmeal1 4 4)
  /opt21cls = PIN(pmeal2 1 1)
  /opt22cls = PIN(pmeal2 2 2)
  /opt23cls = PIN(pmeal2 3 3)
  /opt24cls = PIN(pmeal2 4 4)
  /opt31cls = PIN(pmeal3 1 1)
  /opt32cls = PIN(pmeal3 2 2)
  /opt33cls = PIN(pmeal3 3 3)
  /opt34cls = PIN(pmeal3 4 4)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch1= NMISS(pmeal1) 
  /missch2= NMISS(pmeal2) 
  /missch3= NMISS(pmeal3) 
  /numsch=N (idpupil)
  /opt11sch = PIN(pmeal1 1 1)
  /opt12sch = PIN(pmeal1 2 2)
  /opt13sch = PIN(pmeal1 3 3)
  /opt14sch = PIN(pmeal1 4 4)
  /opt21sch = PIN(pmeal2 1 1)
  /opt22sch = PIN(pmeal2 2 2)
  /opt23sch = PIN(pmeal2 3 3)
  /opt24sch = PIN(pmeal2 4 4)
  /opt31sch = PIN(pmeal3 1 1)
  /opt32sch = PIN(pmeal3 2 2)
  /opt33sch = PIN(pmeal3 3 3)
  /opt34sch = PIN(pmeal3 4 4)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis1= NMISS(pmeal1) 
  /misdis2= NMISS(pmeal2) 
  /misdis3= NMISS(pmeal3) 
  /numdis=N (idpupil)
  /opt11dis = PIN(pmeal1 1 1)
  /opt12dis = PIN(pmeal1 2 2)
  /opt13dis = PIN(pmeal1 3 3)
  /opt14dis = PIN(pmeal1 4 4)
  /opt21dis = PIN(pmeal2 1 1)
  /opt22dis = PIN(pmeal2 2 2)
  /opt23dis = PIN(pmeal2 3 3)
  /opt24dis = PIN(pmeal2 4 4)
  /opt31dis = PIN(pmeal3 1 1)
  /opt32dis = PIN(pmeal3 2 2)
  /opt33dis = PIN(pmeal3 3 3)
  /opt34dis = PIN(pmeal3 4 4)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg1= NMISS(pmeal1) 
  /misreg2= NMISS(pmeal2) 
  /misreg3= NMISS(pmeal3) 
  /numreg=N (idpupil)
  /opt11reg = PIN(pmeal1 1 1)
  /opt12reg = PIN(pmeal1 2 2)
  /opt13reg = PIN(pmeal1 3 3)
  /opt14reg = PIN(pmeal1 4 4)
  /opt21reg = PIN(pmeal2 1 1)
  /opt22reg = PIN(pmeal2 2 2)
  /opt23reg = PIN(pmeal2 3 3)
  /opt24reg = PIN(pmeal2 4 4)
  /opt31reg = PIN(pmeal3 1 1)
  /opt32reg = PIN(pmeal3 2 2)
  /opt33reg = PIN(pmeal3 3 3)
  /opt34reg = PIN(pmeal3 4 4)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon1= NMISS(pmeal1) 
  /miscon2= NMISS(pmeal2) 
  /miscon3= NMISS(pmeal3) 
  /numcon=N (idpupil)
  /opt11con = PIN(pmeal1 1 1)
  /opt12con = PIN(pmeal1 2 2)
  /opt13con = PIN(pmeal1 3 3)
  /opt14con = PIN(pmeal1 4 4)
  /opt21con = PIN(pmeal2 1 1)
  /opt22con = PIN(pmeal2 2 2)
  /opt23con = PIN(pmeal2 3 3)
  /opt24con = PIN(pmeal2 4 4)
  /opt31con = PIN(pmeal3 1 1)
  /opt32con = PIN(pmeal3 2 2)
  /opt33con = PIN(pmeal3 3 3)
  /opt34con = PIN(pmeal3 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

if MISSING(pmeal1) and MISSING(pmeal2) and MISSING(pmeal3) mealflag=1.

FREQUENCIES
  VARIABLES=pmeal1 pmeal2 pmeal3
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misclsp1=  miscls1/ numcls.
compute misschp1= missch1/ numsch.
compute misdisp1= misdis1/numdis.
compute misregp1= misreg1/numreg.
compute misconp1= miscon1/numcon.

compute misclsp2=  miscls2/ numcls.
compute misschp2= missch2/ numsch.
compute misdisp2= misdis2/numdis.
compute misregp2= misreg2/numreg.
compute misconp2= miscon2/numcon.

compute misclsp3=  miscls3/ numcls.
compute misschp3= missch3/ numsch.
compute misdisp3= misdis3/numdis.
compute misregp3= misreg3/numreg.
compute misconp3= miscon3/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt11cls, opt12cls, opt13cls, opt14cls)=opt14cls modecls1=4.
if max(opt11cls, opt12cls, opt13cls, opt14cls)=opt13cls modecls1=3.
if max(opt11cls, opt12cls, opt13cls, opt14cls)=opt12cls modecls1=2.
if max(opt11cls, opt12cls, opt13cls, opt14cls)=opt11cls modecls1=1.

if max(opt21cls, opt22cls, opt23cls, opt24cls)=opt24cls modecls2=4.
if max(opt21cls, opt22cls, opt23cls, opt24cls)=opt23cls modecls2=3.
if max(opt21cls, opt22cls, opt23cls, opt24cls)=opt22cls modecls2=2.
if max(opt21cls, opt22cls, opt23cls, opt24cls)=opt21cls modecls2=1.

if max(opt31cls, opt32cls, opt33cls, opt34cls)=opt34cls modecls3=4.
if max(opt31cls, opt32cls, opt33cls, opt34cls)=opt33cls modecls3=3.
if max(opt31cls, opt32cls, opt33cls, opt34cls)=opt32cls modecls3=2.
if max(opt31cls, opt32cls, opt33cls, opt34cls)=opt31cls modecls3=1.

if max(opt11sch, opt12sch, opt13sch, opt14sch)=opt14sch modesch1=4.
if max(opt11sch, opt12sch, opt13sch, opt14sch)=opt13sch modesch1=3.
if max(opt11sch, opt12sch, opt13sch, opt14sch)=opt12sch modesch1=2.
if max(opt11sch, opt12sch, opt13sch, opt14sch)=opt11sch modesch1=1.

if max(opt21sch, opt22sch, opt23sch, opt24sch)=opt24sch modesch2=4.
if max(opt21sch, opt22sch, opt23sch, opt24sch)=opt23sch modesch2=3.
if max(opt21sch, opt22sch, opt23sch, opt24sch)=opt22sch modesch2=2.
if max(opt21sch, opt22sch, opt23sch, opt24sch)=opt21sch modesch2=1.

if max(opt31sch, opt32sch, opt33sch, opt34sch)=opt34sch modesch3=4.
if max(opt31sch, opt32sch, opt33sch, opt34sch)=opt33sch modesch3=3.
if max(opt31sch, opt32sch, opt33sch, opt34sch)=opt32sch modesch3=2.
if max(opt31sch, opt32sch, opt33sch, opt34sch)=opt31sch modesch3=1.

if max(opt11dis, opt12dis, opt13dis, opt14dis)=opt14dis modedis1=4.
if max(opt11dis, opt12dis, opt13dis, opt14dis)=opt13dis modedis1=3.
if max(opt11dis, opt12dis, opt13dis, opt14dis)=opt12dis modedis1=2.
if max(opt11dis, opt12dis, opt13dis, opt14dis)=opt11dis modedis1=1.

if max(opt21dis, opt22dis, opt23dis, opt24dis)=opt24dis modedis2=4.
if max(opt21dis, opt22dis, opt23dis, opt24dis)=opt23dis modedis2=3.
if max(opt21dis, opt22dis, opt23dis, opt24dis)=opt22dis modedis2=2.
if max(opt21dis, opt22dis, opt23dis, opt24dis)=opt21dis modedis2=1.

if max(opt31dis, opt32dis, opt33dis, opt34dis)=opt34dis modedis3=4.
if max(opt31dis, opt32dis, opt33dis, opt34dis)=opt33dis modedis3=3.
if max(opt31dis, opt32dis, opt33dis, opt34dis)=opt32dis modedis3=2.
if max(opt31dis, opt32dis, opt33dis, opt34dis)=opt31dis modedis3=1.

if max(opt11reg, opt12reg, opt13reg, opt14reg)=opt14reg modereg1=4.
if max(opt11reg, opt12reg, opt13reg, opt14reg)=opt13reg modereg1=3.
if max(opt11reg, opt12reg, opt13reg, opt14reg)=opt12reg modereg1=2.
if max(opt11reg, opt12reg, opt13reg, opt14reg)=opt11reg modereg1=1.

if max(opt21reg, opt22reg, opt23reg, opt24reg)=opt24reg modereg2=4.
if max(opt21reg, opt22reg, opt23reg, opt24reg)=opt23reg modereg2=3.
if max(opt21reg, opt22reg, opt23reg, opt24reg)=opt22reg modereg2=2.
if max(opt21reg, opt22reg, opt23reg, opt24reg)=opt21reg modereg2=1.

if max(opt31reg, opt32reg, opt33reg, opt34reg)=opt34reg modereg3=4.
if max(opt31reg, opt32reg, opt33reg, opt34reg)=opt33reg modereg3=3.
if max(opt31reg, opt32reg, opt33reg, opt34reg)=opt32reg modereg3=2.
if max(opt31reg, opt32reg, opt33reg, opt34reg)=opt31reg modereg3=1.

if max(opt11con, opt12con, opt13con, opt14con)=opt14con modecon1=4.
if max(opt11con, opt12con, opt13con, opt14con)=opt13con modecon1=3.
if max(opt11con, opt12con, opt13con, opt14con)=opt12con modecon1=2.
if max(opt11con, opt12con, opt13con, opt14con)=opt11con modecon1=1.

if max(opt21con, opt22con, opt23con, opt24con)=opt24con modecon2=4.
if max(opt21con, opt22con, opt23con, opt24con)=opt23con modecon2=3.
if max(opt21con, opt22con, opt23con, opt24con)=opt22con modecon2=2.
if max(opt21con, opt22con, opt23con, opt24con)=opt21con modecon2=1.

if max(opt31con, opt32con, opt33con, opt34con)=opt34con modecon3=4.
if max(opt31con, opt32con, opt33con, opt34con)=opt33con modecon3=3.
if max(opt31con, opt32con, opt33con, opt34con)=opt32con modecon3=2.
if max(opt31con, opt32con, opt33con, opt34con)=opt31con modecon3=1.

***** Imputation of pmeal1 at class level *****.

if (missing(pmeal1) and misclsp1~= 0 and misclsp1 LT .15) pmeal1 =modecls1.

FREQUENCIES
  VARIABLES=pmeal1 
  /ORDER  ANALYSIS .

***** Imputation of pmeal1 at school level *****.

if (missing(pmeal1) and misclsp1 GE .15 and misschp1~= 0 and misschp1 LT .15) pmeal1=modesch1.

FREQUENCIES
  VARIABLES=pmeal1
  /ORDER  ANALYSIS .

***** Imputation of pmeal1 at district level *****.

if (missing(pmeal1) and misclsp1 GE .15 and misschp1 GE .15 and misdisp1~= 0 and misdisp1 LT .15) pmeal1=modedis1.

FREQUENCIES
  VARIABLES=pmeal1
  /ORDER  ANALYSIS .

***** Imputation of pmeal1 at region level *****.

if (missing(pmeal1) and misclsp1 GE .15 and misschp1 GE .15 and misdisp1 GE .15 and misregp1~= 0 and misregp1 LT .15) pmeal1=modereg1.

FREQUENCIES
  VARIABLES=pmeal1
  /ORDER  ANALYSIS .

***** Imputation of pmeal1 at country level *****.

if (missing(pmeal1) and misclsp1 GE .15 and misschp1 GE .15 and misdisp1 GE .15 and misregp1 GE .15 and misconp1~= 0 and misconp1 LT .15) pmeal1=modecon1.

FREQUENCIES
  VARIABLES=pmeal1
  /ORDER  ANALYSIS .

***** No imputation of pmeal1 if more than 15% missing at country level *****.

if (missing(pmeal1) and misclsp1 GE .15 and misschp1 GE .15 and misdisp1 GE .15 and misregp1 GE .15 and misconp1 GE .15) pmeal1=pmeal1.

FREQUENCIES
  VARIABLES=pmeal1
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Imputation of pmeal2 at class level *****.

if (missing(pmeal2) and misclsp2~= 0 and misclsp2 LT .15) pmeal2 =modecls2.

FREQUENCIES
  VARIABLES=pmeal2 
  /ORDER  ANALYSIS .

***** Imputation of pmeal2 at school level *****.

if (missing(pmeal2) and misclsp2 GE .15 and misschp2~= 0 and misschp2 LT .15) pmeal2=modesch2.

FREQUENCIES
  VARIABLES=pmeal2
  /ORDER  ANALYSIS .

***** Imputation of pmeal2 at district level *****.

if (missing(pmeal2) and misclsp2 GE .15 and misschp2 GE .15 and misdisp2~= 0 and misdisp2 LT .15) pmeal2=modedis2.

FREQUENCIES
  VARIABLES=pmeal2
  /ORDER  ANALYSIS .

***** Imputation of pmeal2 at region level *****.

if (missing(pmeal2) and misclsp2 GE .15 and misschp2 GE .15 and misdisp2 GE .15 and misregp2~= 0 and misregp2 LT .15) pmeal2=modereg2.

FREQUENCIES
  VARIABLES=pmeal2
  /ORDER  ANALYSIS .

***** Imputation of pmeal2 at country level *****.

if (missing(pmeal2) and misclsp2 GE .15 and misschp2 GE .15 and misdisp2 GE .15 and misregp2 GE .15 and misconp2~= 0 and misconp2 LT .15) pmeal2=modecon2.

FREQUENCIES
  VARIABLES=pmeal2
  /ORDER  ANALYSIS .

***** No imputation of pmeal2 if more than 15% missing at country level *****.

if (missing(pmeal2) and misclsp2 GE .15 and misschp2 GE .15 and misdisp2 GE .15 and misregp2 GE .15 and misconp2 GE .15) pmeal2=pmeal2.

FREQUENCIES
  VARIABLES=pmeal2
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Imputation of pmeal3 at class level *****.

if (missing(pmeal3) and misclsp3~= 0 and misclsp3 LT .15) pmeal3 =modecls3.

FREQUENCIES
  VARIABLES=pmeal3 
  /ORDER  ANALYSIS .

***** Imputation of pmeal3 at school level *****.

if (missing(pmeal3) and misclsp3 GE .15 and misschp3~= 0 and misschp3 LT .15) pmeal3=modesch3.

FREQUENCIES
  VARIABLES=pmeal3
  /ORDER  ANALYSIS .

***** Imputation of pmeal3 at district level *****.

if (missing(pmeal3) and misclsp3 GE .15 and misschp3 GE .15 and misdisp3~= 0 and misdisp3 LT .15) pmeal3=modedis3.

FREQUENCIES
  VARIABLES=pmeal3
  /ORDER  ANALYSIS .

***** Imputation of pmeal3 at region level *****.

if (missing(pmeal3) and misclsp3 GE .15 and misschp3 GE .15 and misdisp3 GE .15 and misregp3~= 0 and misregp3 LT .15) pmeal3=modereg3.

FREQUENCIES
  VARIABLES=pmeal3
  /ORDER  ANALYSIS .

***** Imputation of pmeal3 at country level *****.

if (missing(pmeal3) and misclsp3 GE .15 and misschp3 GE .15 and misdisp3 GE .15 and misregp3 GE .15 and misconp3~= 0 and misconp3 LT .15) pmeal3=modecon3.

FREQUENCIES
  VARIABLES=pmeal3
  /ORDER  ANALYSIS .

***** No imputation of pmeal3 if more than 15% missing at country level *****.

if (missing(pmeal3) and misclsp3 GE .15 and misschp3 GE .15 and misdisp3 GE .15 and misregp3 GE .15 and misconp3 GE .15) pmeal3=pmeal3.

FREQUENCIES
  VARIABLES=pmeal3
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** calculating derived variable *****.

compute zpregme=pmeal1+pmeal2+pmeal3.
formats zpregme (f1.0).

***** saving imputed and derived variables *****.

FREQUENCIES
  VARIABLES=zpregme 
  /ORDER  ANALYSIS .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ10.sav' /keep country stratum idpupil pmeal1  pmeal2  pmeal3 zpregme.

***** Table 3.1(b) Means *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zpregme  BY stratum
  /CELLS MEAN COUNT STDDEV  .

USE ALL.
COMPUTE filter_$=(mealflag = 1).
VARIABLE LABEL filter_$ 'mealflag = 1 (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country pmeal1 pmeal2 pmeal3 zpregme
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='Case Summaries'
  /MISSING=VARIABLE
  /CELLS=COUNT .
