GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

if (missing(prepeat)) prepeat=1.

FREQUENCIES
  VARIABLES=prepeat
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** computing derived variable *****.

if missing(prepeat6) prepeat6=1.
if prepeat=1 and prepeat6=2 prepeat=2.

RECODE prepeat (1=0) (2 thru 4=1) INTO zprepeat.
EXECUTE .

FREQUENCIES
  VARIABLES=prepeat prepeat6 zprepeat
  /ORDER  ANALYSIS .

CROSSTABS
  /TABLES=prepeat  BY prepeat6
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ18_19.sav' /keep country stratum idpupil prepeat prepeat6 zprepeat.

***** Table 3.2(b) Repetition *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zprepeat BY stratum
  /CELLS MEAN COUNT STDDEV  .

