*****1. imputation PQ33 missing to "mode"*****.
*****2. imputation PQ34 missing to "mode"*****.
*****3. consistency check bw PQ33&PQ34*****.
*****4. imputation PQ36 missing to "mode"*****.
*****5. imputation PQ37 missing to "mode"*****.
*****6. consistency check bw PQ36&PQ37*****.
*****7.imputation PQ24 missing to "mode"*****.
*****8.imputation PQ25 missing to "mode"*****.
*****9.consistency check bw PQ24 & PQ25 & PQ33 & PQ36*****.
*****10.imputation PQ24 missing to "mode" among 2,3,4*****.
*****11.imputation PQ25 missing to "mode" among 2,3,4*****.


*******************************************************.
*****1. imputation PQ33 missing to "mode"*****.
*******************************************************.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(phmwkr) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(phmwkr 1 1)
  /opt_2cls = PIN(phmwkr 2 2)
  /opt_3cls = PIN(phmwkr 3 3)
  /opt_4cls = PIN(phmwkr 4 4)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(phmwkr) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(phmwkr 1 1)
  /opt_2sch = PIN(phmwkr 2 2)
  /opt_3sch = PIN(phmwkr 3 3)
  /opt_4sch = PIN(phmwkr 4 4)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(phmwkr) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(phmwkr 1 1)
  /opt_2dis = PIN(phmwkr 2 2)
  /opt_3dis = PIN(phmwkr 3 3)
 /opt_4dis = PIN(phmwkr 4 4)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(phmwkr) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(phmwkr 1 1)
  /opt_2reg = PIN(phmwkr 2 2)
  /opt_3reg = PIN(phmwkr 3 3)
  /opt_4reg = PIN(phmwkr 4 4)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(phmwkr)
  /numcon=N (idpupil)
  /opt_1con = PIN(phmwkr 1 1)
  /opt_2con = PIN(phmwkr 2 2)
  /opt_3con = PIN(phmwkr 3 3)
  /opt_4con = PIN(phmwkr 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=phmwkr
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(phmwkr) and misclspc~= 0 and misclspc LT .15) phmwkr=modecls.

FREQUENCIES
  VARIABLES=phmwkr 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(phmwkr) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) phmwkr=modesch.

FREQUENCIES
  VARIABLES=phmwkr 
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(phmwkr) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) phmwkr=modedis.

FREQUENCIES
  VARIABLES=phmwkr 
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(phmwkr) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) phmwkr=modereg.

FREQUENCIES
  VARIABLES=phmwkr 
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(phmwkr) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) phmwkr=modecon.

FREQUENCIES
  VARIABLES=phmwkr 
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(phmwkr) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) phmwkr=phmwkr.
recode phmwkr (missing=sysmis).
FREQUENCIES
  VARIABLES=phmwkr 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' /keep country region district idschool idclass idpupil stratum phmwkr phmwkrc .


******************************************************.
*****2. imputation PQ34 missing to "mode"*****.
******************************************************.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(phmwkrc) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(phmwkrc 1 1)
  /opt_2cls = PIN(phmwkrc 2 2)
  /opt_3cls = PIN(phmwkrc 3 3)
  /opt_4cls = PIN(phmwkrc 4 4)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(phmwkrc) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(phmwkrc 1 1)
  /opt_2sch = PIN(phmwkrc 2 2)
  /opt_3sch = PIN(phmwkrc 3 3)
  /opt_4sch = PIN(phmwkrc 4 4)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(phmwkrc) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(phmwkrc 1 1)
  /opt_2dis = PIN(phmwkrc 2 2)
  /opt_3dis = PIN(phmwkrc 3 3)
 /opt_4dis = PIN(phmwkrc 4 4)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(phmwkrc) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(phmwkrc 1 1)
  /opt_2reg = PIN(phmwkrc 2 2)
  /opt_3reg = PIN(phmwkrc 3 3)
  /opt_4reg = PIN(phmwkrc 4 4)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(phmwkrc)
  /numcon=N (idpupil)
  /opt_1con = PIN(phmwkrc 1 1)
  /opt_2con = PIN(phmwkrc 2 2)
  /opt_3con = PIN(phmwkrc 3 3)
  /opt_4con = PIN(phmwkrc 4 4)
.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' .

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=phmwkrc
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(phmwkrc) and misclspc~= 0 and misclspc LT .15) phmwkrc=modecls.

FREQUENCIES
  VARIABLES=phmwkrc 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(phmwkrc) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) phmwkrc=modesch.

FREQUENCIES
  VARIABLES=phmwkrc 
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(phmwkrc) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) phmwkrc=modedis.

FREQUENCIES
  VARIABLES=phmwkrc 
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(phmwkrc) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) phmwkrc=modereg.

FREQUENCIES
  VARIABLES=phmwkrc 
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(phmwkrc) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) phmwkrc=modecon.

FREQUENCIES
  VARIABLES=phmwkrc 
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(phmwkrc) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) phmwkrc=phmwkrc.
recode phmwkrc (missing=sysmis).
FREQUENCIES
  VARIABLES=phmwkrc 
  /ORDER  ANALYSIS .


sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' keep country stratum idpupil phmwkr phmwkrc .


*****************************************************************.
*****3. consistency check between PQ33 and PQ34*****.
*****************************************************************.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

if phmwkr=1 phmwkrc=1.
if phmwkrc=1 phmwkr=1.
execute.  

***** computing derived variable *****.

RECODE
  phmwkr
  (1thru 3=0)  (4=1)  INTO  zphmwkr .
EXECUTE .

RECODE
  phmwkrc
  (1=sysmis) (2=1) (3=2) (4=3) (5=3) INTO  zphmwkrc .
EXECUTE .


***** saving imputed and derived variables *****.

FREQUENCIES
  VARIABLES=zphmwkr zphmwkrc 
  /ORDER  ANALYSIS .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ33_34.sav' /keep country stratum idpupil phmwkr zphmwkr phmwkrc zphmwkrc  .

***** Table 8.4(a) Get reading homework *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zphmwkr  BY stratum
  /CELLS MEAN COUNT STDDEV  .

***** Table 8.4(b) Reading homework corrected *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY zphmwkrc
  /FORMAT= AVALUE TABLES
  /CELLS= ROW .



******************************************************.
*****4. imputation PQ36 missing to "mode"*****.
******************************************************.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(phmwkm) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(phmwkm 1 1)
  /opt_2cls = PIN(phmwkm 2 2)
  /opt_3cls = PIN(phmwkm 3 3)
  /opt_4cls = PIN(phmwkm 4 4)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(phmwkm) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(phmwkm 1 1)
  /opt_2sch = PIN(phmwkm 2 2)
  /opt_3sch = PIN(phmwkm 3 3)
  /opt_4sch = PIN(phmwkm 4 4)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(phmwkm) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(phmwkm 1 1)
  /opt_2dis = PIN(phmwkm 2 2)
  /opt_3dis = PIN(phmwkm 3 3)
 /opt_4dis = PIN(phmwkm 4 4)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(phmwkm) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(phmwkm 1 1)
  /opt_2reg = PIN(phmwkm 2 2)
  /opt_3reg = PIN(phmwkm 3 3)
  /opt_4reg = PIN(phmwkm 4 4)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(phmwkm)
  /numcon=N (idpupil)
  /opt_1con = PIN(phmwkm 1 1)
  /opt_2con = PIN(phmwkm 2 2)
  /opt_3con = PIN(phmwkm 3 3)
  /opt_4con = PIN(phmwkm 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=phmwkm
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(phmwkm) and misclspc~= 0 and misclspc LT .15) phmwkm=modecls.

FREQUENCIES
  VARIABLES=phmwkm 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(phmwkm) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) phmwkm=modesch.

FREQUENCIES
  VARIABLES=phmwkm 
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(phmwkm) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) phmwkm=modedis.

FREQUENCIES
  VARIABLES=phmwkm 
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(phmwkm) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) phmwkm=modereg.

FREQUENCIES
  VARIABLES=phmwkm 
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(phmwkm) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) phmwkm=modecon.

FREQUENCIES
  VARIABLES=phmwkm 
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(phmwkm) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) phmwkm=phmwkm.
recode phmwkm (missing=sysmis).
FREQUENCIES
  VARIABLES=phmwkm 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' /keep country region district idschool idclass idpupil stratum phmwkm phmwkmc .


******************************************************.
*****5. imputation PQ37 missing to "mode"*****.
******************************************************.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(phmwkmc) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(phmwkmc 1 1)
  /opt_2cls = PIN(phmwkmc 2 2)
  /opt_3cls = PIN(phmwkmc 3 3)
  /opt_4cls = PIN(phmwkmc 4 4)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(phmwkmc) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(phmwkmc 1 1)
  /opt_2sch = PIN(phmwkmc 2 2)
  /opt_3sch = PIN(phmwkmc 3 3)
  /opt_4sch = PIN(phmwkmc 4 4)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(phmwkmc) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(phmwkmc 1 1)
  /opt_2dis = PIN(phmwkmc 2 2)
  /opt_3dis = PIN(phmwkmc 3 3)
 /opt_4dis = PIN(phmwkmc 4 4)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(phmwkmc) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(phmwkmc 1 1)
  /opt_2reg = PIN(phmwkmc 2 2)
  /opt_3reg = PIN(phmwkmc 3 3)
  /opt_4reg = PIN(phmwkmc 4 4)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(phmwkmc)
  /numcon=N (idpupil)
  /opt_1con = PIN(phmwkmc 1 1)
  /opt_2con = PIN(phmwkmc 2 2)
  /opt_3con = PIN(phmwkmc 3 3)
  /opt_4con = PIN(phmwkmc 4 4)
.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' .

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=phmwkmc
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(phmwkmc) and misclspc~= 0 and misclspc LT .15) phmwkmc=modecls.

FREQUENCIES
  VARIABLES=phmwkmc 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(phmwkmc) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) phmwkmc=modesch.

FREQUENCIES
  VARIABLES=phmwkmc 
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(phmwkmc) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) phmwkmc=modedis.

FREQUENCIES
  VARIABLES=phmwkmc 
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(phmwkmc) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) phmwkmc=modereg.

FREQUENCIES
  VARIABLES=phmwkmc 
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(phmwkmc) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) phmwkmc=modecon.

FREQUENCIES
  VARIABLES=phmwkmc 
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(phmwkmc) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) phmwkmc=phmwkmc.
recode phmwkmc (missing=sysmis).
FREQUENCIES
  VARIABLES=phmwkmc 
  /ORDER  ANALYSIS .


sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' keep country stratum idpupil phmwkm phmwkmc .


******************************************************.
*****6. consistency check bw PQ36&PQ37*****.
******************************************************.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

if phmwkm=1 phmwkmc=1.
if phmwkmc=1 phmwkm=1.
execute.  

***** computing derived variable *****.

RECODE
  phmwkm
  (1thru 3=0)  (4=1)  INTO  zphmwkm .
EXECUTE .

RECODE
  phmwkmc
  (1=sysmis) (2=1) (3=2) (4=3) (5=3) INTO  zphmwkmc .
EXECUTE .


***** saving imputed and derived variables *****.

FREQUENCIES
  VARIABLES=zphmwkm zphmwkmc 
  /ORDER  ANALYSIS .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ36_37.sav' /keep country stratum idpupil phmwkm zphmwkm phmwkmc zphmwkmc  .

***** Table 8.4(a) Get math homework *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zphmwkm  BY stratum
  /CELLS MEAN COUNT STDDEV  .

***** Table 8.4(b) Math homework corrected *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY zphmwkmc
  /FORMAT= AVALUE TABLES
  /CELLS= ROW .

Execute.


*****************************************************.
*****7.imputation PQ24 missing to "mode"*****.
*****************************************************.
GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(phmwkdon) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(phmwkdon 1 1)
  /opt_2cls = PIN(phmwkdon 2 2)
  /opt_3cls = PIN(phmwkdon 3 3)
  /opt_4cls = PIN(phmwkdon 4 4)

.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(phmwkdon) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(phmwkdon 1 1)
  /opt_2sch = PIN(phmwkdon 2 2)
  /opt_3sch = PIN(phmwkdon 3 3)
 /opt_4sch = PIN(phmwkdon 4 4)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(phmwkdon) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(phmwkdon 1 1)
  /opt_2dis = PIN(phmwkdon 2 2)
  /opt_3dis = PIN(phmwkdon 3 3)
  /opt_4dis = PIN(phmwkdon 4 4)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(phmwkdon) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(phmwkdon 1 1)
  /opt_2reg = PIN(phmwkdon 2 2)
  /opt_3reg = PIN(phmwkdon 3 3)
  /opt_4reg = PIN(phmwkdon 4 4)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(phmwkdon)
  /numcon=N (idpupil)
  /opt_1con = PIN(phmwkdon 1 1)
  /opt_2con = PIN(phmwkdon 2 2)
  /opt_3con = PIN(phmwkdon 3 3)
  /opt_4con = PIN(phmwkdon 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=phmwkdon
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .


***** Finding the Mode at each level *****.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(phmwkdon) and misclspc~= 0 and misclspc LT .15) phmwkdon=modecls.

FREQUENCIES
  VARIABLES=phmwkdon 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(phmwkdon) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) phmwkdon=modesch.

FREQUENCIES
  VARIABLES=phmwkdon 
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(phmwkdon) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) phmwkdon=modedis.

FREQUENCIES
  VARIABLES=phmwkdon 
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(phmwkdon) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) phmwkdon=modereg.

FREQUENCIES
  VARIABLES=phmwkdon 
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(phmwkdon) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) phmwkdon=modecon.

FREQUENCIES
  VARIABLES=phmwkdon 
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(phmwkdon) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) phmwkdon=phmwkdon.
recode phmwkdon (missing=sysmis).
FREQUENCIES
  VARIABLES=phmwkdon 
  /ORDER  ANALYSIS .

SORT CASES BY
  country (A) stratum (A) idpupil (A) .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' /keep country stratum idpupil phmwkdon.




*****************************************************.
*****8.imputation PQ25 missing to "mode"*****.
*****************************************************.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(phmwkhlp) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(phmwkhlp 1 1)
  /opt_2cls = PIN(phmwkhlp 2 2)
  /opt_3cls = PIN(phmwkhlp 3 3)
  /opt_4cls = PIN(phmwkhlp 4 4)

.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(phmwkhlp) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(phmwkhlp 1 1)
  /opt_2sch = PIN(phmwkhlp 2 2)
  /opt_3sch = PIN(phmwkhlp 3 3)
 /opt_4sch = PIN(phmwkhlp 4 4)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(phmwkhlp) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(phmwkhlp 1 1)
  /opt_2dis = PIN(phmwkhlp 2 2)
  /opt_3dis = PIN(phmwkhlp 3 3)
  /opt_4dis = PIN(phmwkhlp 4 4)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(phmwkhlp) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(phmwkhlp 1 1)
  /opt_2reg = PIN(phmwkhlp 2 2)
  /opt_3reg = PIN(phmwkhlp 3 3)
  /opt_4reg = PIN(phmwkhlp 4 4)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(phmwkhlp)
  /numcon=N (idpupil)
  /opt_1con = PIN(phmwkhlp 1 1)
  /opt_2con = PIN(phmwkhlp 2 2)
  /opt_3con = PIN(phmwkhlp 3 3)
  /opt_4con = PIN(phmwkhlp 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=phmwkhlp
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp1.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp1.sav'.
EXECUTE .

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(phmwkhlp) and misclspc~= 0 and misclspc LT .15) phmwkhlp=modecls.

FREQUENCIES
  VARIABLES=phmwkhlp 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(phmwkhlp) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) phmwkhlp=modesch.

FREQUENCIES
  VARIABLES=phmwkhlp 
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(phmwkhlp) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) phmwkhlp=modedis.

FREQUENCIES
  VARIABLES=phmwkhlp 
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(phmwkhlp) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) phmwkhlp=modereg.

FREQUENCIES
  VARIABLES=phmwkhlp 
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(phmwkhlp) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) phmwkhlp=modecon.

FREQUENCIES
  VARIABLES=phmwkhlp 
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(phmwkhlp) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) phmwkhlp=phmwkhlp.
recode phmwkhlp (missing=sysmis).
FREQUENCIES
  VARIABLES=phmwkhlp 
  /ORDER  ANALYSIS .

SORT CASES BY
  country (A) stratum (A) idpupil (A) .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp1.sav' /keep country stratum idpupil phmwkhlp.


*******************************************************.
*****Merge files*************************************.
******************************************************.
GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp1.sav'
 /BY country stratum idpupil.
EXECUTE.

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ33_34.sav'
 /RENAME (zphmwkr zphmwkrc = d0 d1)
 /BY country stratum idpupil
 /DROP= d0 d1.
EXECUTE.

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ36_37.sav'
 /RENAME (zphmwkm zphmwkmc = d0 d1)
 /BY country stratum idpupil
 /DROP= d0 d1.
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' .

***************************************************************************.
*****9.consistency check bw PQ24 & PQ25 & PQ33 & PQ36*****.
***************************************************************************.
GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

COMPUTE hmworkmr = 1 .
EXECUTE .
IF (phmwkr = 1 & phmwkrc = 1 & phmwkm = 1 & phmwkmc = 1) hmworkmr = 0 .
EXECUTE .

CROSSTABS
  /TABLES=phmwkdon phmwkhlp  BY hmworkmr
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

DO IF (phmwkdon = 1 &  hmworkmr = 1) .
RECODE
  phmwkdon  (1=SYSMIS)  (2=2)  (3=3)  (4=4)  .
END IF .
EXECUTE .

DO IF (phmwkhlp = 1 &  hmworkmr = 1) .
RECODE
  phmwkhlp  (1=SYSMIS)  (2=2)  (3=3)  (4=4)  .
END IF .
EXECUTE .

CROSSTABS
  /TABLES=phmwkdon phmwkhlp  BY hmworkmr
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

CROSSTABS
  /TABLES=phmwkdon  BY phmwkhlp
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

if phmwkdon=1 phmwkhlp=1.
if phmwkhlp=1 phmwkdon=1.
execute.

CROSSTABS
  /TABLES=phmwkdon  BY phmwkhlp
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

FREQUENCIES
  VARIABLES=phmwkdon phmwkhlp
  /ORDER=  ANALYSIS .

SORT CASES BY
  country (A) stratum (A) idpupil (A) .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' .

*********************************************************************.
*****10.imputation PQ24 missing to "mode" among 2,3,4*****.
*********************************************************************.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

SORT CASES BY 
country (A) stratum (A) idpupil (A) .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp1.sav' /keep country stratum idpupil region district idschool idclass.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp1.sav'.
EXECUTE .

SORT CASES BY
  country (A) stratum (A) idpupil (A) .
execute.

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'
 /BY country stratum idpupil.
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' .


***** Aggregating at class level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' .
EXECUTE .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(phmwkdon) 
  /numcls=N (idpupil)
  /opt_2cls = PIN(phmwkdon 2 2)
  /opt_3cls = PIN(phmwkdon 3 3)
  /opt_4cls = PIN(phmwkdon 4 4)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(phmwkdon) 
  /numsch=N (idpupil)
  /opt_2sch = PIN(phmwkdon 2 2)
  /opt_3sch = PIN(phmwkdon 3 3)
 /opt_4sch = PIN(phmwkdon 4 4)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(phmwkdon) 
  /numdis=N (idpupil)
  /opt_2dis = PIN(phmwkdon 2 2)
  /opt_3dis = PIN(phmwkdon 3 3)
  /opt_4dis = PIN(phmwkdon 4 4)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(phmwkdon) 
  /numreg=N (idpupil)
  /opt_2reg = PIN(phmwkdon 2 2)
  /opt_3reg = PIN(phmwkdon 3 3)
  /opt_4reg = PIN(phmwkdon 4 4)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(phmwkdon)
  /numcon=N (idpupil)
  /opt_2con = PIN(phmwkdon 2 2)
  /opt_3con = PIN(phmwkdon 3 3)
  /opt_4con = PIN(phmwkdon 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=phmwkdon
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp1.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp1.sav'.
EXECUTE .

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.
if max(opt_2cls, opt_3cls, opt_4cls)=opt_4cls modecls=4.
if max(opt_2cls, opt_3cls, opt_4cls)=opt_3cls modecls=3.
if max(opt_2cls, opt_3cls, opt_4cls)=opt_2cls modecls=2.

if max(opt_2sch, opt_3sch, opt_4sch)=opt_4sch modesch=4.
if max(opt_2sch, opt_3sch, opt_4sch)=opt_3sch modesch=3.
if max(opt_2sch, opt_3sch, opt_4sch)=opt_2sch modesch=2.

if max(opt_2dis, opt_3dis, opt_4dis)=opt_4dis modedis=4.
if max(opt_2dis, opt_3dis, opt_4dis)=opt_3dis modedis=3.
if max(opt_2dis, opt_3dis, opt_4dis)=opt_2dis modedis=2.

if max(opt_2reg, opt_3reg, opt_4reg)=opt_4reg modereg=4.
if max(opt_2reg, opt_3reg, opt_4reg)=opt_3reg modereg=3.
if max(opt_2reg, opt_3reg, opt_4reg)=opt_2reg modereg=2.

if max(opt_2con, opt_3con, opt_4con)=opt_4con modecon=4.
if max(opt_2con, opt_3con, opt_4con)=opt_3con modecon=3.
if max(opt_2con, opt_3con, opt_4con)=opt_2con modecon=2.

***** Imputation at class level *****.

if (missing(phmwkdon) and misclspc~= 0 and misclspc LT .15) phmwkdon=modecls.

FREQUENCIES
  VARIABLES=phmwkdon 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(phmwkdon) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) phmwkdon=modesch.

FREQUENCIES
  VARIABLES=phmwkdon 
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(phmwkdon) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) phmwkdon=modedis.

FREQUENCIES
  VARIABLES=phmwkdon 
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(phmwkdon) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) phmwkdon=modereg.

FREQUENCIES
  VARIABLES=phmwkdon 
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(phmwkdon) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) phmwkdon=modecon.

FREQUENCIES
  VARIABLES=phmwkdon 
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(phmwkdon) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) phmwkdon=phmwkdon.
recode phmwkdon (missing=sysmis).
FREQUENCIES
  VARIABLES=phmwkdon 
  /ORDER  ANALYSIS .

SORT CASES BY
  country (A) stratum (A) idpupil (A) .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp1.sav' /keep country stratum idpupil phmwkdon.


*********************************************************************.
*****11.imputation PQ25 missing to "mode" among 2,3,4*****.
*********************************************************************.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(phmwkhlp) 
  /numcls=N (idpupil)
  /opt_2cls = PIN(phmwkhlp 2 2)
  /opt_3cls = PIN(phmwkhlp 3 3)
  /opt_4cls = PIN(phmwkhlp 4 4)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(phmwkhlp) 
  /numsch=N (idpupil)
  /opt_2sch = PIN(phmwkhlp 2 2)
  /opt_3sch = PIN(phmwkhlp 3 3)
 /opt_4sch = PIN(phmwkhlp 4 4)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(phmwkhlp) 
  /numdis=N (idpupil)
  /opt_2dis = PIN(phmwkhlp 2 2)
  /opt_3dis = PIN(phmwkhlp 3 3)
  /opt_4dis = PIN(phmwkhlp 4 4)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(phmwkhlp) 
  /numreg=N (idpupil)
  /opt_2reg = PIN(phmwkhlp 2 2)
  /opt_3reg = PIN(phmwkhlp 3 3)
  /opt_4reg = PIN(phmwkhlp 4 4)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(phmwkhlp)
  /numcon=N (idpupil)
  /opt_2con = PIN(phmwkhlp 2 2)
  /opt_3con = PIN(phmwkhlp 3 3)
  /opt_4con = PIN(phmwkhlp 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=phmwkhlp
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp2.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp2.sav'.
EXECUTE .

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.
if max(opt_2cls, opt_3cls, opt_4cls)=opt_4cls modecls=4.
if max(opt_2cls, opt_3cls, opt_4cls)=opt_3cls modecls=3.
if max(opt_2cls, opt_3cls, opt_4cls)=opt_2cls modecls=2.

if max(opt_2sch, opt_3sch, opt_4sch)=opt_4sch modesch=4.
if max(opt_2sch, opt_3sch, opt_4sch)=opt_3sch modesch=3.
if max(opt_2sch, opt_3sch, opt_4sch)=opt_2sch modesch=2.

if max(opt_2dis, opt_3dis, opt_4dis)=opt_4dis modedis=4.
if max(opt_2dis, opt_3dis, opt_4dis)=opt_3dis modedis=3.
if max(opt_2dis, opt_3dis, opt_4dis)=opt_2dis modedis=2.

if max(opt_2reg, opt_3reg, opt_4reg)=opt_4reg modereg=4.
if max(opt_2reg, opt_3reg, opt_4reg)=opt_3reg modereg=3.
if max(opt_2reg, opt_3reg, opt_4reg)=opt_2reg modereg=2.

if max(opt_2con, opt_3con, opt_4con)=opt_4con modecon=4.
if max(opt_2con, opt_3con, opt_4con)=opt_3con modecon=3.
if max(opt_2con, opt_3con, opt_4con)=opt_2con modecon=2.

***** Imputation at class level *****.

if (missing(phmwkhlp) and misclspc~= 0 and misclspc LT .15) phmwkhlp=modecls.

FREQUENCIES
  VARIABLES=phmwkhlp 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(phmwkhlp) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) phmwkhlp=modesch.

FREQUENCIES
  VARIABLES=phmwkhlp 
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(phmwkhlp) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) phmwkhlp=modedis.

FREQUENCIES
  VARIABLES=phmwkhlp 
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(phmwkhlp) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) phmwkhlp=modereg.

FREQUENCIES
  VARIABLES=phmwkhlp 
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(phmwkhlp) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) phmwkhlp=modecon.

FREQUENCIES
  VARIABLES=phmwkhlp 
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(phmwkhlp) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) phmwkhlp=phmwkhlp.
recode phmwkhlp (missing=sysmis).
FREQUENCIES
  VARIABLES=phmwkhlp 
  /ORDER  ANALYSIS .

SORT CASES BY
  country (A) stratum (A) idpupil (A) .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp2.sav' /keep country stratum idpupil phmwkhlp.


*************************************.
**********Merge files***************.
*************************************.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp1.sav'.
EXECUTE .

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp2.sav'
 /BY country stratum idpupil.
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** computing derived variable *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

RECODE
  phmwkdon
  (1=sysmis) (2 thru 3=0)  (4=1)  INTO  zphmwkdn .
EXECUTE .

RECODE
  phmwkhlp
  (1=sysmis) (2 thru 3=0)  (4=1)  INTO  zphmwkhl .
EXECUTE .

***** saving imputed and derived variables *****.

FREQUENCIES
  VARIABLES=zphmwkdn zphmwkhl
  /ORDER=  ANALYSIS .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ24_25.sav' /keep country stratum idpupil phmwkdon zphmwkdn phmwkhlp zphmwkhl  .

***** Table 9.7(a) Ensure homework done & help with the homework *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zphmwkdn  BY stratum
  /CELLS MEAN COUNT STDDEV  .

MEANS
  TABLES=zphmwkhl  BY stratum
  /CELLS MEAN COUNT STDDEV  .

*******************************************************.

