GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

recode pexteng pextmat pextoth (missing=1).

FREQUENCIES
  VARIABLES=pexteng pextmat pextoth 
  /FORMAT=NOTABLE
  /STATISTICS=MINIMUM MAXIMUM
  /ORDER  ANALYSIS .

COMPUTE zpextany = 0 .
IF (pexteng = 2 | pextmat = 2 | pextoth = 2) zpextany = 1 .
EXECUTE .

If (zpextany=1 and pextpay=1) pextpay=4.
If (zpextany=1 and missing(pextpay)) pextpay=4.
If (zpextany=0 and pextpay=2) pextpay=1.
If (zpextany=0 and pextpay=3) pextpay=1.
If (zpextany=0 and pextpay=4) pextpay=1.
If (zpextany=0 and missing(pextpay)) pextpay=1.
execute.

CROSSTABS
  /TABLES=zpextany  BY pextpay
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

******derived variable************.

RECODE
  pextpay
  (1=SYSMIS)  (2=1)  (3=2)  (4=3)  INTO  zpextpay .
EXECUTE .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ32.sav' /keep country stratum idpupil pextpay zpextpay.

***** Table 8.3(b) Extra tuition pay*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY zpextpay
  /FORMAT= AVALUE TABLES
  /CELLS= ROW .

*********************************************.