GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

recode sage (missing=sysmis).

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /meandis= MEAN(sage) /misdis= NMISS(sage)
  /numdis=N (idpupil).

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /meanreg= MEAN(sage) /misreg= NMISS(sage)
  /numreg=N (idpupil).

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /meancon= MEAN(sage) /miscon= NMISS(sage)
  /numcon=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

recode sage (missing=sysmis).

FREQUENCIES
  VARIABLES=sage
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

if (not(missing(spupboy6)) and not(missing(spupgir6)) and missing(sage) and misdispc~= 0 and misdispc LT .15) sage=RND(meandis).
FREQUENCIES
  VARIABLES=sage
  /ORDER  ANALYSIS .

if (not(missing(spupboy6)) and not(missing(spupgir6)) and missing(sage) and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) sage=RND(meanreg).
FREQUENCIES
  VARIABLES=sage
  /ORDER  ANALYSIS .

if (not(missing(spupboy6)) and not(missing(spupgir6)) and missing(sage) and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) sage=RND(meancon).
FREQUENCIES
  VARIABLES=sage
  /ORDER  ANALYSIS .

if (not(missing(spupboy6)) and not(missing(spupgir6)) and missing(sage) and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) sage=sage.
FREQUENCIES
  VARIABLES=sage
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating derived variables *****.

RECODE
  sage
  (Lowest thru 24=22)  (25 thru 29=27)  (30 thru 34=32)  (35
  thru 39=37)  (40 thru 44=42)  (45 thru 49=47)  (50 thru 97=55)  INTO
  zsagelvl.
EXECUTE .

***** Saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ02.sav' /keep country stratum idpupil sage zsagelvl.

***** Table4.1 (B) Mean teacher age by Strata *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zsagelvl BY stratum
  /CELLS MEAN COUNT STDDEV  .
