GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /meandis= MEAN(sexptch) /misdis= NMISS(sexptch)
  /numdis=N (idpupil).

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /meanreg= MEAN(sexptch) /misreg= NMISS(sexptch)
  /numreg=N (idpupil).

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /meancon= MEAN(sexptch) /miscon= NMISS(sexptch)
  /numcon=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FREQUENCIES
  VARIABLES=sexptch
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

if (schmis~=169 and missing(sexptch) and misdispc~= 0 and misdispc LT .15) sexptch=RND(meandis).
FREQUENCIES
  VARIABLES=sexptch
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sexptch) and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) sexptch=RND(meanreg).
FREQUENCIES
  VARIABLES=sexptch
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sexptch) and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) sexptch=RND(meancon).
FREQUENCIES
  VARIABLES=sexptch
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sexptch) and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) sexptch=sexptch.
FREQUENCIES
  VARIABLES=sexptch
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sexptch)) sexptch=1.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Saving imputed variable *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ06.sav' /keep country stratum idpupil sexptch.

***** Table 5.2 Mean School Head's teaching experience by Strata *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=sexptch BY stratum
  /CELLS MEAN COUNT STDDEV  .
