GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /meandis= MEAN(speriods) /misdis= NMISS(speriods)
  /numdis=N (idpupil).

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /meanreg= MEAN(speriods) /misreg= NMISS(speriods)
  /numreg=N (idpupil).

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /meancon= MEAN(speriods) /miscon= NMISS(speriods)
  /numcon=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FREQUENCIES
  VARIABLES=speriods sminutes
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Imputation *****.

if (schmis~=169 and missing(speriods) and misdispc~= 0 and misdispc LT .15) speriods=RND(meandis).
FREQUENCIES
  VARIABLES=speriods 
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(speriods) and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) speriods=RND(meanreg).
FREQUENCIES
  VARIABLES=speriods 
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(speriods) and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) speriods=RND(meancon).
FREQUENCIES
  VARIABLES=speriods 
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(speriods) and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) speriods=speriods.
FREQUENCIES
  VARIABLES=speriods 
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(speriods)) speriods=0.

sort cases by    country (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.


**************************************.
***** Imputation of sminutes *****.
**************************************.
RECODE
  sminutes  (0=SYSMIS)  .
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISm.SAV'
  /BREAK=country region district 
  /meandism= MEAN(sminutes) /misdism= NMISS(sminutes)
  /numdism=N (idpupil).

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGm.SAV'
  /BREAK=country region 
  /meanregm= MEAN(sminutes) /misregm= NMISS(sminutes)
  /numregm=N (idpupil).

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONm.SAV'
  /BREAK=country 
  /meanconm= MEAN(sminutes) /misconm= NMISS(sminutes)
  /numconm=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

recode sminutes (missing=sysmis).

FREQUENCIES
  VARIABLES=sminutes
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISm.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGm.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONm.sav'
 /BY country .
EXECUTE.
sort cases by country (a) region (a) district (a)   .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispm= misdism/numdism.
compute misregpm= misregm/numregm.
compute misconpm= misconm/numconm.
EXECUTE .

if (schmis~=169 and missing(sminutes) and speriods~= 0 and misdispm~= 0 and misdispm LT .15) sminutes=RND(meandism).
FREQUENCIES
  VARIABLES=sminutes
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sminutes) and speriods~= 0 and misdispm GE .15 and misregpm~= 0 and misregpm LT .15) sminutes=RND(meanregm).
FREQUENCIES
  VARIABLES=sminutes
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sminutes) and speriods~= 0 and misdispm GE .15 and misregpm GE .15 and misconpm~= 0 and misconpm LT .15) sminutes=RND(meanconm).
FREQUENCIES
  VARIABLES=sminutes
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sminutes) and speriods~= 0 and misdispm GE .15 and misregpm GE .15 and misconpm GE .15) sminutes=sminutes.
FREQUENCIES
  VARIABLES=sminutes
  /ORDER  ANALYSIS .

DO IF (speriods = 0) .
RECODE
  sminutes  (MISSING=0)  (ELSE=0)  .
END IF .

DO IF (speriods > 0 & sminutes = 0) .
RECODE
  sminutes  (MISSING=SYSMIS)  (ELSE=SYSMIS)  .
END IF .
EXECUTE .

FREQUENCIES
  VARIABLES=sminutes
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Derived Variable *****.

compute zstchmin=speriods*sminutes.
formats zstchmin (f4.0).

***** Saving imputed variable *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ07_08.sav' /keep country stratum idpupil speriods sminutes zstchmin.

***** Table 5.3 Mean School Head's teaching minutes per week by Strata *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zstchmin BY stratum
  /CELLS MEAN COUNT STDDEV  .
