GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /meandis1= MEAN(sfar1) /meandis2= MEAN(sfar2) /meandis3= MEAN(sfar3) /meandis4= MEAN(sfar4) /meandis5= MEAN(sfar5) /meandis6= MEAN(sfar6) 
  /misdis1= NMISS(sfar1) /misdis2= NMISS(sfar2) /misdis3= NMISS(sfar3) /misdis4= NMISS(sfar4) /misdis5= NMISS(sfar5) /misdis6= NMISS(sfar6)
  /numdis=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=sfar1 sfar2 sfar3 sfar4 sfar5 sfar6 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdisc1= misdis1/numdis.
compute misdisc2= misdis2/numdis.
compute misdisc3= misdis3/numdis.
compute misdisc4= misdis4/numdis.
compute misdisc5= misdis5/numdis.
compute misdisc6= misdis6/numdis.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

if (missing(sfar1)) sfar1=RND(meandis1).
FREQUENCIES
  VARIABLES=sfar1
  /ORDER  ANALYSIS .

if (missing(sfar2)) sfar2=RND(meandis2).
FREQUENCIES
  VARIABLES=sfar2
  /ORDER  ANALYSIS .

if (missing(sfar3)) sfar3=RND(meandis3).
FREQUENCIES
  VARIABLES=sfar3
  /ORDER  ANALYSIS .

if (missing(sfar4)) sfar4=RND(meandis4).
FREQUENCIES
  VARIABLES=sfar4
  /ORDER  ANALYSIS .

if (missing(sfar5)) sfar5=RND(meandis5).
FREQUENCIES
  VARIABLES=sfar5
  /ORDER  ANALYSIS .

if (missing(sfar6)) sfar6=RND(meandis6).
FREQUENCIES
  VARIABLES=sfar6
  /ORDER  ANALYSIS .

Recode sfar1 to sfar6 (0=1) (else=copy).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating derived variables *****.

COMPUTE zsdist = (sfar1 + sfar2 + sfar3 + sfar4 + sfar5 )/5 .
EXECUTE .

***** Saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ13.sav' /keep country stratum idpupil sfar1 sfar2 sfar3 sfar4 sfar5 sfar6 zsdist.

***** Table7.2 Distance *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zsdist  BY stratum
  /CELLS MEAN COUNT STDDEV  .
