GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=xsex ysex 
  /ORDER  ANALYSIS .

***** Calculating derived variables *****.

RECODE   xsex ysex  (1=0) (2=1) INTO  zxsex zysex.
EXECUTE .

***** Saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ02.sav' /keep country stratum idpupil xsex ysex zxsex zysex.

***** Table4.1 (B) Mean female % by Strata *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zxsex zysex BY stratum
  /CELLS MEAN COUNT STDDEV  .
