***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating xqprof at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /misdisx= NMISS(xqprof)   
  /numdisx=N (idpupil)
  /optx1dis = PIN(xqprof 1 1)
  /optx2dis = PIN(xqprof 2 2)
  /optx3dis = PIN(xqprof 3 3)
  /optx4dis = PIN(xqprof 4 4)
  /optx5dis = PIN(xqprof 5 5)
  /optx6dis = PIN(xqprof 6 6)
.

***** Aggregating xqprof at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /misregx= NMISS(xqprof)   
  /numregx=N (idpupil)
  /optx1reg = PIN(xqprof 1 1)
  /optx2reg = PIN(xqprof 2 2)
  /optx3reg = PIN(xqprof 3 3)
  /optx4reg = PIN(xqprof 4 4)
  /optx5reg = PIN(xqprof 5 5)
  /optx6reg = PIN(xqprof 6 6)
.

***** Aggregating xqprof at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /misconx= NMISS(xqprof)  
  /numconx=N (idpupil)
  /optx1con = PIN(xqprof 1 1)
  /optx2con = PIN(xqprof 2 2)
  /optx3con = PIN(xqprof 3 3)
  /optx4con = PIN(xqprof 4 4)
  /optx5con = PIN(xqprof 5 5)
  /optx6con = PIN(xqprof 6 6)
.

***** MATHEMATICS TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating yqprof at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /misdisy= NMISS(yqprof)   
  /numdisy=N (idpupil)
  /opty1dis = PIN(yqprof 1 1)
  /opty2dis = PIN(yqprof 2 2)
  /opty3dis = PIN(yqprof 3 3)
  /opty4dis = PIN(yqprof 4 4)
  /opty5dis = PIN(yqprof 5 5)
  /opty6dis = PIN(yqprof 6 6)
.

***** Aggregating yqprof at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /misregy= NMISS(yqprof)   
  /numregy=N (idpupil)
  /opty1reg = PIN(yqprof 1 1)
  /opty2reg = PIN(yqprof 2 2)
  /opty3reg = PIN(yqprof 3 3)
  /opty4reg = PIN(yqprof 4 4)
  /opty5reg = PIN(yqprof 5 5)
  /opty6reg = PIN(yqprof 6 6)
.

***** Aggregating yqprof at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /miscony= NMISS(yqprof)  
  /numcony=N (idpupil)
  /opty1con = PIN(yqprof 1 1)
  /opty2con = PIN(yqprof 2 2)
  /opty3con = PIN(yqprof 3 3)
  /opty4con = PIN(yqprof 4 4)
  /opty5con = PIN(yqprof 5 5)
  /opty6con = PIN(yqprof 6 6)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=xqprof yqprof
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

EXECUTE .

***** Finding the Mode at each level *****.

if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis, optx6dis)=optx6dis modedisx=6.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis, optx6dis)=optx5dis modedisx=5.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis, optx6dis)=optx4dis modedisx=4.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis, optx6dis)=optx3dis modedisx=3.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis, optx6dis)=optx2dis modedisx=2.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis, optx6dis)=optx1dis modedisx=1.

if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg, optx6reg)=optx6reg moderegx=6.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg, optx6reg)=optx5reg moderegx=5.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg, optx6reg)=optx4reg moderegx=4.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg, optx6reg)=optx3reg moderegx=3.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg, optx6reg)=optx2reg moderegx=2.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg, optx6reg)=optx1reg moderegx=1.

if max(optx1con, optx2con, optx3con, optx4con, optx5con, optx6con)=optx6con modeconx=6.
if max(optx1con, optx2con, optx3con, optx4con, optx5con, optx6con)=optx5con modeconx=5.
if max(optx1con, optx2con, optx3con, optx4con, optx5con, optx6con)=optx4con modeconx=4.
if max(optx1con, optx2con, optx3con, optx4con, optx5con, optx6con)=optx3con modeconx=3.
if max(optx1con, optx2con, optx3con, optx4con, optx5con, optx6con)=optx2con modeconx=2.
if max(optx1con, optx2con, optx3con, optx4con, optx5con, optx6con)=optx1con modeconx=1.

if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis, opty6dis)=opty6dis modedisy=6.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis, opty6dis)=opty5dis modedisy=5.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis, opty6dis)=opty4dis modedisy=4.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis, opty6dis)=opty3dis modedisy=3.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis, opty6dis)=opty2dis modedisy=2.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis, opty6dis)=opty1dis modedisy=1.

if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg, opty6reg)=opty6reg moderegy=6.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg, opty6reg)=opty5reg moderegy=5.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg, opty6reg)=opty4reg moderegy=4.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg, opty6reg)=opty3reg moderegy=3.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg, opty6reg)=opty2reg moderegy=2.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg, opty6reg)=opty1reg moderegy=1.

if max(opty1con, opty2con, opty3con, opty4con, opty5con, opty6con)=opty6con modecony=6.
if max(opty1con, opty2con, opty3con, opty4con, opty5con, opty6con)=opty5con modecony=5.
if max(opty1con, opty2con, opty3con, opty4con, opty5con, opty6con)=opty4con modecony=4.
if max(opty1con, opty2con, opty3con, opty4con, opty5con, opty6con)=opty3con modecony=3.
if max(opty1con, opty2con, opty3con, opty4con, opty5con, opty6con)=opty2con modecony=2.
if max(opty1con, opty2con, opty3con, opty4con, opty5con, opty6con)=opty1con modecony=1.

***** Imputation of xqprof at district level *****.

if (idtr~="" and missing(xqprof) and misdispx~= 0 and misdispx LT .15) xqprof=modedisx.

FREQUENCIES
  VARIABLES=xqprof
  /ORDER  ANALYSIS .

***** Imputation of xqprof at region level *****.

if (idtr~="" and missing(xqprof) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) xqprof=moderegx.

FREQUENCIES
  VARIABLES=xqprof
  /ORDER  ANALYSIS .

***** Imputation of xqprof at country level *****.

if (idtr~="" and missing(xqprof) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) xqprof=modeconx.

FREQUENCIES
  VARIABLES=xqprof
  /ORDER  ANALYSIS .

***** No imputation of xqprof if more than 15% missing at country level *****.

if (idtr~="" and missing(xqprof) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) xqprof=xqprof.

FREQUENCIES
  VARIABLES=xqprof
  /ORDER  ANALYSIS .

***** Imputation of yqprof at district level *****.

if (idtm~="" and missing(yqprof) and misdispy~= 0 and misdispy LT .15) yqprof=modedisy.

FREQUENCIES
  VARIABLES=yqprof
  /ORDER  ANALYSIS .

***** Imputation of yqprof at region level *****.

if (idtm~="" and missing(yqprof) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) yqprof=moderegy.

FREQUENCIES
  VARIABLES=yqprof
  /ORDER  ANALYSIS .

***** Imputation of yqprof at country level *****.

if (idtm~="" and missing(yqprof) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) yqprof=modecony.

FREQUENCIES
  VARIABLES=yqprof
  /ORDER  ANALYSIS .

***** No imputation of yqprof if more than 15% missing at country level *****.

if (idtm~="" and missing(yqprof) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) yqprof=yqprof.

FREQUENCIES
  VARIABLES=yqprof
  /ORDER  ANALYSIS .

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and xqprof~=yqprof).
VARIABLE LABEL filter_$ 'idtr=idtm and xqprof~=yqprof  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xqprof idtm yqprof
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and xqprof~=yqprof yqprof=xqprof.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** calculating derived variable *****.

RECODE
  xqprof yqprof 
  (1=0)  (2=0.5)  (3=1)  (4=2)  (5=3)  (6=4)  INTO  zxqprof  zyqprof  .
EXECUTE .

***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ05.sav' /keep country stratum idpupil xqprof yqprof zxqprof  zyqprof   .

****Table 4.2(b) Teacher Training*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zxqprof  zyqprof   BY stratum
  /CELLS MEAN COUNT STDDEV  .
