******************************************************.
*****TQ11.2*imputation missing to mean%****.
*******************************************************.


***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

compute xwritepu=xwrite/xclsize.
execute.

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating xwritepu at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /meandisx= MEAN(xwritepu) /misdisx= NMISS(xwrite)
  /numdisx=N (idpupil).

***** Aggregating xwritepu at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /meanregx= MEAN(xwritepu) /misregx= NMISS(xwrite)
  /numregx=N (idpupil).

***** Aggregating xwritepu at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /meanconx= MEAN(xwritepu) /misconx= NMISS(xwrite)
  /numconx=N (idpupil).


***** MATH TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

compute ywritepu=ywrite/yclsize.
execute.

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating ywritepu at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /meandisy= MEAN(ywritepu) /misdisy= NMISS(ywrite)
  /numdisy=N (idpupil).

***** Aggregating ywritepu at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /meanregy= MEAN(ywritepu) /misregy= NMISS(ywrite)
  /numregy=N (idpupil).

***** Aggregating ywritepu at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /meancony= MEAN(ywritepu) /miscony= NMISS(ywrite)
  /numcony=N (idpupil).


***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

compute xwritepu=xwrite/xclsize.
compute ywritepu=ywrite/yclsize.
execute.

FREQUENCIES
  VARIABLES=xwrite ywrite xwritepu ywritepu 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.


compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.
EXECUTE .

compute xmwrdis=meandisx*xclsize.
compute xmwrreg=meanregx*xclsize.
compute xmwrcon=meanconx*xclsize.
compute ymwrdis=meandisy*xclsize.
compute ymwrreg=meanregy*xclsize.
compute ymwrcon=meancony*xclsize.
execute.

***** Reading Teachers *****.

if (idtr~= "" and missing(xwrite) and misdispx~= 0 and misdispx LT .15) xwrite=RND(xmwrdis).
FREQUENCIES
  VARIABLES=xwrite
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xwrite) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) xwrite=RND(xmwrreg).
FREQUENCIES
  VARIABLES=xwrite
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xwrite) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) xwrite=RND(xmwrcon).
FREQUENCIES
  VARIABLES=xwrite
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xwrite) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) xwrite=xwrite.
FREQUENCIES
  VARIABLES=xwrite
  /ORDER  ANALYSIS .

***** Math Teachers *****.

if (idtm~= "" and missing(ywrite) and misdispy~= 0 and misdispy LT .15) ywrite=RND(ymwrdis).
FREQUENCIES
  VARIABLES=ywrite
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(ywrite) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) ywrite=RND(ymwrreg).
FREQUENCIES
  VARIABLES=ywrite
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(ywrite) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) ywrite=RND(ymwrcon).
FREQUENCIES
  VARIABLES=ywrite
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(ywrite) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) ywrite=ywrite.

FREQUENCIES
  VARIABLES=ywrite
  /ORDER  ANALYSIS .


***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and xwrite~=ywrite).
VARIABLE LABEL filter_$ 'idtr=idtm and xwrite~=ywrite  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xwrite idtm ywrite
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and xwrite~=ywrite ywrite=xwrite.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.


***** Saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ11.2.sav' /keep country stratum idpupil xwrite ywrite .

