GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating Xsatmost at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /misdisx= NMISS(Xsatmost)   
  /numdisx=N (idpupil)
  /optx01di = PIN(Xsatmost 1 1)
  /optx02di = PIN(Xsatmost 2 2)
  /optx03di = PIN(Xsatmost 3 3)
  /optx04di = PIN(Xsatmost 4 4)
  /optx05di = PIN(Xsatmost 5 5)
  /optx06di = PIN(Xsatmost 6 6)
  /optx07di = PIN(Xsatmost 7 7)
  /optx08di = PIN(Xsatmost 8 8)
  /optx09di = PIN(Xsatmost 9 9)
  /optx10di = PIN(Xsatmost 10 10)
  /optx11di = PIN(Xsatmost 11 11)
  /optx12di = PIN(Xsatmost 12 12)
  /optx13di = PIN(Xsatmost 13 13)
  /optx14di = PIN(Xsatmost 14 14)
  /optx15di = PIN(Xsatmost 15 15)
  /optx16di = PIN(Xsatmost 16 16)
.

***** Aggregating Xsatmost at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /misregx= NMISS(Xsatmost)   
  /numregx=N (idpupil)
  /optx01re = PIN(Xsatmost 1 1)
  /optx02re = PIN(Xsatmost 2 2)
  /optx03re = PIN(Xsatmost 3 3)
  /optx04re = PIN(Xsatmost 4 4)
  /optx05re = PIN(Xsatmost 5 5)
  /optx06re = PIN(Xsatmost 6 6)
  /optx07re = PIN(Xsatmost 7 7)
  /optx08re = PIN(Xsatmost 8 8)
  /optx09re = PIN(Xsatmost 9 9)
  /optx10re = PIN(Xsatmost 10 10)
  /optx11re = PIN(Xsatmost 11 11)
  /optx12re = PIN(Xsatmost 12 12)
  /optx13re = PIN(Xsatmost 13 13)
  /optx14re = PIN(Xsatmost 14 14)
  /optx15re = PIN(Xsatmost 15 15)
  /optx16re = PIN(Xsatmost 16 16)
.

***** Aggregating Xsatmost at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /misconx= NMISS(Xsatmost)  
  /numconx=N (idpupil)
  /optx01co = PIN(Xsatmost 1 1)
  /optx02co = PIN(Xsatmost 2 2)
  /optx03co = PIN(Xsatmost 3 3)
  /optx04co = PIN(Xsatmost 4 4)
  /optx05co = PIN(Xsatmost 5 5)
  /optx06co = PIN(Xsatmost 6 6)
  /optx07co = PIN(Xsatmost 7 7)
  /optx08co = PIN(Xsatmost 8 8)
  /optx09co = PIN(Xsatmost 9 9)
  /optx10co = PIN(Xsatmost 10 10)
  /optx11co = PIN(Xsatmost 11 11)
  /optx12co = PIN(Xsatmost 12 12)
  /optx13co = PIN(Xsatmost 13 13)
  /optx14co = PIN(Xsatmost 14 14)
  /optx15co = PIN(Xsatmost 15 15)
  /optx16co = PIN(Xsatmost 16 16)
.

***** MATHEMATICS TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating Ysatmost at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /misdisy= NMISS(Ysatmost)   
  /numdisy=N (idpupil)
  /opty01di = PIN(Ysatmost 1 1)
  /opty02di = PIN(Ysatmost 2 2)
  /opty03di = PIN(Ysatmost 3 3)
  /opty04di = PIN(Ysatmost 4 4)
  /opty05di = PIN(Ysatmost 5 5)
  /opty06di = PIN(Ysatmost 6 6)
  /opty07di = PIN(Ysatmost 7 7)
  /opty08di = PIN(Ysatmost 8 8)
  /opty09di = PIN(Ysatmost 9 9)
  /opty10di = PIN(Ysatmost 10 10)
  /opty11di = PIN(Ysatmost 11 11)
  /opty12di = PIN(Ysatmost 12 12)
  /opty13di = PIN(Ysatmost 13 13)
  /opty14di = PIN(Ysatmost 14 14)
  /opty15di = PIN(Ysatmost 15 15)
  /opty16di = PIN(Ysatmost 16 16)
.

***** Aggregating Ysatmost at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /misregy= NMISS(Ysatmost)   
  /numregy=N (idpupil)
  /opty01re = PIN(Ysatmost 1 1)
  /opty02re = PIN(Ysatmost 2 2)
  /opty03re = PIN(Ysatmost 3 3)
  /opty04re = PIN(Ysatmost 4 4)
  /opty05re = PIN(Ysatmost 5 5)
  /opty06re = PIN(Ysatmost 6 6)
  /opty07re = PIN(Ysatmost 7 7)
  /opty08re = PIN(Ysatmost 8 8)
  /opty09re = PIN(Ysatmost 9 9)
  /opty10re = PIN(Ysatmost 10 10)
  /opty11re = PIN(Ysatmost 11 11)
  /opty12re = PIN(Ysatmost 12 12)
  /opty13re = PIN(Ysatmost 13 13)
  /opty14re = PIN(Ysatmost 14 14)
  /opty15re = PIN(Ysatmost 15 15)
  /opty16re = PIN(Ysatmost 16 16)
.

***** Aggregating Ysatmost at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /miscony= NMISS(Ysatmost)  
  /numcony=N (idpupil)
  /opty01co = PIN(Ysatmost 1 1)
  /opty02co = PIN(Ysatmost 2 2)
  /opty03co = PIN(Ysatmost 3 3)
  /opty04co = PIN(Ysatmost 4 4)
  /opty05co = PIN(Ysatmost 5 5)
  /opty06co = PIN(Ysatmost 6 6)
  /opty07co = PIN(Ysatmost 7 7)
  /opty08co = PIN(Ysatmost 8 8)
  /opty09co = PIN(Ysatmost 9 9)
  /opty10co = PIN(Ysatmost 10 10)
  /opty11co = PIN(Ysatmost 11 11)
  /opty12co = PIN(Ysatmost 12 12)
  /opty13co = PIN(Ysatmost 13 13)
  /opty14co = PIN(Ysatmost 14 14)
  /opty15co = PIN(Ysatmost 15 15)
  /opty16co = PIN(Ysatmost 16 16)
.


***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=xsatmost ysatmost
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

EXECUTE .

***** Finding the Mode at each level *****.

if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx14di modedisx=16.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx14di modedisx=15.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx14di modedisx=14.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx13di modedisx=13.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx12di modedisx=12.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx11di modedisx=11.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx10di modedisx=10.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx09di modedisx=9.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx08di modedisx=8.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx07di modedisx=7.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx06di modedisx=6.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx05di modedisx=5.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx04di modedisx=4.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx03di modedisx=3.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx02di modedisx=2.
if max(optx01di, optx02di, optx03di, optx04di, optx05di, optx06di, optx07di, optx08di, optx09di, optx10di, optx11di, optx12di, optx13di, optx14di, optx15di, optx16di)=optx01di modedisx=1.

if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx14re moderegx=16.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx14re moderegx=15.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx14re moderegx=14.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx13re moderegx=13.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx12re moderegx=12.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx11re moderegx=11.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx10re moderegx=10.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx09re moderegx=9.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx08re moderegx=8.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx07re moderegx=7.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx06re moderegx=6.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx05re moderegx=5.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx04re moderegx=4.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx03re moderegx=3.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx02re moderegx=2.
if max(optx01re, optx02re, optx03re, optx04re, optx05re, optx06re, optx07re, optx08re, optx09re, optx10re, optx11re, optx12re, optx13re, optx14re, optx15re, optx16re)=optx01re moderegx=1.

if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx14co modeconx=16.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx14co modeconx=15.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx14co modeconx=14.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx13co modeconx=13.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx12co modeconx=12.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx11co modeconx=11.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx10co modeconx=10.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx09co modeconx=9.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx08co modeconx=8.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx07co modeconx=7.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx06co modeconx=6.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx05co modeconx=5.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx04co modeconx=4.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx03co modeconx=3.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx02co modeconx=2.
if max(optx01co, optx02co, optx03co, optx04co, optx05co, optx06co, optx07co, optx08co, optx09co, optx10co, optx11co, optx12co, optx13co, optx14co, optx15co, optx16co)=optx01co modeconx=1.

if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty14di modedisy=16.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty14di modedisy=15.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty14di modedisy=14.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty13di modedisy=13.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty12di modedisy=12.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty11di modedisy=11.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty10di modedisy=10.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty09di modedisy=9.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty08di modedisy=8.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty07di modedisy=7.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty06di modedisy=6.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty05di modedisy=5.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty04di modedisy=4.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty03di modedisy=3.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty02di modedisy=2.
if max(opty01di, opty02di, opty03di, opty04di, opty05di, opty06di, opty07di, opty08di, opty09di, opty10di, opty11di, opty12di, opty13di, opty14di, opty15di, opty16di)=opty01di modedisy=1.

if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty14re moderegy=16.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty14re moderegy=15.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty14re moderegy=14.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty13re moderegy=13.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty12re moderegy=12.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty11re moderegy=11.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty10re moderegy=10.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty09re moderegy=9.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty08re moderegy=8.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty07re moderegy=7.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty06re moderegy=6.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty05re moderegy=5.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty04re moderegy=4.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty03re moderegy=3.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty02re moderegy=2.
if max(opty01re, opty02re, opty03re, opty04re, opty05re, opty06re, opty07re, opty08re, opty09re, opty10re, opty11re, opty12re, opty13re, opty14re, opty15re, opty16re)=opty01re moderegy=1.

if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty14co modecony=16.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty14co modecony=15.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty14co modecony=14.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty13co modecony=13.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty12co modecony=12.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty11co modecony=11.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty10co modecony=10.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty09co modecony=9.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty08co modecony=8.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty07co modecony=7.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty06co modecony=6.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty05co modecony=5.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty04co modecony=4.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty03co modecony=3.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty02co modecony=2.
if max(opty01co, opty02co, opty03co, opty04co, opty05co, opty06co, opty07co, opty08co, opty09co, opty10co, opty11co, opty12co, opty13co, opty14co, opty15co, opty16co)=opty01co modecony=1.

***** Imputation of Xsatmost at district level *****.

if (idtr~="" and missing(Xsatmost) and misdispx~= 0 and misdispx LT .15) Xsatmost=modedisx.

FREQUENCIES
  VARIABLES=Xsatmost
  /ORDER  ANALYSIS .

***** Imputation of Xsatmost at region level *****.

if (idtr~="" and missing(Xsatmost) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) Xsatmost=moderegx.

FREQUENCIES
  VARIABLES=Xsatmost
  /ORDER  ANALYSIS .

***** Imputation of Xsatmost at country level *****.

if (idtr~="" and missing(Xsatmost) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) Xsatmost=modeconx.

FREQUENCIES
  VARIABLES=Xsatmost
  /ORDER  ANALYSIS .

***** No imputation of Xsatmost if more than 15% missing at country level *****.

if (idtr~="" and missing(Xsatmost) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) Xsatmost=Xsatmost.
FREQUENCIES
  VARIABLES=Xsatmost
  /ORDER  ANALYSIS .

***** Imputation of Ysatmost at district level *****.

if (idtm~="" and missing(Ysatmost) and misdispy~= 0 and misdispy LT .15) Ysatmost=modedisy.

FREQUENCIES
  VARIABLES=Ysatmost
  /ORDER  ANALYSIS .

***** Imputation of Ysatmost at region level *****.

if (idtm~="" and missing(Ysatmost) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) Ysatmost=moderegy.

FREQUENCIES
  VARIABLES=Ysatmost
  /ORDER  ANALYSIS .

***** Imputation of Ysatmost at country level *****.

if (idtm~="" and missing(Ysatmost) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) Ysatmost=modecony.

FREQUENCIES
  VARIABLES=Ysatmost
  /ORDER  ANALYSIS .

***** No imputation of Ysatmost if more than 15% missing at country level *****.

if (idtm~="" and missing(Ysatmost) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) Ysatmost=Ysatmost.
FREQUENCIES
  VARIABLES= Ysatmost
  /ORDER  ANALYSIS .

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and Xsatmost~=Ysatmost ).
VARIABLE LABEL filter_$ 'idtr=idtm and Xsatmost~=Ysatmost  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr Xsatmost idtm Ysatmost
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and Xsatmost~=Ysatmost Ysatmost=Xsatmost.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ26.sav' /keep country stratum idpupil Xsatmost Ysatmost.

****Table 11.11 Teachers' Most Important Satisfaction Reason*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=Xsatmost Ysatmost BY stratum
  /CELLS MEAN COUNT STDDEV  .

