GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

DO IF idtr~="".
  recode xlivs1 to xlivs8 (missing=0).
END IF.

DO IF idtm~="".
  recode ylivs1 to ylivs8 (missing=0).
END IF.

FREQUENCIES
  VARIABLES=xlivs1 to xlivs8 ylivs1 to ylivs8 
 /FORMAT=NOTABLE
  /STATISTICS=MINIMUM MAXIMUM
  /ORDER  ANALYSIS .

DO IF idtr~="".
 RECODE    xlivs1 xlivs2 xlivs3 xlivs4 xlivs5 xlivs6 xlivs7 xlivs8 (0 thru 500=Copy)  (501 thru 9997=500) INTO zxlivs1 zxlivs2 zxlivs3 zxlivs4 zxlivs5 zxlivs6 zxlivs7 zxlivs8 .
  compute zxlivs45=0.
  if (xlivs4 GT 0 or xlivs5 GT 0) zxlivs45=max(xlivs4, xlivs5).
END IF.

DO IF idtm~="".
 RECODE   ylivs1 ylivs2 ylivs3 ylivs4 ylivs5 ylivs6 ylivs7 ylivs8  (0 thru 500=Copy)  (501 thru 9997=500) INTO zylivs1 zylivs2 zylivs3 zylivs4 zylivs5 zylivs6 zylivs7 zylivs8.
  compute zylivs45=0.
  if (ylivs4 GT 0 or ylivs5 GT 0) zylivs45=max(ylivs4, ylivs5).
END IF.

formats zxlivs45 zylivs45 (f4.0).

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ28.sav' 
  /keep country stratum idpupil xlivs1 to xlivs8 ylivs1 to ylivs8 zxlivs1 to zxlivs8 zylivs1 to zylivs8 zxlivs45 zylivs45.

***** Table 11.2 *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zxlivs1 zxlivs2 zxlivs3 zxlivs45  zxlivs6 zxlivs7 zylivs1 zylivs2 zylivs3 zylivs45  zylivs6 zylivs7 BY  stratum
  /CELLS MEAN COUNT STDDEV  .
