GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=tsigneng tsignmat 
  /ORDER  ANALYSIS .

*****imputing missing to 1*****.

DO IF idtr~="" .
  recode tsigneng (1=1) (2=2) (missing=1).
END IF.

DO IF idtm~="" .
  recode tsignmat (1=1) (2=2) (missing=1).
END IF.

FREQUENCIES
  VARIABLES=tsigneng tsignmat 
  /ORDER  ANALYSIS .

*****computing derived variable*****.

DO IF idtr~="" .
  RECODE  tsigneng    (1=0)  (2=1)  INTO  ztsignen .
END IF.

DO IF idtm~="" .
  RECODE   tsignmat   (1=0)  (2=1)  INTO   ztsignma.
END IF.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ34_42.sav' /keep country stratum idpupil  tsigneng tsignmat ztsignen ztsignma.

***** Table 11.7 School Report *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=ztsignen ztsignma
BY stratum
  /CELLS MEAN COUNT STDDEV  .


