
GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating trgoalmo at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(trgoalmo)   
  /numdis=N (idpupil)
  /opt1dis = PIN(trgoalmo 1 1)
  /opt2dis = PIN(trgoalmo 2 2)
  /opt3dis = PIN(trgoalmo 3 3)
  /opt4dis = PIN(trgoalmo 4 4)
  /opt5dis = PIN(trgoalmo 5 5)
  /opt6dis = PIN(trgoalmo 6 6)
  /opt7dis = PIN(trgoalmo 7 7)
 .

***** Aggregating trgoalmo at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(trgoalmo)   
  /numreg=N (idpupil)
  /opt1reg = PIN(trgoalmo 1 1)
  /opt2reg = PIN(trgoalmo 2 2)
  /opt3reg = PIN(trgoalmo 3 3)
  /opt4reg = PIN(trgoalmo 4 4)
  /opt5reg = PIN(trgoalmo 5 5)
  /opt6reg = PIN(trgoalmo 6 6)
  /opt7reg = PIN(trgoalmo 7 7)
  .

***** Aggregating trgoalmo at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(trgoalmo)  
  /numcon=N (idpupil)
  /opt1con = PIN(trgoalmo 1 1)
  /opt2con = PIN(trgoalmo 2 2)
  /opt3con = PIN(trgoalmo 3 3)
  /opt4con = PIN(trgoalmo 4 4)
  /opt5con = PIN(trgoalmo 5 5)
  /opt6con = PIN(trgoalmo 6 6)
  /opt7con = PIN(trgoalmo 7 7)
.

***** Merging back the aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=trgoalmo 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.

EXECUTE .

***** Finding the Mode at each level *****.

if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt7dis modedis=7.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt6dis modedis=6.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt5dis modedis=5.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt4dis modedis=4.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt3dis modedis=3.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt2dis modedis=2.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt1dis modedis=1.

if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt7reg modereg=7.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt6reg modereg=6.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt5reg modereg=5.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt4reg modereg=4.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt3reg modereg=3.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt2reg modereg=2.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt1reg modereg=1.

if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt7con modecon=7.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt6con modecon=6.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt5con modecon=5.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt4con modecon=4.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt3con modecon=3.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt2con modecon=2.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt1con modecon=1.


***** Imputation of trgoalmo at district level *****.

if (idtr~="" and missing(trgoalmo) and misdisp~= 0 and misdisp LT .15) trgoalmo=modedis.

FREQUENCIES
  VARIABLES=trgoalmo
  /ORDER  ANALYSIS .

***** Imputation of trgoalmo at region level *****.

if (idtr~="" and missing(trgoalmo) and misdisp GE .15 and misregp~= 0 and misregp LT .15) trgoalmo=modereg.

FREQUENCIES
  VARIABLES=trgoalmo
  /ORDER  ANALYSIS .

***** Imputation of trgoalmo at country level *****.

if (idtr~="" and missing(trgoalmo) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) trgoalmo=modecon.

FREQUENCIES
  VARIABLES=trgoalmo
  /ORDER  ANALYSIS .

***** No imputation of trgoalmo if more than 15% missing at country level *****.

if (idtr~="" and missing(trgoalmo) and misdisp GE .15 and misregp GE .15 and misconp GE .15) trgoalmo=trgoalmo.
FREQUENCIES
  VARIABLES=trgoalmo
  /ORDER  ANALYSIS .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ36.sav' /keep country stratum idpupil trgoalmo .

****Table 8.1(a) Goal rated as 'most important'*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

FREQUENCIES
  VARIABLES=trgoalmo
  /ORDER=  ANALYSIS .
