
GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating tmgoalmo at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(tmgoalmo)   
  /numdis=N (idpupil)
  /opt1dis = PIN(tmgoalmo 1 1)
  /opt2dis = PIN(tmgoalmo 2 2)
  /opt3dis = PIN(tmgoalmo 3 3)
  /opt4dis = PIN(tmgoalmo 4 4)
  /opt5dis = PIN(tmgoalmo 5 5)
  /opt6dis = PIN(tmgoalmo 6 6)
  /opt7dis = PIN(tmgoalmo 7 7)
 .

***** Aggregating tmgoalmo at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(tmgoalmo)   
  /numreg=N (idpupil)
  /opt1reg = PIN(tmgoalmo 1 1)
  /opt2reg = PIN(tmgoalmo 2 2)
  /opt3reg = PIN(tmgoalmo 3 3)
  /opt4reg = PIN(tmgoalmo 4 4)
  /opt5reg = PIN(tmgoalmo 5 5)
  /opt6reg = PIN(tmgoalmo 6 6)
  /opt7reg = PIN(tmgoalmo 7 7)
  .

***** Aggregating tmgoalmo at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(tmgoalmo)  
  /numcon=N (idpupil)
  /opt1con = PIN(tmgoalmo 1 1)
  /opt2con = PIN(tmgoalmo 2 2)
  /opt3con = PIN(tmgoalmo 3 3)
  /opt4con = PIN(tmgoalmo 4 4)
  /opt5con = PIN(tmgoalmo 5 5)
  /opt6con = PIN(tmgoalmo 6 6)
  /opt7con = PIN(tmgoalmo 7 7)
.

***** Merging back the aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=tmgoalmo 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.

EXECUTE .

***** Finding the Mode at each level *****.

if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt7dis modedis=7.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt6dis modedis=6.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt5dis modedis=5.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt4dis modedis=4.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt3dis modedis=3.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt2dis modedis=2.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis, opt7dis)=opt1dis modedis=1.

if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt7reg modereg=7.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt6reg modereg=6.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt5reg modereg=5.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt4reg modereg=4.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt3reg modereg=3.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt2reg modereg=2.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg, opt7reg)=opt1reg modereg=1.

if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt7con modecon=7.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt6con modecon=6.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt5con modecon=5.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt4con modecon=4.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt3con modecon=3.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt2con modecon=2.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con, opt7con)=opt1con modecon=1.


***** Imputation of tmgoalmo at district level *****.

if (idtm~="" and missing(tmgoalmo) and misdisp~= 0 and misdisp LT .15) tmgoalmo=modedis.

FREQUENCIES
  VARIABLES=tmgoalmo
  /ORDER  ANALYSIS .

***** Imputation of tmgoalmo at region level *****.

if (idtm~="" and missing(tmgoalmo) and misdisp GE .15 and misregp~= 0 and misregp LT .15) tmgoalmo=modereg.

FREQUENCIES
  VARIABLES=tmgoalmo
  /ORDER  ANALYSIS .

***** Imputation of tmgoalmo at country level *****.

if (idtm~="" and missing(tmgoalmo) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) tmgoalmo=modecon.

FREQUENCIES
  VARIABLES=tmgoalmo
  /ORDER  ANALYSIS .

***** No imputation of tmgoalmo if more than 15% missing at country level *****.

if (idtm~="" and missing(tmgoalmo) and misdisp GE .15 and misregp GE .15 and misconp GE .15) tmgoalmo=tmgoalmo.
FREQUENCIES
  VARIABLES=tmgoalmo
  /ORDER  ANALYSIS .

***** saving imputed variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ44.sav' /keep country stratum idpupil tmgoalmo .

****Table 8.1(b) Goal rated as 'most important'*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

FREQUENCIES
  VARIABLES=tmgoalmo
  /ORDER=  ANALYSIS .
